<?php

namespace App\Classes\Finance;

use App\Models\Main\FinanceYear;
use Illuminate\Support\Facades\DB;

class FinanceYearHelper
{
    function get_next_codes($date, $year, $branch)
    {
        $data['year_ser'] = intval( DB::table('expense_codes')
                ->where('finance_year_id' , $year)
                ->max('year_ser') ) + 1 ;

        $data['month_ser'] = intval( DB::table('expense_codes')
                ->where('finance_year_id' , $year)
                ->max('month_ser') ) + 1 ;

        $data['branch_ser'] = intval( DB::table('expense_codes')
                ->where('branch_id' , $branch)
                ->max('branch_ser') ) + 1 ;

        return $data;
    }

    function can_delete($id)
    {
        $item = FinanceYear::find($id);
        //check if it the only year found
        $years = DB::table('finance_years')->where('finance_year_id' , '!=', $id)->where('finance_year_active' , 1)->count();
        if($years < 1){
            //trans('error.must_be_at_least_one_year')
            return [ false , trans('error.must_be_at_least_one_year') , []] ;
        }
        if(isset($item->daily_journal_id) && $item->daily_journal_id > 0){
            return [ false , trans('error.cannot_delete_closed_year') , []] ;
        }
        if(($this->check_users_default($id)) > 0){
            return [ false ,trans('error.there_are_users_has_this_year'), $this->check_users_default($id)];
        }
        return [true];
    }
    function can_edit($id)
    {
        $item = FinanceYear::find($id);

        if(isset($item->daily_journal_id) && $item->daily_journal_id > 0){
            return [ false , trans('error.cannot_delete_closed_year') , []] ;
        }
        if(($this->check_users_default($id)) > 0){
            return [ false ,trans('error.there_are_users_has_this_year'), $this->check_users_default($id)];
        }
        return [true];
    }
    function generate_daily_journal($id)
    {
        return true;
    }
    function check_conflict_dates($from , $to , $id = null)
    {
        $query = DB::table('finance_years')
        ->where(function ($q) use ($from, $to) {
            $q->whereBetween('from_date', [$from, $to])
              ->orWhereBetween('to_date', [$from, $to])
              ->orWhere(function ($subQuery) use ($from, $to) {
                  $subQuery->where('from_date', '<=', $from)
                           ->where('to_date', '>=', $to);
              });
        });
        if(isset($id) && $id > 0){
            $query->where('finance_year_id' , '!=' , $id);
        }

        $conflict = $query->first();
        if($conflict){
            return false;
        }else{
            return true;
        }

    }
    protected function check_users_default($id)
    {
        $users = DB::table('users')->where('default_year',$id)->selectRaw('id , user_full_name')->get()->toArray();
        if(count($users) > 0){
           $next_year = DB::table('finance_years')->where('finance_year_id' , '>',$id)->selectRaw('finance_year_id as id , name')->orderBy('finance_year_id')->first();
           $prev_year = DB::table('finance_years')->where('finance_year_id' , '<',$id)->selectRaw('finance_year_id as id , name')->orderBy('finance_year_id', 'desc')->first();
           return ['users' => $users , 'next_year' => $next_year , 'prev_year' => $prev_year];
        }else{
            return [];
        }

    }

}
