<?php

namespace App\Classes\Finance;
use App\Models\Finance\AccountTree;
use App\Models\Finance\DailyJournal;
use App\Models\Finance\PaymentVoucher;
use App\Models\Sales\Delegate;

use App\Models\Sales\Customer;


use DB;

class PaymentVoucherHelper
{
	function get_next_codes($date , $year , $branch)
    {
		$data['year_ser'] = intval( DB::table('payment_voucher_m')
	        ->where('finance_year_id' , $year)
	        ->max('year_ser') ) + 1 ;

	    $data['month_ser'] = intval( DB::table('payment_voucher_m')
	        ->where('finance_year_id' , $year)
	        ->where('action_date' , 'like' , date("Y-m" , strtotime($date))."%" )
	        ->max('month_ser') ) + 1 ;

	    $data['branch_ser'] = intval( DB::table('payment_voucher_m')
	        ->where('branch_id' , $branch)
	        ->max('branch_ser') ) + 1 ;

	    return $data;
	}

    function can_edit_or_delete($id)
    {
        return true;
    }

    function generate_journal($m_id){

        $master  = PaymentVoucher::get_payment_voucher_m($m_id, 'en');
        $details = PaymentVoucher::get_payment_voucher_d($m_id, 'en');
        
        if($master->payment_voucher_active == 0 && $master->daily_journal_m_id > 0 ){
            DailyJournal::delete_daily_journal_m($master->daily_journal_m_id);
            return array( true ,  '')  ;
        }
        $items = [];

        $journal_data = array(
            'finance_year_id' => $master->finance_year_id ,
            'branch_id'       => $master->branch_id ,
            'des'             => $master->arabic_description ,
            'journal_date'    => $master->action_date ,
            'daily_type_id'   => $master->daily_type_id ,
            'document_id'     => $m_id ,
            'auto_generated'  => 1 ,
            'journal_active'  => 1 ,
            'confirmed'       => 1
        );

        if ($master->daily_journal_m_id > 0){
            $journal_data['daily_journal_id'] = $master->daily_journal_m_id;
        }


        $items[] = array(
            'account_tree_id'   => $master->treasury_account_tree_id ,
            'cost_center_id'    => 0 ,
            'debit'             => 0 ,
            'credit'            => $master->total_amount ,
            'description'       => $master->arabic_description
        );


        foreach ($details as $detail){
            switch ($detail->pay_for) {
                case 1:
                    $account_tree = Delegate::get_delegate($detail->delegate_id, 'en')->account_tree_id ?? 0;
                    $pay_for = 'Delegate';
                    break;
                case 2:
                    $account_tree = Delegate::get_delegate($detail->delegate_id, 'en')->account_tree_id ?? 0;
                    $pay_for = 'Delegate';

                    break;
                case 3:
                    $account_tree = AccountTree::get_account_tree($detail->account_tree_id, 'en')->id ?? 0;
                    $pay_for = '';
                    break;
                default:
                    $account_tree = 0;
                    $pay_for = '';
                    break;
            }
            if(  $account_tree == 0 ){
                return array( false ,  trans('error.'.$pay_for.' Account tree id not found') , '' ,[] );
            }

            $items[] = array(
                'account_tree_id'	=> $account_tree ,
                'cost_center_id'	=> $detail->cost_center_id ?? 0 ,
                'debit'				=> $detail->amount ,
                'credit'			=> 0 ,
                'description'		=> $detail->arabic_description
            );
        }

        return (new DailyJournalHelper)->generate_journal($journal_data , $items);
    }
}
