<?php

namespace App\Classes;

use App\Models\Finance\AccountTree;
use App\Models\Finance\CostCenter;
use App\Models\Main\Branch;
use App\Models\Main\SalesAgent;
use App\Models\Main\Supplier;
use App\Models\Sales\Customer;
use App\Models\Sales\Delegate;
use App\Models\Trans\Agent;
use App\Models\Trans\Car;
use App\Models\Trans\Driver;
use App\Models\Trans\Port;
use App\Models\Trans\Wearhouse;

class ReportingHelper {

    public $lookups = [
        'accounts','cost_centers','branchs','suppliers','customers','sales_agents','cars',
        'drivers','delegates','ports','agents','areas','sales_areas','wearhouses'
    ];

    function get_lookups($param,$lang){


        switch ($param) {
            case 'accounts':
                return AccountTree::active_account_trees($lang, array('account_type' => 2, 'active' => '1'));
            break;
            case 'customers':
                return Customer::all_customers(array('lang' => $lang, 'active' => '1'));
            break;
            case 'cost_centers':
                return CostCenter::active_cost_centers($lang, array('active' => '1'));
            break;
            case 'branchs':
                return Branch::all_branchs(array('active' => '1' , 'lang' => $lang));
            break;
            case 'suppliers':
                return Supplier::all_suppliers(array('active' => '1' , 'lang' => $lang));
            break;
            case 'cars':
                return Car::all_cars(array('active' => '1' , 'lang' => $lang));
            break;
            case 'drivers':
                return Driver::all_drivers(array('active' => '1' , 'lang' => $lang));
            break;
            case 'delegates':
                return Delegate::all_delegates(array('active' => '1' , 'lang' => $lang));
            break;
            case 'ports':
                return Port::all_ports(array('active' => '1' , 'lang' => $lang));
            break;
            case 'agents':
                return Agent::all_agents(array('active' => '1' , 'lang' => $lang));
            break;
            case 'sales_areas':
                return Supplier::all_suppliers(array('active' => '1' , 'lang' => $lang));
            break;
            case 'wearhouses':
                return Wearhouse::all_wearhouses(array('active' => '1' , 'lang' => $lang));
            break;
            case 'sales_agents':
                return SalesAgent::all_sales_agents(array('active' => '1' , 'lang' => $lang));
            break;
            default:
                return  [];
            break;
        }

    }
}

?>
