<?php
namespace App\Classes\Sales;
use App\Classes\Finance\DailyJournalHelper;




use App\Models\Sales\ClearanceInvoiceClaim as ClearanceInvoice;
use App\Models\Main\Setting;
use App\Models\Finance\Tax;
use App\Models\Finance\DailyJournal;

use App\Models\Sales\Customer;
use Illuminate\Support\Facades\DB;

class ClearanceInvoiceClaimHelper
{
    function get_next_codes($date, $year, $branch)
    {

        $data = [];
        return $data;
    }

    function can_edit($id)
    {
        return true;
    }

    function can_delete($id)
    {

    }

    function generate_journal($id)
    {

        $master             = ClearanceInvoice::get_invoice($id, 'en');
        $customer           = Customer::get_customer($master->customer_id, 'en');
        $details            = [];
        $delegate_details   = ClearanceInvoice::get_invoice_delegate_d($id, 'en');
        $journals           = [];
        $is_journals        = boolval( Setting::get_main_setting_by_code('invoice_journals')->value ?? 0 );
        $totals             = [
            'total_with_vat'    => $delegate_details->sum('amount')  ,
            'total_vat'         => 0 ,
            'total_without_vat' => $delegate_details->sum('amount')
        ];

        if($master->invoice_active == 0 && $master->daily_journal_m_id > 0 ){
            DailyJournal::delete_daily_journal_m($master->daily_journal_m_id);
            return array( true ,  '')  ;
        }

        $item_des       = $customer->name_ar  ." - ن/ " .$master->customs_declaration_number." - م/ ".$master->clearance_id." - ب/ ".$master->shipping_policy_no;
        $items          = [];
        $journal_data   = array(
            'finance_year_id'   => $master->finance_year_id  ,
            'branch_id'         => $master->branch_id ,
            'des'               => "فاتوره مبيعات رقم  ".$id." لمعامله رقم  ".$master->clearance_id  ,
            'journal_date'      => $master->invoice_date ,
            'document_id'       => $id ,
            'daily_type_id'     => 35 ,
            'auto_generated'    => 1 ,
            'journal_active'    => 1 ,
            'confirmed'         => 1 ,
            'daily_journal_id'  => $master->daily_journal_m_id
        );

        if($master->customer_account_tree_id == null || $master->customer_account_tree_id == 0 ){
            return array( false ,  trans('error.Customer Account tree id not found') , '' ,[] );
        }
        //check account shared
        $shared = DB::table('account_tree')
            ->where('account_tree_id' , $master->customer_account_tree_id )
            ->where('shared_account' , 1 )
            ->where('shared_type_id'  , 1 ) // customer
            ->first();
        if(isset($shared) ){
            $shared_profile_id = $master->customer_id;
        }
        $items[] = array(
            'account_tree_id'   => $master->customer_account_tree_id ,
            'shared_profile_id' => $shared_profile_id ?? 0 ,
            'cost_center_id'    => 0 ,
            'debit'             => $totals['total_with_vat'] ,
            'credit'            => 0 ,
            'description'       => $item_des
        );

        foreach ($delegate_details as $key => $row) {

            if($row->expense_code_account_tree_id == null || $row->expense_code_account_tree_id == 0 ){
                return array( false ,  trans('Account tree id not found in ').$row->expense_code_name , '' ,[] );
            }

            if( $row->amount > 0 ){
                $items[]    = array(
                    'account_tree_id'   => $row->expense_code_account_tree_id ,
                    'cost_center_id'    => 0 ,
                    'debit'             => 0 ,
                    'credit'            => $row->amount ,
                    'description'       => $item_des
                );
            }
        }

        $is_journals = boolval( Setting::get_main_setting_by_code('invoice_journals')->value ?? 0 );
        if($is_journals){
            foreach ($journals as $key => $row) {

                if($row->account_tree_id == null || $row->account_tree_id == 0 ){
                    return array( false ,  'Account tree id not found in '.$row->expense_code_name , '' ,[] );
                }

                if( $row->amount > 0 ){
                    $items[]    = array(
                        'account_tree_id'   => $row->account_tree_id ,
                        'cost_center_id'    => 0 ,
                        'debit'             => 0 ,
                        'credit'            => $row->amount  ,
                        'description'       => $item_des
                    );
                }
            }
        }else{
            foreach ($details as $key => $row) {

                if($row->account_tree_id == null || $row->account_tree_id == 0 ){
                    return array( false ,  trans('error.Account tree id not found in clearance invoices details').' " '.($row->name_ar ?? '' ).' "', '' ,[] );
                }

                if( $row->amount_with_vat > 0 ){
                    $items[]    = array(
                        'account_tree_id'   => $row->account_tree_id ,
                        'cost_center_id'    => 0 ,
                        'debit'             => 0 ,
                        'credit'            => $row->amount_without_vat ,
                        'description'       => $item_des
                    );
                }
            }
        }


        $total_revenue_vat = 0;
        if($total_revenue_vat > 0 ){
            $tax_account = Setting::get_main_setting_by_code('default_sales_vat')->value ?? 0;
            $tax = Tax::get_tax($tax_account , 'en');

            if($tax->account_tree_id == null || $tax->account_tree_id == 0 ){
                return array( false ,  trans('error.Account tree id not found in clearance invoices journal'), '' ,[] );
            }

            $items[]    = array(
                'account_tree_id'   => $tax->account_tree_id ,
                'cost_center_id'    => 0 ,
                'debit'             => 0 ,
                'credit'            => $total_revenue_vat ,
                'description'       => $item_des
            );
        }


        $daily_journal = (new DailyJournalHelper)->generate_journal($journal_data , $items );

        if(!$daily_journal[0]){
            DB::rollback();
            return $daily_journal;
        }
        ClearanceInvoice::update_invoice([ 'daily_journal_m_id' => $daily_journal[2] ] , $id );
        return $daily_journal;

    }
}
