<?php
namespace App\Classes\Sales;
use App\Classes\Finance\DailyJournalHelper;
use App\Models\Sales\ClearanceInvoice;
use App\Models\Main\Setting;
use App\Models\Finance\Tax;
use App\Models\Finance\DailyJournal;
use App\Models\Sales\Clearance;
use App\Models\Sales\ClearanceInvoiceClaim;
use App\Models\Sales\ClearanceInvoiceDraft;
use DomFDPF;
use Illuminate\Support\Facades\Storage;
use Spatie\PdfToImage\Pdf as pdfToImage;
use App\Models\Sales\Customer;
use Illuminate\Support\Facades\DB;

class ClearanceInvoiceHelper
{
    function get_next_codes($date, $year, $branch)
    {

        $data = [];
        return $data;
    }

    function can_edit($id)
    {
        return true;
    }

    function can_delete($id)
    {

    }


    function generate_attachments_zip($id )
    {
        $lang   = 'en';
        $master                     = ClearanceInvoice::get_invoice($id, $lang);
        $invoice_attachment         = ClearanceInvoice::all_attachment($lang,$master->clearance_id);
        $multi_voucher_attachment   = ClearanceInvoice::multi_voucher_attachment($lang,$master->clearance_id);
        $multi_voucher_files        = collect($multi_voucher_attachment)->pluck('attachment')->toArray();
        $invoice_files              = collect($invoice_attachment)->pluck('file_path')->toArray();
        $files                      = array_merge($multi_voucher_files ,$invoice_files);
        $files                      = array_filter($files, function ($value) {
            return $value !== null;
        });

        if(isset($files) && !empty($files)){
            $client_id      = request()->header('clientID');
            $zip            = new \ZipArchive();
            $folder         = '/temp/'.$client_id.'/invoice_attachments/';
            $name           = 'clearance_invoice_zip_'.$master->invoice_uuid.'.zip';
            $zipFilePath    = public_path($folder.$name);
            $final_path     = url($folder.$name);
            if(!is_dir(public_path($folder))){
                mkdir(public_path($folder), 0777, true);
            }
            if ($zip->open($zipFilePath, \ZipArchive::CREATE) === TRUE) {
                foreach ($files as $file) {
                    $filePath = public_path($file);
                    if (file_exists($filePath)) {
                        // Add files to zip
                        $zip->addFile($filePath, basename($file));
                    } else {
                        // Optionally log missing files
                        \Log::warning("File not found: $filePath");
                    }
                }
                $zip->close();
            } else {
                return $this->sendError('Could not create a zip file.', '');
            }

        }else{
            $folder = '';
            $name = '';
            $final_path = null;
        }

        return $folder.$name;

    }

    function attachments_image($id , $type = null , $invoice_files = 0 , $fees_files = 0 , $clearance_files = 0 ){
        $lang   = 'en';
        // customs_declaration_file
        if(isset($type) && $type == 'claim' ){
            $master                     = ClearanceInvoiceClaim::get_invoice($id, $lang);
            $invoice_attachments        = ClearanceInvoiceClaim::invoice_attachments($lang , $id);

        }elseif(isset($type) && $type == 'draft'){
            $master                     = ClearanceInvoiceDraft::get_invoice($id, $lang);
            $invoice_attachments        = ClearanceInvoiceDraft::invoice_attachments($lang , $id);

        }elseif(isset($type) && $type == 'invoice'){
            $master                     = ClearanceInvoice::get_invoice($id, $lang);
            $invoice_attachments        = ClearanceInvoice::invoice_attachments($lang , $id);

        }else{
            return $return = [ 'images' => [] , "files" => [] ];
            // $master                     = ClearanceInvoice::get_invoice($id, $lang);
            // $invoice_attachments        = ClearanceInvoice::invoice_attachments($lang , $id);
        }

        $all_attachments  = [];

        if($invoice_files == 1){

            $invoice_attachments_files  = collect($invoice_attachments)->pluck('file_path')->toArray();
            $all_attachments            = array_unique(array_merge($all_attachments,$invoice_attachments_files));
        }

        if($clearance_files == 1){

            $clearance_m            = Clearance::get_clearance($master->clearance_id , 'ar');
            $clearance_d            = Clearance::get_clearance_d($master->clearance_id , 'ar');
            $clearance_files        = Clearance::get_files($master->clearance_id , 'ar');

            $clearance_base_files   = [$clearance_m->customs_declaration_file,$clearance_m->final_note_file];
            $clearance_d_files      = collect($clearance_d)->pluck('return_file')->toArray();
            $clearance_other_files  = collect($clearance_files)->pluck('file_path')->toArray();

            $all_attachments  =  array_unique(array_merge($all_attachments,$clearance_base_files,$clearance_d_files,$clearance_other_files  ));

        }

        if($fees_files == 1){
            $delegate_petty_attachment  = ClearanceInvoice::delegate_petty_attachment($lang,$master->clearance_id , $id , $type ?? 'invoice');
            $multi_voucher_attachment   = ClearanceInvoice::multi_voucher_attachment($lang,$master->clearance_id, $id , $type ?? 'invoice');
            $delegate_petty_attachment_files = collect($delegate_petty_attachment)->pluck('file_path')->toArray();
            $multi_voucher_files        = collect($multi_voucher_attachment)->pluck('attachment')->toArray();
            $all_attachments            = array_unique(array_merge($all_attachments,$delegate_petty_attachment_files,$multi_voucher_files));

        }

        $files                      = array_filter($all_attachments, function ($value) {
            return $value !== null;
        });

        $return['files']    = [];
        $return['images']   = [];
        $file_paths = array_map(function ($path) {
            return ltrim($path, '/');
        }, $files);

        $client_id      = request()->header('clientID') ?? request()->input('clientID') ?? '';
        $page_counter   = 0;
        $folder         = '/upload/'.$client_id.'/'.$id.'/';

        if(!is_dir(public_path($folder))){
            mkdir(public_path($folder), 0777, true);
        }


        foreach ($file_paths as $file){

            $extension = pathinfo($file, PATHINFO_EXTENSION);
            $image_ext = ['jpg', 'jpeg', 'png', 'gif', 'webp']; // Add more as needed
            $page_counter++;
            if(is_file($file) && strtolower(pathinfo($file, PATHINFO_EXTENSION)) === 'pdf'){

                try {
                    $pdf = new pdfToImage($file);

                    // Convert each page to a separate JPEG image
                    $pages = $pdf->pageCount();

                    for ($i = 1; $i <= $pages; $i++) {
                        $pdf->selectPage($i);
                        $pdf->backgroundColor('white')->save(public_path($folder .'page_' . $i  . '-' .$page_counter.'.jpg'));
                        $return['images'][] = $folder .'page_' . $i . '-' .$page_counter. '.jpg';
                    }

                } catch (\Exception $e) {
                }
            }elseif(in_array(strtolower($extension), $image_ext)){
                $return['images'][] = ($file);
            }else{
                $return['files'][] = $file;
            }
        }
        return $return;
    }
    function generate_journal($id)
    {
        $master             = ClearanceInvoice::get_invoice($id, 'en');
        $customer           = Customer::get_customer($master->customer_id, 'en');
        $details            = ClearanceInvoice::get_invoice_d($id, 'en');
        $delegate_details   = ClearanceInvoice::get_invoice_delegate_d($id, 'en');
        $journals           = ClearanceInvoice::get_invoice_journals($id, 'en');
        $is_journals        = boolval( Setting::get_main_setting_by_code('invoice_journals')->value ?? 0 );

        $totals             = [
            'total_with_vat'    => $delegate_details->sum('amount') + $details->sum('amount_with_vat') ,
            'total_vat'         => $details->sum('vat_amount') ,
            'total_without_vat' => $delegate_details->sum('amount') + $details->sum('amount_without_vat')
        ];

        if($master->invoice_active == 0 && $master->daily_journal_m_id > 0 ){
            DailyJournal::delete_daily_journal_m($master->daily_journal_m_id);
            return array( true ,  '')  ;
        }

        //$item_des       = " بيان رقم " .$master->customs_declaration_number." - معامله رقم ".$master->clearance_id." - بوليصة رقم ".$master->shipping_policy_no;
        $item_des       = $customer->name_ar  ." - ن/ " .$master->customs_declaration_number." - م/ ".$master->clearance_id." - ب/ ".$master->shipping_policy_no;
        $items          = [];
        $journal_data   = array(
            'finance_year_id'   => $master->finance_year_id  ,
            'branch_id'         => $master->branch_id ,
            'des'               => "فاتوره مبيعات رقم  ".$id." لمعامله رقم  ".$master->clearance_id  ,
            'journal_date'      => $master->invoice_date ,
            'document_id'       => $id ,
            'daily_type_id'     => 13 ,
            'auto_generated'    => 1 ,
            'journal_active'    => 1 ,
            'confirmed'         => 1 ,
            'daily_journal_id'  => $master->daily_journal_m_id
        );

        if($master->customer_account_tree_id == null || $master->customer_account_tree_id == 0 ){
            return array( false ,  trans('error.Customer Account tree id not found') , '' ,[] );
        }
                //check account shared
            $shared = DB::table('account_tree')
                ->where('account_tree_id' , $master->customer_account_tree_id )
                ->where('shared_account' , 1 )
                ->where('shared_type_id'  , 1 ) // customer
                ->first();
            if(isset($shared) ){
                $shared_profile_id = $master->customer_id;
            }
        $items[] = array(
            'account_tree_id'   => $master->customer_account_tree_id ,
            'shared_profile_id' => $shared_profile_id ?? 0 ,
            'cost_center_id'    => 0 ,
            'debit'             => $totals['total_with_vat'] ,
            'credit'            => 0 ,
            'description'       => $item_des
        );

        foreach ($delegate_details as $key => $row) {

            if($row->expense_code_account_tree_id == null || $row->expense_code_account_tree_id == 0 ){
                return array( false ,  trans('Account tree id not found in ').$row->expense_code_name , '' ,[] );
            }

            if( $row->amount > 0 ){
                $items[]    = array(
                    'account_tree_id'   => $row->expense_code_account_tree_id ,
                    'cost_center_id'    => 0 ,
                    'debit'             => 0 ,
                    'credit'            => $row->amount ,
                    'description'       => $item_des
                );
            }
        }

        $is_journals = boolval( Setting::get_main_setting_by_code('invoice_journals')->value ?? 0 );
        if($is_journals){
            foreach ($journals as $key => $row) {

                if($row->account_tree_id == null || $row->account_tree_id == 0 ){
                    return array( false ,  'Account tree id not found in '.$row->expense_code_name , '' ,[] );
                }

                if( $row->amount > 0 ){
                    $items[]    = array(
                        'account_tree_id'   => $row->account_tree_id ,
                        'cost_center_id'    => 0 ,
                        'debit'             => 0 ,
                        'credit'            => $row->amount  ,
                        'description'       => $item_des
                    );
                }
            }
        }else{
            foreach ($details as $key => $row) {

                if($row->account_tree_id == null || $row->account_tree_id == 0 ){
                    return array( false ,  trans('error.Account tree id not found in clearance invoices details').' " '.($row->name_ar ?? '' ).' "', '' ,[] );
                }

                if( $row->amount_with_vat > 0 ){
                    $items[]    = array(
                        'account_tree_id'   => $row->account_tree_id ,
                        'cost_center_id'    => 0 ,
                        'debit'             => 0 ,
                        'credit'            => $row->amount_without_vat ,
                        'description'       => $item_des
                    );
                }
            }
        }


        $total_revenue_vat = $details->sum('vat_amount');
        if($total_revenue_vat > 0 ){
            $tax_account = Setting::get_main_setting_by_code('default_sales_vat')->value ?? 0;
            $tax = Tax::get_tax($tax_account , 'en');

            if($tax->account_tree_id == null || $tax->account_tree_id == 0 ){
                return array( false ,  trans('error.Account tree id not found in clearance invoices journal'), '' ,[] );
            }

            $items[]    = array(
                'account_tree_id'   => $tax->account_tree_id ,
                'cost_center_id'    => 0 ,
                'debit'             => 0 ,
                'credit'            => $total_revenue_vat ,
                'description'       => $item_des
            );
        }


        $daily_journal = (new DailyJournalHelper)->generate_journal($journal_data , $items );

        if(!$daily_journal[0]){
            DB::rollback();
            return $daily_journal;
        }
        ClearanceInvoice::update_invoice([ 'daily_journal_m_id' => $daily_journal[2] ] , $id );
        return $daily_journal;

    }
}
