<?php
namespace App\Classes\Trans;
use App\Classes\Finance\DailyJournalHelper;
use App\Models\Finance\DailyJournal;
use App\Models\Sales\Insurance;
use App\Models\Main\Setting;
use App\Models\Finance\Tax;
use App\Models\Sales\Customer;
use App\Models\Trans\Invoice;
use DB;

class InvoiceTransHelper
{
    function get_next_codes($date, $year, $branch)
    {
        $data = [];
        return $data;
    }

    function can_edit($id)
    {
        return true;
    }

    function can_delete($id)
    {
        return true;

    }

    function generate_journal($id)
    {

        $master             = Invoice::get_invoice($id, 'en');
        $customer           = Customer::get_customer($master->customer_id, 'en');
        $transport_revenue  = Setting::get_main_setting_by_code('transport_revenue')->value ?? 0 ;

        if($master->invoice_active == 0 && $master->daily_journal_id > 0 ){
            DailyJournal::delete_daily_journal_m($master->daily_journal_id);
            return array( true ,  '')  ;
        }

        $items          = [];
        $journal_data   = array(
            'finance_year_id'   => $master->finance_year_id  ,
            'branch_id'         => $master->branch_id ,
            'des'               => "فاتوره نقليات رقم  ".$id ,
            'journal_date'      => $master->invoice_date ,
            'document_id'       => $id ,
            'daily_type_id'     => 13 ,
            'auto_generated'    => 1 ,
            'journal_active'    => 1 ,
            'confirmed'         => 1
        );

        if($master->customer_account_tree_id == null || $master->customer_account_tree_id == 0 ){
            return array( false ,  trans('error.Customer Account tree id not found') , '' ,[] );
        }
            //check account shared
            $shared = DB::table('account_tree')
                ->where('account_tree_id' , $master->customer_account_tree_id )
                ->where('shared_account' , 1 )
                ->where('shared_type_id'  , 1 ) // customer
                ->first();
            if(isset($shared) ){
                $shared_profile_id = $master->customer_id;
            }
        $items[] = array(
            'account_tree_id'   => $master->customer_account_tree_id ,
            'shared_profile_id' => $shared_profile_id ?? 0 ,
            'cost_center_id'    => 0 ,
            'debit'             => $master->total_with_vat ,
            'credit'            => 0 ,
            'description'       => 'فاتورة نقليات رقم' .$id
        );


        $transport_revenue = Setting::get_main_setting_by_code('transport_revenue')->value ?? 0;

        if($transport_revenue == null || $transport_revenue == 0 ){
            return array( false ,  trans('error.transport_revenue Account tree id not found') , '' ,[] );
        }


        $items[] = array(
            'account_tree_id'   => $transport_revenue ,
            'cost_center_id'    => 0 ,
            'debit'             => 0 ,
            'credit'            => $master->total_without_vat ,
            'description'       => 'إيرادات فاتورة نقليات رقم' .$id
        );


        if($master->total_vat> 0 ){
            $tax_account = Setting::get_main_setting_by_code('default_sales_vat')->value ?? 0;
            $tax = Tax::get_tax($tax_account , 'en');
            if($tax->account_tree_id == null || $tax->account_tree_id == 0 ){
                return array( false ,  trans('error.Account tree id not found in clearance invoices journal'), '' ,[] );
            }

            $items[]    = array(
                'account_tree_id'   => $tax->account_tree_id ,
                'cost_center_id'    => 0 ,
                'debit'             => 0 ,
                'credit'            => $master->total_vat ,
                'description'       => 'ضريبة فاتورة نقليات' .$id
            );
        }


        $daily_journal = (new DailyJournalHelper)->generate_journal($journal_data , $items );

        if(!$daily_journal[0]){
            DB::rollback();
            return $daily_journal;
        }
        Invoice::update_invoice([ 'daily_journal_m_id' => $daily_journal[2] ] , $id );
        return $daily_journal;
    }


    function update_action($id)
    {
        return true;
    }

}
