<?php
namespace App\Classes\Trans;

use App\Classes\Finance\DailyJournalHelper;
use App\Models\Trans\WearhouseTransaction;


use Illuminate\Support\Facades\DB;

class WearhouseTransactionHelper
{
    function get_next_codes($date, $year, $branch)
    {
        $data = [];
        return $data;
    }

    function can_edit($id)
    {
        return true;
    }

    function can_delete($id)
    {
        return true;

    }

    function generate_journal($id)
    {
        return true;
    }


    function calc_price($id)
    {
        $item   = WearhouseTransaction::get_wearhouse_transaction($id , "en");
        if($item->invoice_id > 0 )
            return true;

        if($item->transaction_type == 1){
            $prices = DB::connection('other_mysql')->table('customer_warehouse_prices');
        }else{
            $prices = DB::table('customer_warehouse_prices');
        }

        $prices->where('customer_warehouse_prices.customer_id' ,  $item->customer_id )
            ->where('customer_warehouse_prices.customer_warehouse_price_active' ,  1)
            ->where('customer_warehouse_prices.warehouse_id' , $item->wearhouse_id )
            ->selectRaw('
                ifnull(cont_40 , 0) as cont_40 ,
                ifnull(cont_20 , 0) as cont_20 ,
                ifnull(cont_empty_40 , 0) as cont_empty_40 ,
                ifnull(cont_empty_20 , 0) as cont_empty_20 ,
                ifnull(loading_unloading , 0) as loading_unloading ,
                ifnull(lcl , 0) as lcl ,
                ifnull(warehouse_temp , 0) as warehouse_temp ,
                ifnull(allowed_days , 0) as allowed_days
            ');
        $prices = $prices->first();

        $days = intval( $item->total_days - ($prices->allowed_days ?? 0) );
        if($days <= 0 ){
            $ppd =  0;
        }elseif($item->is_box){
            $ppd = $prices->lcl ?? 0;
        }elseif($item->is_empty && $item->container_size == "20"){
            $ppd = $prices->cont_empty_20 ?? 0;
        }elseif($item->is_empty && $item->container_size == "40"){
            $ppd = $prices->cont_empty_40 ?? 0;
        }elseif(!$item->is_empty && $item->container_size == "20"){
            $ppd = $prices->cont_20 ?? 0;
        }elseif(!$item->is_empty && $item->container_size == "40"){
            $ppd = $prices->cont_40 ?? 0;
        }else{
            $ppd = 0;
        }

        $total_price = ($days * $ppd) + ( $prices->loading_unloading ?? 0 );
        WearhouseTransaction::update_wearhouse_transaction(['total_cost' => $total_price ] ,  $id);
        return true;
    }

}
