<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromArray;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithCustomCsvSettings;
use Maatwebsite\Excel\Concerns\WithMultipleSheets;


class ClassificationsGeneralExport implements FromArray, WithMultipleSheets,WithCustomCsvSettings
{
    /**
     * @return \Illuminate\Support\Collection
     */
    protected $sheets;

    public function __construct(array $sheets)
    {
        $this->sheets = $sheets;
    }

    public function array(): array
    {
        return $this->sheets;
    }

    public function sheets(): array
    {
        $sheets = [
            new ClassificationsExport($this->sheets['details']->toArray()),//items
//            new CountriesExport($this->sheets['countries']->toArray()),//countries
//            new DutyTypeExport($this->sheets['duty_types']),//duty type
//            new ContainerSizesExport($this->sheets['container_sizes']),//container size
//            new DateTypesExport($this->sheets['date_types']),//date type
//            new ItemsUnitsExport($this->sheets['item_units']->toArray()),//item uni
        ];
        return $sheets;
    }

    public function getCsvSettings(): array
    {
        return [
            'extension' => 'xlsx',
        ];
    }
}
