<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithColumnFormatting;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithTitle;

class ContainerSizesExport implements  WithHeadings, WithTitle, ShouldAutoSize, WithColumnFormatting , FromCollection
{
    /**
    * @return \Illuminate\Support\Collection
    */

    public function __construct(array $rows)
    {
        $this->rows = $rows;
    }

    public function columnFormats(): array
    {
        return [];
    }

    public function collection()
    {
        return collect($this->rows)->map(function ($row) {
            return [
                $row->container_size,
            ];
        });
    }

    public function title(): string
    {
        return 'حجم الحاوية /  Container Size';
    }


    public function headings(): array
    {

        return [
            'حجم الحاوية /  Container Size',
        ];
    }
}
