<?php

namespace App\Exports;

use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use Maatwebsite\Excel\Concerns\WithColumnFormatting;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithTitle;

class ItemsUnitsExport implements WithHeadings, WithTitle, ShouldAutoSize, WithColumnFormatting , FromCollection
{
    protected $rows;

    public function __construct(array $rows)
    {
        $this->rows = $rows;
    }

    public function headings(): array
    {

        return [
            'وحدة الصنف - Item Unit',
            'وصف الوحدة بالعربي / Unit Type Arabic Description',
            'وصف الوحدة بالإنجليزي / Unit Type English Description',
        ];
    }
    public function columnFormats(): array
    {
        return [];
    }


    public function title(): string
    {
        return 'وحدة الصنف - Item Unit';
    }

    public function collection()
    {
        return collect($this->rows)->map(function ($row) {
            return [
                $row->id,
                $row->name_ar,
                $row->name_en,
            ];
        });
    }
}
