<?php

namespace App\Http\Controllers\API\EX;
use App\Http\Controllers\API\EX\BaseController;
use Illuminate\Http\Request;
use App\Models\Sales\Customer;
use App\Models\Sales\CustomerFile;
use App\Models\Sales\CustomerInfo;
use App\Classes\General\Upload;



use DB;

class HomeController extends BaseController
{
    protected $return = array();
    protected $filter = array();

    // public function __construct()
    // {
    //     $this->middleware(function ($request, $next) {
    //         return $next($request);
    //     });
    // }

    public function get_customer($lang, Request $request)
    {
        $token      = request()->header('customer-token');
        $customer   = DB::table('customers')
            ->where('customer_token' , $token)
            ->first();

        if( !isset( $customer->customer_id )){
            return $this->sendError( 'Link expired' , [] );
        }

        $this->return['customer']           = Customer::get_customer($customer->customer_id,$lang);
        $this->return['client_attachments'] = CustomerFile::get_customer_file($customer->customer_id,$lang);
        $this->return['customer_contacts']  = CustomerInfo::all_customer_info($customer->customer_id,$lang);
        
    	return $this->sendResponse($this->return );
    }

    public function update_customer($lang, Request $request)
    {

        $token      = request()->header('customer-token');
        $customer   = DB::table('customers')
            ->where('customer_token' , $token)
            ->first();

        if( !isset( $customer->customer_id )){
            return $this->sendError( 'Link expired' , [] );
        }
        $id = $customer->customer_id ;
        $update = $request->only(['name_en', 'name_ar', 'mobile', 'address', 'vat',
                                   'vat_register_number', 'location', 'delegate_id',
                                   'collection_delegate_id', 'account_tree_id','iban_no',
                                   'customer_type', 'id_number', 'email' , 'credit_period' , 'notes' , 'issuing_invoice' ,'commercial_no' ,
            'alireda_code','customer_main_id','is_main' , 'add_building_no' ,'add_street' ,'add_sec_no' ,'add_district' ,'add_postcode' ,'add_city' , 'add_country' ]);

        $rules            = Customer::$rules;
        $rules['name_ar'] = $rules['name_ar'].',name_ar,'.$id.',customer_id';
        $rules['name_en'] = $rules['name_en'].',name_en,'.$id.',customer_id';


        $update['customer_token'] = "";

        $validator  = validator()->make( $update , $rules );
        if($validator->fails())
        {
            return $this->sendError( trans('error.add_fails') , $validator->errors() );
        }

        if( isset($request->commercial_register_file) || isset($request->prices_list_file) || isset($request->iban_file) || isset($request->other_file) ){
            $update['issuing_invoice'] = 1;
        }


        if(isset($request['commercial_register_file']) && strlen($request['commercial_register_file']) > 100){
            $upload = new Upload;
            $check  = $upload->uploadBase64File($request['commercial_register_file'] , 'customers' );

            if(!$check['check'])
                return $this->sendError( trans('error.add_fails') , $check['msg'] );
            else
                $update['commercial_register_file'] = $check['url'];
        }

        if(isset($request['prices_list_file']) && strlen($request['prices_list_file']) > 100){
            $upload = new Upload;
            $check  = $upload->uploadBase64File($request['prices_list_file'] , 'customers' );

            if(!$check['check'])
                return $this->sendError( trans('error.add_fails') , $check['msg'] );
            else
                $update['prices_list_file'] = $check['url'];
        }


        if(isset($request['iban_file']) && strlen($request['iban_file']) > 100){
            $upload = new Upload;
            $check  = $upload->uploadBase64File($request['iban_file'] , 'customers' );

            if(!$check['check'])
                return $this->sendError( trans('error.add_fails') , $check['msg'] );
            else
                $update['iban_file'] = $check['url'];
        }

        if(isset($request['other_file']) && strlen($request['other_file']) > 100){
            $upload = new Upload;
            $check  = $upload->uploadBase64File($request['other_file'] , 'customers' );

            if(!$check['check'])
                return $this->sendError( trans('error.add_fails') , $check['msg'] );
            else
                $update['other_file'] = $check['url'];
        }

        if(isset($request['vat_file']) && strlen($request['vat_file']) > 100){
            $upload = new Upload;
            $check  = $upload->uploadBase64File($request['vat_file'] , 'customers' );

            if(!$check['check'])
                return $this->sendError( trans('error.add_fails') , $check['msg'] );
            else
                $update['vat_file'] = $check['url'];
        }


        DB::beginTransaction();
        Customer::update_customer($update ,  $id );


        if(isset($request->customer_contacts)){
            $customer_contacts =  $request['customer_contacts'];
            CustomerInfo::delete_customer_info($id);
            foreach ($customer_contacts as $customer_contact){
                $seed['customers_info_name']  = $customer_contact['customers_info_name'] ?? null;
                $seed['customers_info_email']  = $customer_contact['customers_info_email'] ?? null;
                $seed['customers_info_phone']  = $customer_contact['customers_info_phone']  ?? null;
                $seed['customer_id']  = $id  ?? null;
                $seed['add_user']  = auth()->user()->id ?? 0;
                CustomerInfo::add_customer_info($seed);
            }
        }

            // return $this->sendError( 'Link expired' , [] );


        DB::commit();



    	return $this->sendResponse($this->return  , trans('main.update_success') );
    }

    public function barcodes_results($lang, Request $request)
    {

    	$this->return['items'] = $request['items'];
        DB::table('rfids')
            ->insert([
                'rfid'      => json_encode($request['items']) , 
                'counter'   => count($request['items'])  ,
                'counter_1' => collect($request['items'])->where('resualt' , 1 )->count() , 
                'counter_2' => collect($request['items'])->where('resualt' , 2 )->count() , 
                'counter_3' => collect($request['items'])->where('resualt' , 3 )->count() 
                ]
            );

    	return $this->sendResponse($this->return , true);
    }

}