<?php

namespace App\Http\Controllers\API\V1;
use App\Http\Controllers\API\V1\BaseController;
use App\Classes\Excel\InvoicesExport;
use App\Classes\General\Upload;
use App\Classes\General\General;
use Illuminate\Http\Request;
use App\Models\Main\ScreenSub;
use App\Models\Trans\Trip;

use App\Models\User;

use PDF;
use App;
use Excel;


class PrintController extends BaseController
{

    public function export_trip($lang , $id , Request $request)
    {
        $this->checkPermission('03-007','print');


        $this->return['lang']             = $lang;
        $this->return['logo']             = get_logo( 1 );
        // $this->return['screen_name']      = ScreenSub::get_screen_sub_by_screen_code('03-007' , $this->return['lang']);
        $this->return['trip']             = Trip::get_trip($id , $this->return['lang']);



        switch (@$request['type']) {
            case 'excel':
                $this->return['logo']     = public_path().$this->return['logo'];
                $export = new InvoicesExport($this->return , 'Trans/trip');
                return Excel::download($export, 'trip.xlsx');
                break;
            case 'pdf':
                $this->return['logo']     = public_path().$this->return['logo'];
                $pdf = PDF::loadView('Trans/trip', array('data' => $this->return ));
                return $pdf->stream();

            break;
            case 'image':
                $this->return['logo']     = public_path().$this->return['logo'];
                $image = App::make('snappy.image.wrapper');
                $image->loadView('Trans/trip', array('data' => $this->return ));
                return $image->stream();
            break;
            case 'print':
                return view('Trans/trip')->with('data' , $this->return);
            break;
            default:
                return $this->sendResponse( $this->return );
            break;
        }

    }

    public function export_invoice($lang , $id , Request $request)
    {
        $this->checkPermission('03-011','print');


        $this->data['lang']             = $lang;
        $this->data['logo']             = get_logo( 1 );
        $this->data['screen_name']      = ScreenSub::get_screen_sub_by_screen_code('03-011' , $this->data['lang']);
        switch (@$request['type']) {
            case 'excel':
                $this->data['logo']     = public_path().$this->data['logo'];
                $export = new InvoicesExport($this->data , 'Trans/invoice');
                return Excel::download($export, 'balances.xlsx');
                break;
            case 'pdf':
                $this->data['logo']     = public_path().$this->data['logo'];
                $pdf = PDF::loadView('Trans/invoice', array('data' => $this->data ));
                return $pdf->stream();

            break;
            case 'image':
                $this->data['logo']     = public_path().$this->data['logo'];
                $image = App::make('snappy.image.wrapper');
                $image->loadView('Trans/invoice', array('data' => $this->data ));
                return $image->stream();
            break;
            case 'print':
                return view('Trans/invoice')->with('data' , $this->data);
            break;
        }
    }

    public function export_store_in($lang , $id , Request $request)
    {
        $this->checkPermission('03-009','print');


        $this->data['lang']             = $lang;
        $this->data['logo']             = get_logo( 1 );
        $this->data['screen_name']      = ScreenSub::get_screen_sub_by_screen_code('03-009' , $this->data['lang']);
        switch (@$request['type']) {
            case 'excel':
                $this->data['logo']     = public_path().$this->data['logo'];
                $export = new InvoicesExport($this->data , 'Trans/invoice');
                return Excel::download($export, 'balances.xlsx');
                break;
            case 'pdf':
                $this->data['logo']     = public_path().$this->data['logo'];
                $pdf = PDF::loadView('Trans/invoice', array('data' => $this->data ));
                return $pdf->stream();

            break;
            case 'image':
                $this->data['logo']     = public_path().$this->data['logo'];
                $image = App::make('snappy.image.wrapper');
                $image->loadView('Trans/invoice', array('data' => $this->data ));
                return $image->stream();
            break;
            case 'print':
                return view('Trans/invoice')->with('data' , $this->data);
            break;
        }

    }

    public function export_store_out($lang , $id , Request $request)
    {
        $this->checkPermission('03-009','print');


        $this->data['lang']             = $lang;
        $this->data['logo']             = get_logo( 1 );
        $this->data['screen_name']      = ScreenSub::get_screen_sub_by_screen_code('03-009' , $this->data['lang']);
        switch (@$request['type']) {
            case 'excel':
                $this->data['logo']     = public_path().$this->data['logo'];
                $export = new InvoicesExport($this->data , 'Trans/invoice');
                return Excel::download($export, 'balances.xlsx');
                break;
            case 'pdf':
                $this->data['logo']     = public_path().$this->data['logo'];
                $pdf = PDF::loadView('Trans/invoice', array('data' => $this->data ));
                return $pdf->stream();

            break;
            case 'image':
                $this->data['logo']     = public_path().$this->data['logo'];
                $image = App::make('snappy.image.wrapper');
                $image->loadView('Trans/invoice', array('data' => $this->data ));
                return $image->stream();
            break;
            case 'print':
                return view('Trans/invoice')->with('data' , $this->data);
            break;
        }

    }








}
