<?php
namespace App\Http\Controllers\API\V1\Sales;
use App\Classes\General\General;
use App\Http\Controllers\API\V1\BaseController;
use App\Models\Finance\DelegatePetty;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Mail;

use App\Classes\Sales\ClearanceInvoiceHelper;
use App\Classes\General\ZatcaHelper;


use App\Models\Finance\AccountTree;
use App\Models\Main\ScreenSub;
use App\Models\Sales\Clearance;
use App\Models\Sales\Customer;
use App\Models\Sales\Revenue;
use App\Models\Trans\Area;
use App\Models\Main\Branch;
use App\Models\Main\Setting;


use Illuminate\Support\Facades\DB;
use Salla\ZATCA\GenerateQrCode;
use Salla\ZATCA\Tags\InvoiceDate;
use Salla\ZATCA\Tags\InvoiceTaxAmount;
use Salla\ZATCA\Tags\InvoiceTotalAmount;
use Salla\ZATCA\Tags\Seller;
use Salla\ZATCA\Tags\TaxNumber;
use Excel;
use App;
use App\Classes\General\Upload;
use App\Classes\General\WhatsAppHelper;
use App\Models\Sales\ClearanceInvoice;
use App\Models\Sales\ClearanceInvoiceClaim;
use App\Models\Sales\ClearanceInvoiceDraft;
use Str;
use DNS2D;
use DomFDPF;
use Illuminate\Support\Facades\Storage;
use Illuminate\Validation\Rule;
use Spatie\PdfToImage\Pdf as pdfToImage;
use PDF;
use View;

class InvoiceController extends BaseController
{
    protected $return = array();
    protected $filter = array();

    public function index($lang, Request $request)
    {
        $this->checkPermission('04-012','view');


        $this->filter = array(
            'lang'   => $lang ,
            'active' => $request['active'] ?? 1 ,
            'rows'   => $request['rows'] ?? null ,
            'page'   => $request['page'] ?? 1 ,
            'word'   => $request['word'] ?? null ,
            'from_id' => $request['from_id'] ?? null ,
            'to_id'   => $request['to_id'] ?? null ,

            'draft'   => 0 ,
            'clearance_id'   => $request['clearance_id'] ?? null ,
            'is_customs_clearance'   => $request['is_customs_clearance'] ?? null ,

        );

        $this->return['screen_name']                = ScreenSub::get_screen_sub_by_screen_code('04-012', $lang)->sub_title ?? '';
        $this->return['items']                      = ClearanceInvoice::all_invoices($this->filter);
        $this->return['customs_clearance_count']    = DB::table('clearance_invoices_d')->where('revenue_id',1)->where('amount_without_vat','>',0)->groupBy('invoice_m_id')->get()->count();
        $this->return['whatsapp_message']           = Setting::get_main_setting_by_code('whatsapp_message')->value ?? 0 ;
        // (new ClearanceInvoiceHelper)->generate_journal( 101 );

        // $invoices = DB::table('clearance_invoices_m')->where('draft_invoice_date' , '>=' , '2025-03-26')->get();
        // foreach ($invoices as $key => $value) {
        //     (new ZatcaHelper)->send_clearance_zatca($value->invoice_id);
        // }
        //     $details = Clearance::get_clearance_d($value->clearance_id , $lang);

        //     DB::table('clearance_invoices_m')
        //         ->where('invoice_id' , $value->invoice_id)
        //         ->update([
        //             'container_count'   => count($details ?? []) ,
        //             'container_small'   => collect($details ?? [])->where('container_size' , 20)->count() ,
        //             'container_big'     => collect($details ?? [])->where('container_size' , 40)->count() ,
        //             'containers_numbers'=> implode(',', collect($details ?? [])->pluck('container_number')->toArray() )
        //         ]);
        // }

//         if(request()->header('clientID') == "buraq_1"){
//             $invoices = DB::table('clearance_invoices_m')
//                 ->whereIn('invoice_id' , [1628,
// 1881,
// 2301,
// 2641,
// 2909,
// 3281,
// 4060,
// 4230,
// 4546,
// 4550,
// 4564,
// 4590,
// 4614,
// 4622,
// 4653,
// 4666])->get();
//             foreach ($invoices as $key => $value) {
//                 (new ClearanceInvoiceHelper)->generate_journal($value->invoice_id);
//             }
//         }

        return $this->sendResponse($this->return);
    }

    protected function update_delegate_amounts($invoice_id , $clearance_id)
    {
        $lang   = 'ar';
        // $master = ClearanceInvoice::get_invoice($invoice_id, $lang);
        // $petty = DB::table('delegate_petty_d')
        //     ->join('delegate_petty_m' , 'delegate_petty_d.delegate_petty_m_id' , '=' , 'delegate_petty_m.delegate_petty_m_id')
        //     ->where('invoice_id' , 0 )
        //     ->where('delegate_petty_d.add_date' , '<=', $master->add_date )
        //     ->where('delegate_petty_m.delegate_petty_active' , 1 )
        //     ->where('delegate_petty_d.clearance_id' , '>',  0 )
        //     ->where('delegate_petty_d.clearance_id' , $clearance_id )
        //     ->selectRaw('
        //         "delegate_petty" as from_type ,
        //         delegate_petty_d.delegate_petty_m_id as m_id ,
        //         delegate_petty_d.delegate_petty_d_id as d_id ,
        //         delegate_petty_d.clearance_id ,
        //         delegate_petty_d.expense_code_id ,
        //         delegate_petty_d.receipt_number ,
        //         delegate_petty_d.amount_without_vat as amount ,
        //         delegate_petty_d.description_'.$lang.' as description ,
        //         delegate_petty_d.add_date
        //     ');

        // $all = DB::table('multi_voucher_d')
        //     ->join('multi_voucher_m' , 'multi_voucher_d.multi_voucher_m_id' , '=' , 'multi_voucher_m.multi_voucher_m_id')
        //     ->where('invoice_id' , 0 )
        //     ->where('multi_voucher_m.add_date' , '<=', $master->add_date )
        //     ->where('multi_voucher_m.multi_voucher_active' , 1 )
        //     ->where('multi_voucher_d.clearance_id' , '>',  0 )
        //     ->where('multi_voucher_d.clearance_id' , $clearance_id )
        //     ->where('voucher_type' , 1 )
        //     ->selectRaw('
        //         "multi_voucher" as from_type ,
        //         multi_voucher_d.multi_voucher_m_id as m_id ,
        //         multi_voucher_d.multi_voucher_d_id as d_id ,
        //         multi_voucher_d.clearance_id ,
        //         multi_voucher_d.dis_expense_code_id as expense_code_id ,
        //         multi_voucher_d.receipt_number ,
        //         multi_voucher_d.amount_without_vat as amount ,
        //         multi_voucher_d.description as description ,
        //         "" as add_date
        //     ')
        //     ->union($petty);



        // $this->return['deleget_amounts']    = DB::table('expense_codes')
        //     ->leftjoinSub($all, 'all', function ($join) {
        //         $join->on('all.expense_code_id' , '=' , 'expense_codes.expense_code_id');
        //     })
        //     ->where('expense_codes.expense_code_id' , '<>' , 8)
        //     ->groupBy('expense_codes.expense_code_id')
        //     ->selectRaw('
        //         m_id ,
        //         d_id ,
        //         group_concat( case when from_type = "delegate_petty" then d_id end) as petty_ids ,
        //         group_concat( case when from_type = "multi_voucher" then d_id end) as multi_ids ,
        //         clearance_id ,
        //         expense_codes.expense_code_id ,
        //         expense_codes.name_'.$lang.' as expense_code_name ,
        //         group_concat(ifnull( receipt_number , "-" )) as receipt_number ,
        //         ifnull( sum(amount) , 0 ) as amount ,
        //         description ,
        //         all.add_date
        //     ')
        //     ->get();



        // // $this->get_invoice_amounts($clearance_id , $lang);

        // DB::table('clearance_invoices_delegate_d')->where('invoice_m_id',$invoice_id)->delete();
        // foreach ($this->return['deleget_amounts'] as $key => $row) {
        //     DB::table('clearance_invoices_delegate_d')->insert([
        //         'invoice_m_id'          => $invoice_id ,
        //         'delegate_petty_d_id'   => $row->d_id ?? 0 ,
        //         'petty_ids'             => $row->petty_ids ,
        //         'multi_ids'             => $row->multi_ids ,
        //         'expense_code_id'       => $row->expense_code_id ,
        //         'receipt_number'        => $row->receipt_number ?? 0 ,
        //         'amount'                => $row->amount ,
        //         'description_ar'        => $row->description ?? '' ,
        //         'description_en'        => $row->description ?? ''
        //     ]);



        //     DB::table('multi_voucher_d')
        //         ->whereIn('multi_voucher_d_id' , explode(',', $row->multi_ids))
        //         ->update( ['invoice_id' => $invoice_id ] );

        //     DB::table('delegate_petty_d')
        //         ->whereIn('delegate_petty_d_id' , explode(',', $row->petty_ids))
        //         ->update( ['invoice_id' => $invoice_id ] );


        // }

        $this->return['details']            = ClearanceInvoice::get_invoice_d($invoice_id, $lang);
        $this->return['delegate_details']   = ClearanceInvoice::get_invoice_delegate_d($invoice_id, $lang);
        $this->return['invoice_journals']   = ClearanceInvoice::get_invoice_journals($invoice_id, $lang);
        ClearanceInvoice::update_invoice([
            'total_delegate'        => collect($this->return['delegate_details'])->sum('amount') ,
            'total_cost'            => collect($this->return['details'])->sum('amount_with_vat') ,
            'total_amount'          => collect($this->return['details'])->sum('amount_with_vat') + collect($this->return['delegate_details'])->sum('amount') ,
            'total_cost_without_vat'=> collect($this->return['details'])->sum('amount_without_vat') ,


            // 'total_without_vat'=> collect($this->return['details'])->sum('amount_without_vat') + collect($this->return['delegate_details'])->sum('amount') ,
            // 'total_vat'     => collect($this->return['details'])->sum('vat_amount')
            // 'total_with_vat'=> collect($this->return['details'])->sum('amount_with_vat') + collect($this->return['delegate_details'])->sum('amount')



        ],$invoice_id);

    }
    public function create($lang , Request $request)
    {
        $this->checkPermission('04-012','add');
        $clearance_id                   = $request['clearance_id'] ?? 0;

        if($request['clearance_id'] == 0 ){
            $this->return['clearances']     = Clearance::all_clearances( ['lang' => $lang , 'active' => 1  ] );
        }else{

            $nof_drafts_clearnace = ClearanceInvoice::all_invoices(array('lang' => $lang,'draft' => 1,'clearance_id'=>$clearance_id))->count();

            if($nof_drafts_clearnace > 0){
                return $this->sendError(trans('error.A draft has already been created for the current transaction'), [], 200);
            }

            $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('04-012', $lang)->sub_title ?? '';
            $this->return['areas']          = Area::all_areas( ['lang' => $lang , 'active' => 1] );
            $this->return['clearance']      = Clearance::get_clearance( $clearance_id , $lang );
            $this->return['customer']      = Customer::get_customer( $this->return['clearance']->customer_id , $lang );
            $this->return['count_invoices'] = DB::table('clearance_invoices_m')->where('clearance_id' , $request['clearance_id'] )->where('invoice_active' , 1 )->count() ;
            $this->return['prices']         = DB::table('customer_transport_prices')
                ->where('port_id' , $this->return['clearance']->port_id)
                ->where('customer_id' , $this->return['clearance']->customer_id)
                ->select('from_area_id' , 'to_area_id','price' , 'container_20' , 'container_40' )
                ->where('customer_transport_price_active' , 1)
                ->get();

            $this->return['account_tree']       = AccountTree::active_account_trees($lang , array('account_type' => 2 , 'active' => 1 ));
            $this->return['is_journals']        = boolval( Setting::get_main_setting_by_code('invoice_journals')->value ?? 0 );


            if(!$this->get_invoice_amounts($clearance_id , $lang) ){
                return $this->sendError($this->return , [],  200);
            }

            if($this->return['deleget_amounts']->sum('amount') == 0 && count($this->return['amounts']) == 0   ){
                return $this->sendError( trans('main.no_amount_found'), [], 200);
            }
        }

        return $this->sendResponse($this->return);
    }

    public function store($lang, Request $request)
    {
        $this->checkPermission('04-012','add');
        $clearance_id = $request['clearance_id'] ?? 0;
        if($request['clearance_id'] == 0 ){
            return $this->sendError( 'clearance ID is required', [], 200);
        }

        $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('04-012', $lang)->sub_title ?? '';
        if(!$this->get_invoice_amounts($clearance_id , $lang) ){
            return $this->sendError($this->return , [],  200);
        }

        if($this->return['deleget_amounts']->sum('amount') == 0 && count($this->return['amounts']) == 0   ){
            return $this->sendError('No Amounts found', [], 200);
        }


        $year   = array_search( date("Y" , strtotime($request['invoice_date'])) , $this->data['years'] );
        // if($year == ''){
        //     return $this->sendError( trans("error.finance_year_not_aval"));
        // }
        if((new General)->check_financial_year($request['invoice_date'] ?? date("Y-m-d")) != "true"){
            return $this->sendError((new General)->check_financial_year($request['invoice_date'] ?? date("Y-m-d")));
        }
        DB::beginTransaction();

        DB::table('clearance_invoices_m')->lockForUpdate()->get();
        $id = intval( DB::table('clearance_invoices_m')->max("invoice_id") ) + 1;


        if(isset($request['clearance_transport_fees']) && is_array(isset($request['clearance_transport_fees'])) && count($request['clearance_transport_fees']) > 0 ){
            foreach ($request['clearance_transport_fees'] as $key => $row) {
                DB::table('clearances_d')
                    ->where('clearances_m_id' , $row['clearances_m_id'])
                    ->where('clearances_d_id' , $row['clearances_d_id'])
                    ->update( ['from_area' => $row['from_area'] , 'to_area' => $row['to_area'] , ] );
            }
        }

        $counter = DB::table('clearance_invoices_m')->where('clearance_id' , $request['clearance_id'] )->where('invoice_active' , 1 )->count();
        if($counter >= 0  )
            $this->return['amounts'] = $request['extra_amounts'];

         ClearanceInvoice::add_invoice([
            'invoice_id'        => $id ,
            'invoice_uuid'      => Str::uuid() ,
            'clearance_id'      => $clearance_id ,
            'goods_type'        => $request['goods_type'] ?? '' ,
            'branch_id'         => $this->data['current_branch'],
            'finance_year_id'   => $year ,
            'port_id'           => $this->return['clearance_m']->port_id ,
            'customer_id'       => $this->return['clearance_m']->customer_id ,
            'invoice_date'      => $request['invoice_date'] ?? date("Y-m-d") ,
            'total_delegate'    => collect($this->return['deleget_amounts'])->sum('amount') ,
            "total_cost_without_vat"  => collect($this->return['amounts'])->sum('amount_without_vat') ,
            'total_cost'        => collect($this->return['amounts'])->sum('amount_with_vat') ,
            'total_amount'      => collect($this->return['amounts'])->sum('amount_with_vat') + collect($this->return['deleget_amounts'])->sum('amount') ,


            // 'total_without_vat'=> collect($this->return['amounts'])->sum('amount_without_vat') + collect($this->return['deleget_amounts'])->sum('amount') ,
            // 'total_vat'     => collect($this->return['amounts'])->sum('vat_amount')
            // 'total_with_vat'=> collect($this->return['amounts'])->sum('amount_with_vat') + collect($this->return['deleget_amounts'])->sum('amount')


            'vat_per'       => 15 ,
            'add_user'      => auth()->guard('api')->user()->id,
            'draft'         => 0
        ]);

        foreach ($this->return['amounts'] as $key => $row) {
            $this->return['amounts'][$key]['invoice_m_id'] = $id;
            $this->return['amounts'][$key]['description'] = $this->return['amounts'][$key]['description'] ?? '';

        }

        ClearanceInvoice::add_invoice_d( $this->return['amounts'] );
        $this->return['deleget_amounts'] = $request['delegate_amounts'];

        foreach ($this->return['deleget_amounts'] as $key => $row) {

            // if($row['amount'] > 0 ){
                DB::table('clearance_invoices_delegate_d')->insert([
                    'invoice_m_id'          => $id ,
                    'delegate_petty_d_id'   => $row['d_id'] ?? 0 ,
                    'multi_ids'             => $row['multi_ids'] ,
                    'petty_ids'             => $row['petty_ids'] ,
                    'expense_code_id'       => $row['expense_code_id'] ,
                    'receipt_number'        => $row['receipt_number'] ?? 0 ,
                    'amount'                => $row['amount'] ,
                    'description_ar'        => $row['description'] ?? '' ,
                    'description_en'        => $row['description'] ?? ''
                ]);

                DB::table('multi_voucher_d')
                    ->whereIn('multi_voucher_d_id' , explode(',', $row['multi_ids']))
                    ->update( ['invoice_id' => $id ] );

                DB::table('delegate_petty_d')
                    ->whereIn('delegate_petty_d_id' , explode(',', $row['petty_ids']))
                    ->update( ['invoice_id' => $id ] );
            // }
        }
        if(isset($request['pledge_number']) || isset($request['pledge_date'])){
            $clearance = DB::table('clearances_m')->where('clearance_id',$clearance_id)->first();
            DB::table('clearances_m')->where('clearance_id',$clearance_id)->update([
                'pledge_number' => $request['pledge_number'] ?? $clearance->pledge_number,
                'pledge_date'   => $request['pledge_date'] ?? $clearance->pledge_date
            ]);
        }
        if (isset($request['invoice_journals']) && is_array($request['invoice_journals'])){
            foreach ($request['invoice_journals'] as $row){
                $seed['invoice_m_id'] = $id;
                $seed['account_tree_id'] = $row['account_tree_id'];
                $seed['amount'] = $row['amount'];
                ClearanceInvoice::add_invoice_journal($seed);
            }
        }

        $journal = (new ClearanceInvoiceHelper)->generate_journal($id);
        if(!$journal[0])
            return $this->sendError($journal[1], $journal ?? [] );

        if( in_array( request()->header('clientID') ,[ 'buraq_1'])){

            $ztca   = new ZatcaHelper;
            $ztca->prepare_clearnace_invoice($id);
            $res    = $ztca->send_invoice();

            if(!$res[0]){

                DB::rollback();
                DB::table('zatca_log')
                    ->insert([
                        'invoice_id'    => $id  ,
                        'source'        => 'ClearanceInvoice' ,
                        'respones'      => $res[2] ,
                        'add_user'      => auth()->user()->id ,
                        'is_done'       => 0
                    ]);

                return $this->sendError($res[1], $res ?? [] );
            }
        }elseif( in_array( request()->header('clientID') ,[ 'amwaj']) ){
            (new ZatcaHelper)->send_clearance_zatca($id);
        }

        DB::commit();

        // $this->return['id'] = Invoice::add_invoice($insert);
        return $this->sendResponse($id, trans('main.add_success'));
    }

    public function show($lang, $id)
    {
        // $this->checkPermission('04-012','view');


        // $x = (new ZatcaHelper)->send_clearance_zatca($id);
        // return $this->sendError('', $x );

        $this->return['screen_name']        = ScreenSub::get_screen_sub_by_screen_code('04-012', $lang)->sub_title ?? '';
        $this->return['master']             = ClearanceInvoice::get_invoice($id, $lang);
        if(!isset($this->return['master']->id)){
            return $this->sendError(trans('error.transaction_not_found' , ['i' => trans('main.invoice')]) , [],  200);
        }
        $this->return['details']            = ClearanceInvoice::get_invoice_d($id, $lang);
        $this->return['delegate_details']   = ClearanceInvoice::get_invoice_delegate_d($id, $lang);
        $this->return['invoice_journals']   = ClearanceInvoice::get_invoice_journals($id, $lang);
        $this->return['is_journals']        = boolval( Setting::get_main_setting_by_code('invoice_journals')->value ?? 0 );
        $this->return['account_tree']       = AccountTree::active_account_trees($lang , array('account_type' => 2 , 'active' => 1 ));
        $this->return['customer']      = Customer::get_customer(  $this->return['master']->customer_id , $lang );
        $this->return['clearance_details'] = Clearance::get_clearance_d($this->return['master']->clearance_id , $lang);

        $this->return['totals']             = [
            'total_with_vat'    => $this->return['delegate_details']->sum('amount') + $this->return['details']->sum('amount_with_vat') ,
            'total_vat'         => $this->return['details']->sum('vat_amount') ,
            'total_without_vat' => $this->return['delegate_details']->sum('amount') + $this->return['details']->sum('amount_without_vat')
        ];

        $this->return['next_item']      = ClearanceInvoice::get_next( $id , 0 )->m_id ?? 0;
        $this->return['previous_item']  = ClearanceInvoice::get_previous($id , 0 )->m_id ?? 0;
        $this->return['first_item']     = 1;
        $this->return['last_item']      = ClearanceInvoice::get_last( 0 )->m_id ?? 0;
        $clearance      = Clearance::get_clearance( $this->return['master']->clearance_id , $lang );


        $this->return['prices']          = DB::table('customer_transport_prices')
            ->leftjoin('areas as from_areas' , 'customer_transport_prices.from_area_id' , '=' , 'from_areas.area_id')
            ->leftjoin('areas as to_areas' , 'customer_transport_prices.to_area_id' , '=' , 'to_areas.area_id')
            ->where('port_id' , $clearance->port_id)
            ->where('customer_id' , $clearance->customer_id)
            ->select('from_areas.area_name_'.$lang.' as from_area_name','to_areas.area_name_'.$lang.' as to_area_name','from_area_id' , 'to_area_id','price' , 'container_20' , 'container_40','price_special' , 'container_20_special' , 'container_40_special' )
            ->where('customer_transport_price_active' , 1)
            ->get();


        return $this->sendResponse($this->return);
    }

    public function update_invoice_journals($lang,$id,Request $request){
        $this->checkPermission('04-012','edit');

        ClearanceInvoice::delete_invoice_journals($id);
        foreach ($request['invoice_journals'] as $row){
            $seed['invoice_m_id'] =$id ;
            $seed['account_tree_id'] = $row['account_tree_id'];
            $seed['amount'] = $row['amount'];
            ClearanceInvoice::add_invoice_journal($seed);
        }

        $journal = (new ClearanceInvoiceHelper)->generate_journal($id);
        if(!$journal[0])
            return $this->sendError($journal[1], $journal ?? [] );

        return $this->sendResponse('',trans('main.update_success'));

    }


    public function print( $id , Request $request)
    {

        // $this->checkPermission('04-012','print');
        $lang                               =  $_GET['lang'] ?? 'ar';
        // if(isset($_GET['clientID']) && $_GET['clientID'] == "redex_1" ){
        //     $lang = 'en';
        // }

        $this->return['lang']               = $lang;
        $this->return['master']             = ClearanceInvoice::get_invoice($id, $lang);
        $this->return['details']            = ClearanceInvoice::get_invoice_d($id, $lang);
        $this->return['delegate_details']   = ClearanceInvoice::get_invoice_delegate_d($id, $lang);
        $this->return['branch_data']        = Branch::get_branch($this->return['master']->branch_id  , $lang);
        $this->return['logo']               = $this->return['branch_data']->branch_image ?? 0;
        $this->return['goods_type']         = DB::table('classifications_m')
            ->join('classifications_d' , 'classifications_m.classification_id' , '=' , 'classifications_d.classifications_m_id')
            ->where('clearances_m_id' , $this->return['master']->clearance_id)
            ->first()->item_name ?? $this->return['master']->goods_type;
        $this->return['containers']         = implode(' , ' ,  Clearance::get_clearance_d($this->return['master']->clearance_id)->pluck('container_number')->toArray() );
        $this->return['tafqeet']            =  ( new General )->numberToText($this->return['lang'], round($this->return['master']->total_amount , 2) , 'SAR' );
        if( strlen($this->return['master']->invoice_qrcode) > 10 ){

            // $this->return['qrcode'] = Image::make(DNS2D::getBarcodePNG($this->return['master']->invoice_qrcode, 'QRCODE,H', 10, 10));
            $this->return['qrcode'] = "data:image/png;base64,".DNS2D::getBarcodePNG( ($this->return['master']->invoice_qrcode) , 'QRCODE', 10, 10);

        }else{

            $this->return['qrcode']             = GenerateQrCode::fromArray([
                new Seller($this->return['branch_data']->vat_register_name),
                new TaxNumber($this->return['branch_data']->vat_number),
                new InvoiceDate(date('Y-m-d\TH:i:s', strtotime($this->return['master']->add_date))),
                new InvoiceTotalAmount(($this->return['delegate_details']->sum('amount') + $this->return['details']->sum('amount_with_vat') )), // Invoice Total Amount
                new InvoiceTaxAmount(round($this->return['details']->sum('vat_amount') , 2)) // Invoice Tax Amount
            ])->render();
        }
        $temp_name  = $request['print_temp'] ?? Setting::get_main_setting_by_code('clearance_invoice_print')->value ?? 'temp_1' ;
        $print_temp = 'Print.clearance.invoice.'.$temp_name;
        // $this->return['attachments'] = [];

        // if(isset($request['with_attachments']) && $request['with_attachments'] == 1){
        //     $attachments =  (new ClearanceInvoiceHelper)->attachments_image($id , 'invoice' , $request['clearance_attachments'] ?? 0);
        //     $this->return['attachments'] = $attachments['images'];
        // }

        $this->return['attachments'] = (new ClearanceInvoiceHelper)->attachments_image($id , 'invoice' , 1 , $request['with_attachments'] ?? 0 , $request['clearance_attachments'] ?? 0)['images'] ?? [];

        $this->return['type'] = $request['type'] ?? '';

        // return $this->sendPrint('pdf', $print_temp, $this->return , 'invoice_'.$id.'.pdf');
        switch (@$request['type']) {
            case 'excel':
                $this->return['logo']     = public_path().$this->return['logo'];
                $export = new InvoicesExport($this->return , $print_temp );
                return Excel::download($export, 'balances.xlsx');
                break;
            case 'pdf':
                $this->return['logo']     = public_path().$this->return['logo'];
                $options = [
                    'margin-left'   => 0 ,
                    'margin-right'  => 0 ,
                    'margin-top'    => 0 ,
                    'margin-bottom' => 0 ,
                    // 'footer-html' => view()->make('Print.clearance.invoice.whats_footer')->render()
                ];
                return PDF::loadView($print_temp, array('data' => $this->return ))
                    ->setPaper('A4', 'portrait')
                    ->setOptions($options)
                    ->inline();

                break;
            case 'pdf_save':
                $this->return['logo']     = public_path().$this->return['logo'];
                $options = [
                    'margin-left' => 0 ,
                    'margin-right' => 0 ,
                    'margin-top' => 0 ,
                    'margin-bottom' => 0 ,
                    // 'footer-html' => view()->make('Print.clearance.invoice.whats_footer')->render()
                ];
                return PDF::loadView($print_temp, array('data' => $this->return ))
                    ->setPaper('A4', 'portrait')
                    ->setOptions($options)
                    ->save(public_path('upload/clear'));

                break;
            case 'image':
                $image = App::make('snappy.image.wrapper');
                $image->loadView($print_temp, array('data' => $this->return));
                return $image->stream();
                break;
            case 'print':
                return view($print_temp)->with('data' , $this->return);
                break;
            case 'json':
                return view($print_temp)->with('data' , $this->return);
                break;
            case 'save_pdf_file':

                $folder                 = '/temp/'.$request['clientID'].'/invoices_pdf/';
                $name                   = 'invoice_'.$id.'.pdf';
                $file_path              = ($folder.$name);
                $file_real_path         = public_path($folder.$name);
                $this->return['logo']   = public_path().$this->return['logo'];
                $options = [
                    'margin-left' => 0 ,
                    'margin-right' => 0 ,
                    'margin-top' => 0 ,
                    'margin-bottom' => 0 ,
                    // 'footer-html' => view()->make('Print.clearance.invoice.whats_footer')->render()
                ];

                if(!is_dir(public_path($folder))){
                    mkdir(public_path($folder), 0777, true);
                }

                if (file_exists(($file_real_path))) {
                  unlink(($file_real_path));
                }
                // return $file_real_path;


                PDF::loadView($print_temp, array('data' => $this->return ))
                    ->setPaper('A4', 'portrait')
                    ->setOptions($options)
                    ->save($file_real_path);

                return ($file_path);
            break;
            case 'save_pdf_file_url':

                $folder                 = '/temp/'.$request['clientID'].'/invoices_pdf/';
                $name                   = 'invoice_'.$id.'.pdf';
                $file_path              = ($folder.$name);
                $file_real_path         = public_path($folder.$name);
                $this->return['logo']   = public_path().$this->return['logo'];
                $options = [
                    'margin-left' => 0 ,
                    'margin-right' => 0 ,
                    'margin-top' => 0 ,
                    'margin-bottom' => 0 ,
                    // 'footer-html' => view()->make('Print.clearance.invoice.whats_footer')->render()
                ];

                if(!is_dir(public_path($folder))){
                    mkdir(public_path($folder), 0777, true);
                }

                if (file_exists(($file_real_path))) {
                  unlink(($file_real_path));
                }
                // return $file_real_path;


                PDF::loadView($print_temp, array('data' => $this->return ))
                    ->setPaper('A4', 'portrait')
                    ->setOptions($options)
                    ->save($file_real_path);

                return url($file_path);

                $this->return['logo']   = public_path().$this->return['logo'];
                $name           = 'clearance_invoice_'.$id.'.pdf';
                $file_real_path = public_path($folder.$name);
                $final_url      = url($folder.$name);
                if(file_exists($file_real_path)){
                    unlink($file_real_path);
                }
                if(!is_dir(public_path($folder))){
                    mkdir(public_path($folder), 0777, true);
                }
                $pdf = PDF::loadView($print_temp, array('data' => $this->return ))->setOption("footer-center", "[page] / [topage]");
                $pdf->save($file_real_path);
                return $folder.$name;
            break;
        }


        return $this->sendResponse($this->return);
    }
    public function print_invoices($lang ,Request $request){
        // $this->checkPermission('03-023','print');
        $this->filter = array(
            'lang'   => $lang ,
            'active' => $request['active'] ?? 1 ,
            'rows'   => $request['rows'] ?? null ,
            'page'   => $request['page'] ?? 1 ,
            'word'   => $request['word'] ?? null ,
            'from_id' => $request['from_id'] ?? null ,
            'to_id'   => $request['to_id'] ?? null ,
            'draft'   => 0 ,
            'clearance_id'   => $request['clearance_id'] ?? null ,
            'is_customs_clearance'   => $request['is_customs_clearance'] ?? null ,

        );

        // $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('04-012', $lang)->sub_title ?? '';
        $invoices       = ClearanceInvoice::all_invoices($this->filter);
        $this->return['logo']           = $this->return['branch_data']->branch_image ?? 0;
        $temp_name  = $request['print_temp'] ?? Setting::get_main_setting_by_code('clearance_invoice_print')->value ?? 'temp_1' ;

        $allInvoicesHtml = '';

        foreach ($invoices  as $invoice) {
            $this->return['lang']               = $lang;
            $this->return['master']             = ClearanceInvoice::get_invoice($invoice->id, $lang);
            $this->return['details']            = ClearanceInvoice::get_invoice_d($invoice->id, $lang);
            $this->return['delegate_details']   = ClearanceInvoice::get_invoice_delegate_d($invoice->id, $lang);
            $this->return['branch_data']        = Branch::get_branch($this->return['master']->clearance_branch_id  , $lang);
            $this->return['goods_type']         = DB::table('classifications_m')
                ->join('classifications_d' , 'classifications_m.classification_id' , '=' , 'classifications_d.classifications_m_id')
                ->where('clearances_m_id' , $this->return['master']->clearance_id)
                ->first()->item_name ?? $this->return['master']->goods_type;
            $this->return['containers']         = implode(' , ' ,  Clearance::get_clearance_d($this->return['master']->clearance_id)->pluck('container_number')->toArray() );
            $this->return['tafqeet']            =  ( new General )->numberToText($this->return['lang'], round($this->return['master']->total_amount , 2) , 'SAR' );

            if( strlen($this->return['master']->invoice_qrcode) > 10 ){

                $this->return['qrcode'] = "data:image/png;base64,".DNS2D::getBarcodePNG( ($this->return['master']->invoice_qrcode) , 'QRCODE', 10, 10);

            }else{

                $this->return['qrcode']             = GenerateQrCode::fromArray([
                    new Seller($this->return['branch_data']->vat_register_name),
                    new TaxNumber($this->return['branch_data']->vat_number),
                    new InvoiceDate(date('Y-m-d\TH:i:s', strtotime($this->return['master']->add_date))),
                    new InvoiceTotalAmount(($this->return['delegate_details']->sum('amount') + $this->return['details']->sum('amount_with_vat') )), // Invoice Total Amount
                    new InvoiceTaxAmount(round($this->return['details']->sum('vat_amount') , 2)) // Invoice Tax Amount
                ])->render();
            }

            $invoice_html = view('Print.clearance.'.$temp_name, ['data' => $this->return])->render();
            $invoice_html .= '<div style="page-break-after: always;"></div>';
            $allInvoicesHtml .= $invoice_html;
        }
        $allInvoicesHtml .= '<script type="text/javascript">window.print();</script>';

        return  $allInvoicesHtml;


    }

    public function destroy($lang, $id)
    {
        $this->checkPermission('04-012','delete');

        // DB::beginTransaction();

        // ClearanceInvoice::delete_invoice($id);
        // DB::table('delegate_petty_d')
        //     ->where('invoice_id' , $id)
        //     ->update( ['invoice_id' => 0 ] );

        // DB::table('multi_voucher_d')
        //     ->where('invoice_id' , $id)
        //     ->update( ['invoice_id' => 0 ] );


        // DB::commit();

        return $this->sendError(trans('error.delete_fails') , []);
    }

    public function toggle_active($lang, $id)
    {
        $item = Invoice::find($id);

        if($item->invoice_active){
            $this->checkPermission('04-012','delete');

            Invoice::delete_invoice($id);
            $this->return['active'] = false;

        }else{
            $this->checkPermission('04-012','delete');

            Invoice::update_invoice(array('invoice_active' => 1), $id);
            $this->return['active'] = true;
        }

        return $this->sendResponse($this->return, trans('main.update_success'));
    }

    public function get_invoice_deleget_data($lang , Request $request){

        $clearance_id       = $request['clearance_id'] ?? "no_id";
        $expense_code_id    = $request['expense_code_id'] ?? "no_id";
        $invoice_id         = $request['invoice_id'] ?? "no_id";
        $source             = $request['source'] ?? "no_source";

        $petty = DB::table('delegate_petty_d')
            ->join('delegate_petty_m' , 'delegate_petty_d.delegate_petty_m_id' , '=' , 'delegate_petty_m.delegate_petty_m_id')
            ->where('delegate_petty_m.delegate_petty_active' , 1 )
            ->where('delegate_petty_d.clearance_id' , '>',  0 )
            ->where('delegate_petty_d.clearance_id' , $clearance_id )
            ->where('expense_code_id' , $expense_code_id)
            //->where('invoice_id' , $invoice_id)
            ->selectRaw('
                "delegate_petty" as from_type ,
                delegate_petty_d.delegate_petty_m_id as m_id ,
                delegate_petty_d.delegate_petty_d_id as d_id ,

                clearance_id ,
                expense_code_id ,
                receipt_number ,
                delegate_petty_d.file_path as attachment ,
                amount ,
                delegate_petty_d.description_'.$lang.' as description ,
                delegate_petty_m.add_date
            ');



        $multi =  DB::table('multi_voucher_d')
            ->join('multi_voucher_m' , 'multi_voucher_d.multi_voucher_m_id' , '=' , 'multi_voucher_m.multi_voucher_m_id')
            ->where('multi_voucher_m.multi_voucher_active' , 1 )
            ->where('multi_voucher_d.multi_voucher_d_active' , 1 )
            ->where('multi_voucher_d.clearance_id' , '>',  0 )
            // ->where('invoice_id' , $invoice_id)
            ->where('multi_voucher_d.clearance_id' , $clearance_id )
            ->where('dis_expense_code_id' , $expense_code_id)
            ->where('voucher_type' , 1 )
            ->selectRaw('
                "multi_voucher" as from_type ,
                multi_voucher_d.multi_voucher_m_id as m_id ,
                multi_voucher_d.multi_voucher_d_id as d_id ,
                clearance_id ,
                multi_voucher_d.dis_expense_code_id as expense_code_id ,
                multi_voucher_d.receipt_number ,
                multi_voucher_d.attachment ,
                amount ,
                multi_voucher_d.description as description ,
                multi_voucher_m.add_date as add_date
            ');


        switch ($source){
            case 'invoice':
                $petty->where('invoice_type' , 'invoice')
                    ->where('invoice_id' , $invoice_id );
                $multi->where('invoice_type' , 'invoice')
                    ->where('invoice_id' , $invoice_id );
            break;
            case 'draft':
                $ids = DB::table('clearance_invoices_draft_delegate_d')
                    ->where('invoice_m_id' , $invoice_id)
                    ->where('expense_code_id' , $expense_code_id)
                    ->first();
                if( isset($ids->petty_ids )){
                    $petty->whereIn('delegate_petty_d_id' , explode(',' , $ids->petty_ids ));
                    $multi->whereIn('multi_voucher_d.multi_voucher_d_id' , explode(',' , $ids->multi_ids ) );
                }else{
                    $petty->where('invoice_id' , 0 );
                    $multi->where('invoice_id' , 0 );
                }

            break;
            case 'claim':
                $petty->where('invoice_type' , 'claim')
                    ->where('invoice_id' , $invoice_id );
                $multi->where('invoice_type' , 'claim')
                    ->where('invoice_id' , $invoice_id );
            break;
            case 'claim_update':
                // $petty->where('invoice_type' , 'claim')
                //     ->where('invoice_id' , $invoice_id );
                // $multi->where('invoice_type' , 'claim')
                //     ->where('invoice_id' , $invoice_id );
            break;
            case 'invoice_update':
                // $petty->where('invoice_type' , 'invoice')
                //     ->where('invoice_id' , $invoice_id );
                // $multi->where('invoice_type' , 'invoice')
                //     ->where('invoice_id' , $invoice_id );
            break;
            default:

            break;

        }
        $this->return['items'] = $multi->union($petty)->get();

        return $this->sendResponse($this->return, []);

    }

    private function get_invoice_amounts($clearance_id ,$lang){

        $this->return['clearance_m']    = Clearance::get_clearance($clearance_id , $lang);
        if(!$this->return['clearance_m']){
            $this->return = 'Clearance Not found';
            return false;
        }
        $this->return['clearance_d']    = Clearance::get_clearance_d($clearance_id , $lang);

        if($this->return['clearance_d']->where('from_area' , 0)->count() > 0 ){
            $this->return['transport_fees'] = 1;
        }else{
            $this->return['transport_fees'] = 0;
        }

        $this->return['amounts']            = array();


        $petty = DB::table('delegate_petty_d')
            ->join('delegate_petty_m' , 'delegate_petty_d.delegate_petty_m_id' , '=' , 'delegate_petty_m.delegate_petty_m_id')
            ->where('invoice_id' , 0 )
            ->where('delegate_petty_m.delegate_petty_active' , 1 )
            ->where('delegate_petty_d.clearance_id' , '>',  0 )
            ->where('delegate_petty_d.clearance_id' , $clearance_id )
            ->selectRaw('
                "delegate_petty" as from_type ,
                delegate_petty_d.delegate_petty_m_id as m_id ,
                delegate_petty_d.delegate_petty_d_id as d_id ,
                delegate_petty_d.clearance_id ,
                delegate_petty_d.expense_code_id ,
                delegate_petty_d.receipt_number ,
                delegate_petty_d.amount_without_vat as amount ,
                delegate_petty_d.description_'.$lang.' as description ,
                delegate_petty_d.add_date
            ');

        $all = DB::table('multi_voucher_d')
            ->join('multi_voucher_m' , 'multi_voucher_d.multi_voucher_m_id' , '=' , 'multi_voucher_m.multi_voucher_m_id')
            ->where('multi_voucher_d.invoice_id' , 0 )
            ->where('multi_voucher_m.multi_voucher_active' , 1 )
            ->where('multi_voucher_d.multi_voucher_d_active' , 1 )
            ->where('multi_voucher_d.clearance_id' , '>',  0 )
            ->where('multi_voucher_d.clearance_id' , $clearance_id )
            ->where('voucher_type' , 1 )
            ->selectRaw('
                "multi_voucher" as from_type ,
                multi_voucher_d.multi_voucher_m_id as m_id ,
                multi_voucher_d.multi_voucher_d_id as d_id ,
                multi_voucher_d.clearance_id ,
                multi_voucher_d.dis_expense_code_id as expense_code_id ,
                multi_voucher_d.receipt_number ,
                multi_voucher_d.amount_without_vat as amount ,
                multi_voucher_d.description as description ,
                "" as add_date
            ')
            ->union($petty);



        $this->return['deleget_amounts']    = DB::table('expense_codes')
            ->leftjoinSub($all, 'all', function ($join) {
                $join->on('all.expense_code_id' , '=' , 'expense_codes.expense_code_id');
            })
            ->where('expense_codes.expense_code_id' , '<>' , 8)
            ->groupBy('expense_codes.expense_code_id')
            ->selectRaw('
                m_id ,
                d_id ,
                group_concat( case when from_type = "delegate_petty" then d_id end) as petty_ids ,
                group_concat( case when from_type = "multi_voucher" then d_id end) as multi_ids ,
                clearance_id ,
                expense_codes.expense_code_id ,
                expense_codes.name_'.$lang.' as expense_code_name ,
                group_concat(ifnull( receipt_number , "-" )) as receipt_number ,
                ifnull( sum(amount) , 0 ) as amount ,
                description ,
                all.add_date
            ')
            ->get();


        $count = $this->return['clearance_m']->container_count ?? 0;

        $revenues = collect( Revenue::all_revenues( ['lang' => $lang , 'active' => 1 ] ) )->groupBy('id')->all();



        if(DB::table('clearance_invoices_m')->where('clearance_id' , $clearance_id )->where('invoice_active' , 1 )->count() == 0  ){
            $prices = DB::table('customer_prices')
                ->where('customer_id' , $this->return['clearance_m']->customer_id)
                ->where('port_id' , $this->return['clearance_m']->port_id )
                ->first();

            if(!$prices){

                $prices = (object) array();
                $prices->cont_s_first   = $prices->cont_s_first ?? 0;
                $prices->cont_s_sec     = $prices->cont_s_sec ?? 0;
                $prices->cont_s_other   = $prices->cont_s_other ?? 0;
                $prices->cont_b_first   = $prices->cont_b_first ?? 0;
                $prices->cont_b_sec     = $prices->cont_b_sec ?? 0;
                $prices->cont_b_other   = $prices->cont_b_other ?? 0;
                $prices->loading_type   = $prices->loading_type ?? 0;
                $prices->loading_price  = $prices->loading_price ?? 0;
                $prices->translate_type = $prices->translate_type ?? 0;
                $prices->translate_price= $prices->translate_price ?? 0;
                $prices->other_type     = $prices->other_type ?? 0;
                $prices->other_price    = $prices->other_price ?? 0;

                if(in_array(request()->header('clientID') , ['trans' , 'amwag'] )){
                    $this->return = trans('main.no_prices_found');
                    return false;
                }
            }


            if( isset($revenues[1]) ){


                if($this->return['clearance_m']->is_lcl){
                    $t = $prices->cont_s_first;
                }else{
                    $count_s = $this->return['clearance_m']->container_small;
                    $count_b = $this->return['clearance_m']->container_big;
                    $amount_s = ( ($count_s > 0? $prices->cont_s_first : 0 ) ) + ( ( ($count_s - 1) > 0? $prices->cont_s_sec : 0)  ) + ( ( ($count_s - 2) > 0? (($count_s - 2) * $prices->cont_s_other) : 0) );
                    $amount_b = ( ($count_b > 0? $prices->cont_b_first : 0 ) ) + ( ( ($count_b - 1) > 0? $prices->cont_b_sec : 0)  ) + ( ( ($count_b - 2) > 0? (($count_b - 2) * $prices->cont_b_other) : 0) );
                    $t        = $amount_s+$amount_b;
                }
                $this->return['amounts'][] = [
                    'revenue_id'        => 1,
                    'name_ar'           => $revenues[1][0]->revenue_name_ar ,
                    'name_en'           => $revenues[1][0]->revenue_name_en ,
                    'amount_without_vat'=> $t ,
                    'vat_per'           => 15 ,
                    'vat_amount'        => $t * 0.15  ,
                    'amount_with_vat'=> $t + ($t * 0.15 )
                ];

            }

            if( isset($revenues[2]) ){

                $loading_amount = ( $prices->loading_type == 1? $prices->loading_price:($count*$prices->loading_price) );
                $this->return['amounts'][] = [
                    'revenue_id'        => 2,
                    'name_ar'           => $revenues[2][0]->revenue_name_ar ,
                    'name_en'           => $revenues[2][0]->revenue_name_en ,
                    'amount_without_vat'=> $loading_amount ,
                    'vat_per'           => 15 ,
                    'vat_amount'        => $loading_amount * 0.15  ,
                    'amount_with_vat'=> $loading_amount + ($loading_amount * 0.15 )
                ];

            }

            if( isset($revenues[3]) ){

                $trans_amount = ( $prices->translate_type == 1? $prices->translate_price:($count*$prices->translate_price) );
                $this->return['amounts'][] = [
                    'revenue_id'        => 3,
                    'name_ar'           => $revenues[3][0]->revenue_name_ar ,
                    'name_en'           => $revenues[3][0]->revenue_name_en ,
                    'amount_without_vat'=> $trans_amount ,
                    'vat_per'           => 15 ,
                    'vat_amount'        => $trans_amount * 0.15  ,
                    'amount_with_vat'=> $trans_amount + ($trans_amount * 0.15 )
                ];

            }

            if( isset($revenues[4]) ){

                $other_amount = ( $prices->other_type == 1? $prices->other_price:($count*$prices->other_price) );
                $this->return['amounts'][] = [
                    'revenue_id'        => 4,
                    'name_ar'           => $revenues[4][0]->revenue_name_ar ,
                    'name_en'           => $revenues[4][0]->revenue_name_en ,
                    'amount_without_vat'   => $other_amount ,
                    'vat_per'           => 15 ,
                    'vat_amount'        => $other_amount * 0.15  ,
                    'amount_with_vat'=> $other_amount + ($other_amount * 0.15 )
                ];
            }


            if( isset($revenues[5]) ){

                $trans_price = 0;

                if($this->return['clearance_m']->is_lcl == 1 ){

                    $trans_price = 0;

                }else{

                    foreach ($this->return['clearance_d'] as $key => $row) {
                        $price = DB::table('customer_transport_prices')
                            ->where('port_id' , $this->return['clearance_m']->port_id)
                            ->where('from_area_id' , $row->from_area)
                            ->where('to_area_id' , $row->to_area)
                            ->select('price' , 'container_20' , 'container_40')
                            ->first();

                        if($row->container_size == 40 ){
                            $size_price = $price->container_40 ?? 0 ;
                        }else{
                            $size_price = $price->container_20 ?? 0 ;
                        }
                        $trans_price = $trans_price + ( $size_price ) ;

                    }
                }

                $this->return['amounts'][] = [
                    'revenue_id'        => 5,
                    'name_ar'           => $revenues[5][0]->revenue_name_ar ,
                    'name_en'           => $revenues[5][0]->revenue_name_en ,
                    'amount_without_vat'=> $trans_price ,
                    'vat_per'           => 15 ,
                    'vat_amount'        => $trans_price * 0.15 ,
                    'amount_with_vat'=> $trans_price + ($trans_price * 0.15)
                ];

            }


            foreach ($revenues as $key => $revenue) {

                if($revenue[0]->id > 5 ){
                    $this->return['amounts'][] = [
                        'revenue_id'        => $revenue[0]->id ,
                        'name_ar'           => $revenue[0]->revenue_name_ar ,
                        'name_en'           => $revenue[0]->revenue_name_en ,
                        'amount_with_vat'   => 0 ,
                        'vat_per'           => 15 ,
                        'vat_amount'        => 0 ,
                        'amount_without_vat'=> 0
                    ];
                }

            }


        }else{

            foreach ($revenues as $key => $revenue) {

                $this->return['amounts'][] = [
                    'revenue_id'        => $revenue[0]->id ,
                    'name_ar'           => $revenue[0]->revenue_name_ar ,
                    'name_en'           => $revenue[0]->revenue_name_en ,
                    'amount_with_vat'   => 0 ,
                    'vat_per'           => 15 ,
                    'vat_amount'        => 0 ,
                    'amount_without_vat'=> 0
                ];

            }

        }





        return true;


    }

    public function get_invoice_attachment($lang,$invoice_id,Request $request){
        $this->checkPermission('04-012','view');
        $type = $request->type ?? null;
        if(isset($type) && $type == "invoice"){
            $clearance_id             = ClearanceInvoice::get_invoice($invoice_id, $lang)->clearance_id;
            $invoice_attachments = ClearanceInvoice::invoice_attachments($lang , $invoice_id);
        }elseif(isset($type) && $type == "claim"){
            $clearance_id             = ClearanceInvoiceClaim::get_invoice($invoice_id, $lang)->clearance_id;
            $invoice_attachments = ClearanceInvoiceClaim::invoice_attachments($lang , $invoice_id);
        }elseif(isset($type) && $type == "draft"){
            $clearance_id             = ClearanceInvoiceDraft::get_invoice($invoice_id, $lang)->clearance_id;
            $invoice_attachments = ClearanceInvoiceDraft::invoice_attachments($lang , $invoice_id);
        }else{
            $clearance_id             = ClearanceInvoice::get_invoice($invoice_id, $lang)->clearance_id;
            $invoice_attachments = ClearanceInvoice::invoice_attachments($lang , $invoice_id);
        }

        $clearance                  = Clearance::get_clearance($clearance_id , $lang);
        $delegate_petty_attachment  = ClearanceInvoice::delegate_petty_attachment($lang,$clearance_id);
        $clearance_attachment       = ClearanceInvoice::clearance_attachment($lang,$clearance_id);
        $multi_voucher_attachment   = Clearance::multi_voucher_attachment($lang , $clearance_id);

        $this->return = $delegate_petty_attachment->merge($clearance_attachment)->merge($multi_voucher_attachment)->merge($invoice_attachments);
        $this->return[] = (object) ['file_name' => 'customs_declaration_file' , 'file_path' => $clearance->customs_declaration_file ?? null , 'id' => 0 , 'type_attachment' => 'customs_declaration_file'  ];
        $this->return[] = (object) ['file_name' => 'final_note_file' , 'file_path' => $clearance->final_note_file  ?? null , 'id' => 0 , 'type_attachment' => 'final_note_file' ];

        foreach ($this->return as $key => $value) {
            if($this->return[$key]->file_path == null)
                unset($this->return[$key]);
        }

        $this->return = array_values( collect($this->return)->toArray() );


        return $this->sendResponse($this->return);

    }

    public function download_attachment($lang, $id, Request $request)
    {
        $this->checkPermission('04-012','view');
        $type_attachment = $request->type_attachment ?? null;
        switch ($type_attachment) {
            case 'clearance_attachment':
                $file = DB::table('clearance_attachments')
                ->where('clearance_attachments.clearance_attachment_id',$id)
                ->value('file_path');
                break;

            case 'delegate_attachment':
                $file = DB::table('delegate_petty_d')
                ->where('delegate_petty_d.delegate_petty_d_id',$id)
                ->value('file_path');
                break;

            case 'multi_voucher_attachments':
                $file = DB::table('multi_voucher_d')
                ->where('multi_voucher_d.multi_voucher_d_id',$id)
                ->value('attachment');
                break;

            case 'invoice_attachment':
                $file = DB::table('invoice_attachments')
                ->where('invoice_attachments.id',$id)
                ->value('file_path');
                break;

            default:
                 return $this->sendError('404 File not found ', '');
                break;
        }

        if (file_exists(public_path($file ?? ''))) {
            return response()->download(public_path($file ?? ''));
        }else{
            return $this->sendError('404 File not found ', '');
        }

    }

    public function send_clearance_invoice($lang, $id, Request $request){

        $this->checkPermission('04-012','view');
        $data['master']      = ClearanceInvoice::get_invoice($id, $lang);
        $data['logo']        = Branch::get_branch($data['master']->clearance_branch_id  , $lang)->branch_image;

        $customer_contacts         = $request['customer_contacts'] ?? '';
        if(!is_array($customer_contacts)){
            $customer_contacts = [$customer_contacts];
        }

        $request->merge([
            'with_attachments'      => intval($request['is_attachment']) ,
            'clearance_attachments'  => intval($request['clearance_attachments']) ?? 0 ,
            'type'              => 'save_pdf_file',
            'print_temp'        => Setting::get_main_setting_by_code('clearance_invoice_mail_print')->value ?? 'temp_1' ,
            'clientID'          => request()->header('clientID')
            ]);


        // $x = (new ClearanceInvoiceHelper)->attachments_image($id , 'invoice' , 1 , $request['with_attachments'] ?? 0 , $request['clearance_attachments'] ?? 0);

        // return $this->sendError('404 File not found ', $x );


        $invoice    = $this->print($id,$request);
        $email_temp = 'Print.clearance.invoice.'.(Setting::get_main_setting_by_code('clearance_body_mail_print')->value ?? 'temp_1');

        $emails = DB::table('cc_mails')
            ->whereRaw('FIND_IN_SET("invoice", screens)')
            ->get()
            ->toArray();

        $subject = "INV-".$data['master']->id." BL-".$data['master']->shipping_policy_no." BAYAN-".$data['master']->customs_declaration_number." FILE-".$data['master']->clearance_id;


        $response   = Mail::send($email_temp ,[ 'data' => $data], function ($message) use ($subject,$customer_contacts,$emails,$invoice,$id) {

            foreach ($customer_contacts as $email) {
                if( !filter_var($email, FILTER_VALIDATE_EMAIL) ){
                    continue;
                }
                $message->to($email);
            }

            foreach ($emails as $item) {
                if( !filter_var($item->email, FILTER_VALIDATE_EMAIL) ){
                    continue;
                }
                switch ($item->mail_type) {
                    case 'to':
                        $message->to($item->email);
                    break;
                    case 'cc':
                        $message->cc($item->email);
                    break;
                    case 'bcc':
                        $message->bcc($item->email);
                    break;
                }
            }
            // $message->cc(env("MAIL_CC_ADDRESS"));
            $message->subject($subject);
            $message->attach(public_path($invoice));

        });

        // insert log
        DB::table('invoices_sent_logs')->insert([
            'invoice_id'  => $id,
            'add_user'    => auth()->user()->id,
            'type'        => 'email',
            'data'        => json_encode($request->all()),
            'response'    => isset($response) ? json_encode($response) : null
        ]);
        return $this->sendResponse( $response ?? [] , trans('main.send mail success') );

    }

    public function send_clearance_invoice_whats($lang, $id, Request $request){

        $this->checkPermission('04-012','view');
        if( !(new WhatsAppHelper)->check_has_whatsapp() ) {
            return $this->sendError('Whats not installed');
        }
        $invoice_data   = ClearanceInvoice::get_invoice($id, $lang);
        $mobiles        = $request['customer_contacts'] ?? '';

        $request->merge([
            'with_attachments'      => intval($request['is_attachment']) ,
            'clearance_attachments'  => intval($request['clearance_attachments']) ?? 0 ,
            'type'                  => 'save_pdf_file_url',
            'print_temp'            => Setting::get_main_setting_by_code('invoice_whats')->value ?? 'temp_1' ,
            'clientID'              => request()->header('clientID')
            ]);
        $invoice = $this->print($id , $request);

        // return $invoice;
        // $invoice        = url('/export_clearance_invoice/'.$invoice_data->invoice_uuid.'?type=save_pdf_file&with_attachments='.$request['is_attachment'].'&print_temp=invoice_whats_buraq&clientID='.request()->header('clientID'));

        if(!is_array($mobiles)){
            $mobiles = [$mobiles];
        }

        if(!isset($mobiles[0]) || strlen($mobiles[0]) < 8){
            return $this->sendError(trans('error.customer_dont_have_mobile_number'));
        }

        foreach($mobiles as $mobile){

            $reposnse = (new WhatsAppHelper)->wa_line(array('type'=>'media','message' => $id , 'media_url'=> $invoice,'phone'=> $mobile));
            if($reposnse->status == "error" ){
                return $this->sendError($reposnse->message);
            }

        }

        // unlink(public_path('/temp/buraq_1/invoices_pdf/invoice_4473.pdf'));
        // insert log
        DB::table('invoices_sent_logs')->insert([
            'invoice_id'  => $id,
            'add_user'    => auth()->user()->id,
            'type'        => 'whats',
            'data'        => json_encode($request->all()),
            'response'    => isset($response) ? json_encode($response) : null
        ]);
        return $this->sendResponse( $reposnse ?? [] , trans('main.send message success') );
    }
    public function upload_attachment($lang , $id , Request $request){
        $this->checkPermission('04-012','edit');
        $item = $request->all();
        $file_name = $item['file_name'] ?? date('Y-m-d H:i:s');

        $check  = (new Upload)->uploadFile($item['file'] , 'invoice_attachments' , $file_name);
        if(!$check['check'])
            return $this->sendError( trans('error.add_fails') , $check['msg'] );

        $insert = [
            'invoice_id'        => $id ,
            'invoice_type'      =>'invoice' ,
            'file_name'         => $file_name ,
            'file_path'         => $check['url'] ,
            'add_user'          => auth()->user()->id ,
        ];
        $rules = [
            'file_name' => 'required|string|unique:invoice_attachments'
        ];
        $validator  = validator()->make( $insert , $rules );
        if($validator->fails())
        {
            return $this->sendError( trans('error.add_fails') , $validator->errors() );
        }
        $this->return['id']  = DB::table('invoice_attachments')->insertGetId($insert);

        return $this->sendResponse( $this->return );
    }
    public function download_all_attachments($lang , $id , Request $request){

        // $this->checkPermission('04-012','view');
        $type = $request->type ?? null;
        if(isset($type) && $type == "invoice"){
            $clearance_id             = ClearanceInvoice::get_invoice($id, $lang)->clearance_id;
            $invoice_attachments = ClearanceInvoice::invoice_attachments($lang , $id);
        }elseif(isset($type) && $type == "claim"){
            $clearance_id           = ClearanceInvoiceClaim::get_invoice($id, $lang)->clearance_id;
            $invoice_attachments    = ClearanceInvoiceClaim::invoice_attachments($lang , $id);
        }elseif(isset($type) && $type == "draft"){
            $clearance_id           = ClearanceInvoiceDraft::get_invoice($id, $lang)->clearance_id;
            $invoice_attachments    = ClearanceInvoiceDraft::invoice_attachments($lang , $id);
        }else{
            $clearance_id           = ClearanceInvoice::get_invoice($id, $lang)->clearance_id;
            $invoice_attachments    = ClearanceInvoice::invoice_attachments($lang , $id);
        }
        $clearance  = Clearance::get_clearance($clearance_id , $lang);
        $clearance_attachments      = DB::table('clearance_attachments')
            ->where('clearance_id', $clearance_id)
            ->pluck('file_path')->toArray();

            $delegate_petty_attachment  = ClearanceInvoice::delegate_petty_attachment($lang,$clearance_id);
            $multi_voucher_attachment   = ClearanceInvoice::multi_voucher_attachment($lang,$clearance_id);
            $delegate_petty_attachment_files    = collect($delegate_petty_attachment)->pluck('file_path')->toArray();
            $multi_voucher_files                = collect($multi_voucher_attachment)->pluck('attachment')->toArray();
            $invoice_attachments_files = collect($invoice_attachments)->pluck('file_path')->toArray();
            $files = array_merge($clearance_attachments, $delegate_petty_attachment_files, $multi_voucher_files ,$invoice_attachments_files);

        if(strlen($clearance->customs_declaration_file) > 10){
            $files[] = $clearance->customs_declaration_file;
        }

        if(strlen($clearance->final_note_file) > 10){
           $files[] = $clearance->final_note_file;
        }

        if (empty($files)) {
            return $this->sendError('No files found for this clearance.', '' , 404);
        }

        $zip = new \ZipArchive();
        $zipFileName = 'attachments-' . $id . '.zip';
        $zipFilePath = public_path($zipFileName);

        if ($zip->open($zipFilePath, \ZipArchive::CREATE) === TRUE) {
            foreach ($files as $file) {
                if($file == null){
                    continue;
                }
                $filePath = public_path($file);
                if (file_exists($filePath)) {
                    // Add files to zip
                    $zip->addFile($filePath, basename($file));
                } else {
                    // Optionally log missing files
                    \Log::warning("File not found: $filePath");
                }
            }
            $zip->close();
        } else {
            return $this->sendError('Could not create a zip file.', '');
        }

        // Check if the zip file has been created and has files
        if (file_exists($zipFilePath) && filesize($zipFilePath) > 0) {
            return response()->download($zipFilePath)->deleteFileAfterSend(true);
        } else {
            return $this->sendError('Failed to download the zip file or zip file is empty.', '');
        }

    }
    public function delete_attachment($lang , $id){
        $this->checkPermission('04-012','edit');

        $attachment = DB::table('invoice_attachments')->where('id',$id)->first();

        if (!$attachment) {
            return response()->json(['message' => 'File not found'], 404);
        }

        // Delete the file from storage
        if (Storage::exists($attachment->file_path)) {
            Storage::delete($attachment->file_path);
        }

        // Delete the record from the database
        DB::table('invoice_attachments')->where('id',$id)->delete();

        return $this->sendResponse( $this->return  , trans('main.delete_success'));
    }
}
