<?php

namespace App\Http\Controllers\API\V1\Sales;
use App\Http\Controllers\API\V1\BaseController;
use App\Models\Sales\Revenue;
use Illuminate\Http\Request;
use App\Models\Finance\AccountTree;
use App\Models\Main\ScreenSub;



use DB;
use Illuminate\Support\Arr;

class RevenueController extends BaseController
{
    protected $return = array();
    protected $filter = array();

    public function index($lang , Request $request)
    {
    //     if(request()->header('Clientid') == "amwaj"){

    //     $all = DB::table('clearances_m')->get();
    //     foreach ($all as $key => $row) {
    //         $clearance_trips = DB::table('clearances_d')
    //         ->leftjoin('arabdivs_trans.trips' , function($join) {
    //             $join->on('arabdivs_trans.trips.clearance_d_id' , '=' , 'clearances_d.clearances_d_id')
    //                 ->where('arabdivs_trans.trips.trip_active' , 1);

    //         })
    //         ->where('clearances_d.clearances_m_id' , $row->clearance_id )
    //         ->groupBy('clearances_d.clearances_d_id')
    //         ->selectRaw('
    //             clearances_d.clearances_d_id ,
    //             IFNULL(arabdivs_trans.trips.trip_id , 0) as trip_id
    //         ')->get();
    //         $check = true;
    //         foreach($clearance_trips as $item){
    //             if($item->trip_id == 0){
    //                 $check = false;
    //                 break;
    //             }
    //         }
    //         if($check){
    //             DB::table('clearances_m')
    //                 ->where('clearance_id',$row->clearance_id )
    //                 ->update(array('clearance_status_id'=>6));
    //         }
    //     }
    // }

//        $this->checkPermission('03-025','view');
        $this->filter = array(
            'lang'        => $lang ,
            'active'      => $request['active'] ?? 1 ,
            'rows'        => $request['rows'] ?? null ,
            'page'        => $request['page'] ?? 1 ,
            'word'        => $request['word'] ?? null
        );

        $this->return['screen_name'] = ScreenSub::get_screen_sub_by_screen_code('03-025' , $lang)->sub_title ?? '';
        $this->return['items']       = Revenue::all_revenues( $this->filter );

        return $this->sendResponse( $this->return );
    }

    public function create($lang , Request $request)
    {
        $this->checkPermission('03-025','add');
        $this->return['account_tree']   = AccountTree::active_account_trees($lang , array('account_type' => 2 , 'active' => 1 ));
        $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('03-025' , $lang)->sub_title ?? '';
        return $this->sendResponse( $this->return  );
    }

    public function store($lang , Request $request)
    {
        $this->checkPermission('03-025','add');
        $insert = $request->only(['revenue_name_ar', 'revenue_name_en', 'account_tree_id']);


        $validator = validator()->make( $insert , Revenue::$rules );
        if($validator->fails())
        {
            return $this->sendError( trans('error.add_fails') , $validator->errors() );
        }


        $insert['add_user'] = auth()->user()->id;
        $this->return['id'] = Revenue::add_revenue($insert);

        return $this->sendResponse( $this->return , trans('main.add_success') );
    }




    public function show($lang , $id , Request $request)
    {
        $this->checkPermission('03-025','view');

        $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('03-025' , $lang)->sub_title ?? '';
        $this->return['account_tree']   = AccountTree::active_account_trees($lang , array('account_type' => 2 , 'active' => 1 ));
        $this->return['data']           = Revenue::get_revenue($id,$lang);

        return $this->sendResponse( $this->return , '' );
    }

    public function update($lang , $id , Request $request)
    {
        $this->checkPermission('03-025','edit');

        $update = $request->only(['revenue_name_ar', 'revenue_name_en', 'account_tree_id']);

        $rules            = Revenue::$rules;
        $validator  = validator()->make( $update , $rules );
        if($validator->fails())
        {
            return $this->sendError( trans('error.add_fails') , $validator->errors() );
        }

        Revenue::update_revenue($update ,  $id );

        return $this->sendResponse( $this->return , trans('main.update_success') );
    }

    public function toggle_active($lang, $id)
    {
        $revenue = Revenue::find($id);

        if($revenue->revenues_active){
            $this->checkPermission('03-025','delete');

            Revenue::delete_revenue($id);
            $this->return['active'] = false;
        }else{
            $this->checkPermission('03-025','edit');

            Revenue::update_revenue(array('revenues_active' => 1), $id);
            $this->return['active'] = true;
        }

        return $this->sendResponse($this->return, trans('main.update_success'));
    }
    public function destroy($lang , $id)
    {
        $this->checkPermission('03-025','delete');

        Revenue::delete_revenue($id);

        return $this->sendResponse( [] , trans('main.delete_success') );
    }




}
