<?php

namespace App\Http\Controllers\API\V1\Trans;
use App\Http\Controllers\API\V1\BaseController;
use App\Models\Sales\Clearance;
use App\Models\Trans\Agent;
use Illuminate\Http\Request;

use App\Classes\Trans\TripsHelper;


use App\Models\Finance\AccountTree;
use App\Models\Trans\Trip;
use App\Models\Trans\Area;
use App\Models\Trans\Driver;
use App\Models\Sales\Customer;
use App\Models\Trans\Port;
use App\Models\Trans\Wearhouse;
use App\Models\Trans\Car;
use App\Models\Main\Branch;


use App\Models\Main\ScreenSub;
use App\Models\Trans\AreaPrice;
use App\Models\User;
use Illuminate\Support\Facades\DB;

class TripController extends BaseController
{
    protected $return = array();
    protected $filter = array();

    public function check_clearance_trip($lang , Request $request){

        $this->return['count']  = DB::table('trips')
            ->where('clearance_d_id' , $request['clearance_d_id'])
            ->where('clearance_m_id' , $request['clearance_m_id'])
            ->where('trip_active' , 1 )
            ->count();

        return $this->sendResponse( $this->return );
    }

    public function index($lang , Request $request)
    {
        $this->checkPermission('03-007','view');

        $this->filter = array(
            'lang'        => $lang ,
            'active'      => $request['active'] ?? 1 ,
            'customer'    => $request['customer'] ?? null ,
            'rows'        => $request['rows'] ?? null ,
            'page'        => $request['page'] ?? 1 ,
            'word'        => $request['word'] ?? null ,
            'port_id'     => $request['port_id'] ?? null ,
            'branch_id'   => $request['branch_id'] ?? $this->data['current_branch']
        );

        $this->return['screen_name'] = ScreenSub::get_screen_sub_by_screen_code('03-007' , $lang)->sub_title ?? '';
        $this->return['items']       = Trip::all_trips( $this->filter );
        $this->return['ports']       = Port::all_ports( ['active' => 1 , 'lang' => $lang ] );



        // $all = DB::table('trips')
        //     ->where('customer_id' , 2)
        //     ->get();

        // foreach($all as $row){
        //     $customer_id = DB::connection('other_mysql')->table('clearances_m')
        //         ->where('clearance_id',$row->clearance_m_id)
        //         ->first()->customer_id ?? 0;

        //     DB::table('trips')
        //         ->where('trip_id' , $row->trip_id)
        //         ->update(['customer_id' => $customer_id]);




        // }

        // return $this->sendResponse( $all );


        return $this->sendResponse( $this->return );
    }

    public function create($lang , Request $request)
    {
        $this->checkPermission('03-007','add');

        $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('03-007' , $lang)->sub_title ?? '';
        $this->return['areas']          = Area::all_areas( ['active' => 1 , 'lang' => $lang] );
        $this->return['drivers']        = Driver::all_drivers( ['active' => 1 , 'lang' => $lang] );
        $this->return['customers']      = Customer::all_customers( ['active' => 1 , 'lang' => $lang] );
        $this->return['ports']          = Port::all_ports( ['active' => 1 , 'lang' => $lang  , 'branch'=> $this->data['current_branch']] );
        $this->return['cars']           = Car::all_cars( ['active' => 1 , 'lang' => $lang] );
        $this->return['wearhouses']     = Wearhouse::all_wearhouses( ['active' => 1 , 'lang' => $lang] );
        $this->return['branchs']        = Branch::all_branchs( ['active' => 1 , 'lang' => $lang , 'user' => auth()->user()->id] );
        $this->return['agents']         = Agent::all_agents( ['active' => 1 , 'lang' => $lang] );


        return $this->sendResponse( $this->return  );
    }
    public function get_area_prices($lang , Request $request){

        $this->filter = array(
            'lang'        => $lang ,
            'active'      => 1 ,
            'from_area'   => $request['from_area'] ?? null ,
            'to_area'     => $request['to_area'] ?? null ,
            'active'      => $request['active'] ?? 1 ,
            'rows'        => $request['rows'] ?? null ,
            'page'        => $request['page'] ?? 1 ,
            'word'        => $request['word'] ?? null
        );

        $this->return['screen_name'] = ScreenSub::get_screen_sub_by_screen_code('03-006' , $lang)->sub_title ?? '';
        if($request['clearrance_id'] > 0  ){
            // $trip_discount_percentage = DB::table('settings')->where('setting_code' , 'trip_discount_percentage')->value('value') ?? 100;
            // $customer_id = DB::connection('other_mysql')->table('clearances_m')->where('clearance_id' ,$request['clearrance_id'] )->value('customer_id');
            // $this->return['items']         = DB::connection('other_mysql')->table('customer_transport_prices')
            //     ->leftjoin('ports' , 'customer_transport_prices.port_id' , '=' , 'ports.port_id')
            //     ->leftjoin('areas as from_areas' , 'customer_transport_prices.from_area_id' , '=' , 'from_areas.area_id')
            //     ->leftjoin('areas as to_areas' , 'customer_transport_prices.to_area_id' , '=' , 'to_areas.area_id')
            //     ->where('from_area_id' , '=' , $request['from_area'] )
            //     ->where('to_area_id' , '=' , $request['to_area'] )
            //     ->where('customer_transport_prices.customer_id' , '=' , $customer_id)
            //     ->selectRaw('
            //         ports.port_id ,
            //         ports.port_name_'.$lang.' as port_name ,

            //         from_area_id  ,
            //         from_areas.area_name_'.$lang.' as from_area_name ,
            //         to_area_id ,
            //         to_areas.area_name_'.$lang.' as to_area_name ,

            //         ifnull(price , 0) as trip_price ,
            //         container_20 ,
            //         container_40,
            //         ifnull(price_special , 0) as price_special ,
            //         container_40_special ,
            //         container_20_special
            //     ')->get();
            // if(!isset($this->return['items'])){
            //     return $this->sendError(trans('error.no_area_price_for_this_customer'));
            // }
            // foreach($this->return['items'] as $item){
            //     $item->driver_price = DB::table('area_prices')
            //     ->where('from_area_id'  , $request['from_area'])
            //     ->where('to_area_id'    , $request['to_area'])
            //     ->where('area_price_active' , 1)->value('driver_price_in') ?? 0;
            //     $item->trip_price = $item->trip_price * (intval($trip_discount_percentage)/100);
            // }


            $this->return['items'] = AreaPrice::all_area_prices( $this->filter);



        }else{
            $this->return['items'] = AreaPrice::all_area_prices( $this->filter);
        }
        return $this->sendResponse( $this->return  );

    }
    public function store($lang , Request $request)
    {
        $this->checkPermission('03-007','add');
        $insert = $request->only([
            'clearance_m_id' ,
            'clearance_d_id' ,
            'customer_id',
            'driver_id' ,
            'car_id' ,
            'container_number',
            'container_size',
            'is_empty',
            'customer_name',
            'customer_vat_number' ,
            'trip_road' ,
            'trip_type' ,
            'from_port_id' ,
            'from_wearhouse_id' ,
            'from_area_id' ,
            'to_port_id' ,
            'to_wearhouse_id' ,
            'to_area_id' ,
            'final_dest_id' ,
            'trip_date' ,
            'related_trans_date',
            'car_number' ,
            'driver_price' ,
            'trip_price' ,
            'total_price' ,
            'to_agent_id',
            'company_bears_expenses',
        ]);
        //check container holding
        $is_hols = DB::connection('other_mysql')->table('clearances_d')->where('clearances_d_id',$insert['clearance_d_id'])->value('is_hold');

        if(isset($insert['clearance_m_id']) && $insert['clearance_m_id'] > 0 ){
            $clearance = DB::connection('other_mysql')->table('clearances_m')->where('clearance_id',$insert['clearance_m_id'])->first();
            $insert['customer_id'] = $clearance->customer_id ?? $insert['customer_id'];
        }

        if($is_hols == 1){
            return $this->sendError( trans('error.container_is_holding') );
        }

        $validator = validator()->make( $insert , Trip::$rules );
        if($validator->fails())
        {
            return $this->sendError( trans('error.add_fails') , $validator->errors() );
        }

        $insert['add_user']     = auth()->user()->id;
        $insert['branch_id']    = $this->data['current_branch'];

        if( isset($insert['clearance_m_id'] ) && $insert['clearance_m_id'] > 0 && $insert['clearance_d_id'] > 0 ){

            $check = DB::table('trips')
                ->where('clearance_m_id' , $insert['clearance_m_id'])
                ->where('trip_road' , $insert['trip_road'])
                ->where(function($where) use($insert){
                    $where->where('clearance_d_id' , $insert['clearance_d_id'])
                        ->orWhere('container_number' , $insert['container_number']);
                })
                ->where('trip_active' , 1 )
                ->count();

            if($check > 0 ){
                return $this->sendError( trans('error.dublicate_trip') , [] );
            }

        }
        $is_lcl = optional(Clearance::get_clearance($insert['clearance_m_id']))->is_lcl;

        if(isset($is_lcl) && $is_lcl == 1){
            $insert['container_number'] = $insert['clearance_m_id'].'-LCL';
        }

        DB::beginTransaction();
        DB::table('trips')->lockForUpdate()->get();
        $insert['trip_id'] = (Trip::max('trip_id')+1);

        $insert['driver_price'] = doubleval($insert['driver_price'] ?? 0 );
        $this->return['id'] = Trip::add_trip($insert);

        $driver = Driver::get_driver($insert['driver_id'] , 'ar');
        $car    = Car::get_car($insert['car_id'] , 'ar');

        $clearance  = DB::connection('other_mysql')->table('clearances_m')
                ->where('clearance_id' , $request->clearance_m_id )
                ->first();

        // $clearance = Clearance::get_clearance($request->clearance_m_id,$lang);
        $is_box = (isset($clearance->is_lcl) && $clearance->is_lcl == 1 )? 1 : 0 ;

        if(($insert['trip_road'] == 1 && $insert['clearance_d_id'] > 0) || ($insert['trip_road'] == 2 && $insert['clearance_d_id'] > 0)){
            DB::connection('other_mysql')->table('clearances_d')
            ->where('clearances_d_id' , $insert['clearance_d_id'])
            ->update(['container_trip_id' => $this->return['id']]);
        }
        if($insert['trip_road'] == 1){
            $seed = [
                'in_trip_id'                => $this->return['id'] ,
                'branch_id'                 => $insert['branch_id'] ,
                'transaction_type'          => 1 ,
                'is_box'                    => $is_box ,
                'is_empty'                  => $insert['is_empty'] ?? 0 ,
                'clearance_m_id'            => $insert['clearance_m_id'] ?? 0 ,
                'clearance_d_id'            => $insert['clearance_d_id'] ?? 0 ,
                'customer_id'               => $insert['customer_id'] ?? 0 ,
                'wearhouse_id'              => $insert['to_wearhouse_id'] ,
                'in_driver_residency_number'=> $driver->residency_number ?? '',
                'in_driver_name'            => $driver->name ?? '',
                'in_driver_mobile'          => $driver->mobile ?? '' ,
                'in_car_number'             => $car->name ?? '' ,
                'code_number'               => $this->return['id']."-".( $insert['clearance_m_id'] ?? "t_n" )."-".( $insert['clearance_d_id'] ?? "c_n" )
            ];
            DB::table('wearhouse_transactions')->insert($seed);
            if($insert['clearance_d_id'] > 0 && $insert['final_dest_id'] > 0){
                DB::connection('other_mysql')->table('clearances_d')
                ->where('clearances_d_id' , $insert['clearance_d_id'])
                ->update(['dest_id'=>$insert['final_dest_id']]);
            }
        }
        if(in_array($insert['trip_road'] , [2,3]) && $insert['to_area_id'] > 0 && $insert['clearance_d_id'] > 0){
            DB::connection('other_mysql')->table('clearances_d')
            ->where('clearances_d_id' , $insert['clearance_d_id'])
            ->update(['dest_id' => $insert['to_area_id']]);
        }

        if($insert['trip_road'] <= 2){
            $seed = [
                'trip_id'               => $this->return['id'] ,
                'container_status_id'   => ($insert['trip_road'] == 1 ? 1 : 3) ,
                'clearance_m_id'        => $insert['clearance_m_id'] ?? 0  ,
                'clearance_d_id'        => $insert['clearance_d_id'] ?? 0  ,
                'customer_id'           => $insert['customer_id'] ,
                'code_number'           => $this->return['id']."-".( $insert['transaction_number'] ?? "t_n" )."-".( $insert['container_number'] ?? "c_n" ) ,
                'in_date'               => $insert['related_trans_date'] ?? date("Y-m-d H:i:s")
            ];
            DB::table('containers')->insert($seed);

        }


        if($insert['trip_road'] == 3 && isset($request['warehouse_transaction_id']) && $request['warehouse_transaction_id'] > 0 ){

            DB::table('wearhouse_transactions')
                ->where('wearhouse_transaction_id' , $request['warehouse_transaction_id'])
                ->update(
                    [
                        'status'                        => 3 ,

                        'out_trip_id'                   => $this->return['id'] ,
                        'out_driver_residency_number'   => $driver->residency_number ?? '',
                        'out_driver_name'               => $driver->name ?? '',
                        'out_driver_mobile'             => $driver->mobile ?? '' ,
                        'out_car_number'                => $car->name ?? '' ,

                        'out_date'                      => $insert['related_trans_date'] ?? date("Y-m-d H:i:s"),
                        'out_user'                      => auth()->user()->id ,
                        'out_notes'                     => 'تم اشاء رحله رقم #'.$this->return['id']
                    ]
                );

        }

        if($insert['trip_road'] == 4){
            $seed = [
                'in_trip_id'                => $this->return['id'] ,
                'branch_id'                 => $insert['branch_id'] ,
                'transaction_type'          => 1 ,
                'is_box'                    => $is_box ,
                'is_empty'                  => $insert['is_empty'] ?? 0 ,

                'clearance_m_id'            => $insert['clearance_m_id'] ?? 0 ,
                'clearance_d_id'            => $insert['clearance_d_id'] ?? 0 ,
                'customer_id'               => $insert['customer_id'] ?? 0 ,
                'wearhouse_id'              => $insert['to_wearhouse_id'] ,
                'in_driver_residency_number'=> $driver->residency_number ?? '',
                'in_driver_name'            => $driver->name ?? '',
                'in_driver_mobile'          => $driver->mobile ?? '' ,
                'in_car_number'             => $car->name ?? '' ,
                'company_bears_expenses'    => $insert['company_bears_expenses'] ?? 0,
                'code_number'               => $this->return['id']."-".( $insert['clearance_m_id'] ?? "t_n" )."-".( $insert['clearance_d_id'] ?? "c_n" )
            ];
            DB::table('wearhouse_transactions')->insert($seed);
        }

        if($insert['trip_road'] == 5 && isset($request['warehouse_transaction_id']) && $request['warehouse_transaction_id'] > 0 ){

            DB::table('wearhouse_transactions')
                ->where('wearhouse_transaction_id' , $request['warehouse_transaction_id'])
                ->update(
                    [
                        'status'                        => 3 ,

                        'out_trip_id'                   => $this->return['id'] ,
                        'out_driver_residency_number'   => $driver->residency_number ?? '',
                        'out_driver_name'               => $driver->name ?? '',
                        'out_driver_mobile'             => $driver->mobile ?? '' ,
                        'out_car_number'                => $car->name ?? '' ,

                        'out_date'                      => $insert['related_trans_date'] ?? date("Y-m-d H:i:s"),
                        'out_user'                      => auth()->user()->id ,
                        'out_notes'                     => 'تم اشاء رحله رقم #'.$this->return['id']
                    ]
                );

        }
        if(isset($request['recommended_return_date']) && isset($insert['clearance_d_id'])){
            DB::connection('other_mysql')->table('clearances_d')
            ->where('clearances_d_id' , $insert['clearance_d_id'])
            ->update(['recommended_return_date'=>$request['recommended_return_date']]);
        }

        if($insert['clearance_m_id'] > 0){
            (new TripsHelper)->update_container_trips($insert['clearance_m_id']);
        }


        //check if all clearances has trip tp update status

        DB::commit();


        $clearance_trips = DB::connection('other_mysql')->table('clearances_d')
        ->leftjoin('trips' , function($join) {
            $join->on('trips.clearance_d_id' , '=' , 'clearances_d.clearances_d_id')
                ->where('trips.trip_active' , 1);

        })
        ->where('clearances_d.clearances_m_id' , $insert['clearance_m_id'])
        ->groupBy('clearances_d.clearances_d_id')
        ->selectRaw('
            clearances_d.clearances_d_id ,
            IFNULL(trips.trip_id , 0) as trip_id
        ')->get();


        $check = true;
        foreach($clearance_trips as $item){
            if($item->trip_id == 0){
                $check = false;
                break;
            }
        }
        if($check){
            DB::connection('other_mysql')
                ->table('clearances_m')
                ->where('clearance_id',$insert['clearance_m_id'])
                ->update(array('clearance_status_id'=>6));
        }



        return $this->sendResponse( $clearance_trips , trans('main.add_success') );
    }

    public function show($lang , $id , Request $request)
    {
        $this->checkPermission('03-007','view');

        $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('03-007' , $lang)->sub_title ?? '';
        $this->return['data']           = Trip::get_trip($id,$lang);
        $this->return['areas']          = Area::all_areas( ['active' => 1 , 'lang' => $lang] );
        $this->return['drivers']        = Driver::all_drivers( ['active' => 1 , 'lang' => $lang] );
        $this->return['customers']      = Customer::all_customers( ['active' => 1 , 'lang' => $lang] );
        $this->return['ports']          = Port::all_ports( ['active' => 1 , 'lang' => $lang  , 'branch'=> $this->data['current_branch']] );
        $this->return['cars']           = Car::all_cars( ['active' => 1 , 'lang' => $lang] );
        $this->return['wearhouses']     = Wearhouse::all_wearhouses( ['active' => 1 , 'lang' => $lang] );
        $this->return['branchs']        = Branch::all_branchs( ['active' => 1 , 'lang' => $lang , 'user' => auth()->user()->id] );
        $this->return['agents']         = Agent::all_agents( ['active' => 1 , 'lang' => $lang] );
        if(in_array($this->return['data']->trip_road , [3,5])){
            $check_out = DB::table('wearhouse_transactions')
            ->where('out_trip_id', $id)
            ->where('status','>' , 3)
            ->count();
            if($check_out  > 0){
                $this->return['has_out_transactions'] = true;
            }
        }elseif(in_array($this->return['data']->trip_road , [1,4])){
            $check_in = DB::table('wearhouse_transactions')
            ->where('in_trip_id', $id)
            ->where('status','>' , 1)
            ->count();
            if($check_in  > 0){
                $this->return['has_in_transactions'] = true;
            }
        }
        return $this->sendResponse( $this->return , '' );
    }

    public function update($lang , $id , Request $request)
    {
        // $this->checkPermission('03-007','edit');


        $item = Trip::find($id);
        if($item->driver_paid > 0 )
            return $this->sendError( trans('error.trip_has_driver_card'));

        if($item->invoice_id > 0 )
            return $this->sendError( trans('error.trip_has_invoice'));

        // if( !( new TripsHelper)->can_edit($id) ){
        //     return $this->sendError( trans('error.has_wearhosue_ta') );
        // }

        $update = $request->only([
            'clearance_m_id' ,
            'clearance_d_id' ,
            'customer_id',
            'driver_id' ,
            'car_id' ,
            'container_number',
            'container_size',
            'is_empty',
            'customer_name' ,
            'customer_vat_number' ,
            'trip_road' ,
            'trip_type' ,
            'from_port_id' ,
            'from_wearhouse_id' ,
            'from_area_id' ,
            'to_port_id' ,
            'to_wearhouse_id' ,
            'to_area_id' ,
            'to_agent_id' ,
            'final_dest_id' ,
            'trip_date' ,
            'related_trans_date',
            'car_number' ,
            'driver_price' ,
            'trip_price' ,
            'total_price',
            'company_bears_expenses'
        ]);


        $roadOptions = [
            1 => ['from_wearhouse_id','from_area_id', 'to_port_id', 'to_area_id', 'to_agent_id'],// from_port_id  - to_wearhouse_id
            2 => ['from_wearhouse_id','from_area_id','to_port_id', 'to_wearhouse_id', 'to_agent_id'], //from_port_id - to_area_id
            3 => ['from_port_id', 'from_area_id', 'to_port_id','to_wearhouse_id', 'to_agent_id'], // from_wearhouse_id  - to_area_id
            4 => ['from_port_id', 'from_wearhouse_id', 'to_port_id','to_area_id', 'to_agent_id'], // from_area_id - to_wearhouse_id
            5 => ['from_port_id', 'from_area_id', 'to_port_id','to_wearhouse_id', 'to_area_id'], // from_wearhouse_id  -  to_agent_id
        ];

        $selectedRoad = $request['trip_road'] ?? null;

        if (array_key_exists($selectedRoad, $roadOptions)) {
            foreach ($roadOptions[$selectedRoad] as $field) {
                $update[$field] = null;
            }
        }

        if(isset($request['recommended_return_date']) && isset($update['clearance_d_id'])){
            DB::connection('other_mysql')->table('clearances_d')
            ->where('clearances_d_id' , $update['clearance_d_id'])
            ->update(['recommended_return_date'=>$request['recommended_return_date']]);
        }

        if(isset($update['clearance_m_id']) && $update['clearance_m_id'] > 0 ){
            $clearance = DB::connection('other_mysql')->table('clearances_m')->where('clearance_id',$update['clearance_m_id'])->first();
            $update['customer_id'] = $clearance->customer_id ?? $update['customer_id'];
        }

        $validator  = validator()->make( $update , Trip::$rules );
        if($validator->fails())
        {
            return $this->sendError( trans('error.add_fails') , $validator->errors() );
        }
        unset($update['trip_id'] , $update['trip_active'] , $update['_method'] );
        if( isset($update['clearance_m_id'] ) && $update['clearance_m_id'] > 0 && $update['clearance_d_id'] > 0 ){

            $check = DB::table('trips')
                ->where('clearance_m_id' , $update['clearance_m_id'])
                ->where('trip_road' , $update['trip_road'])
                ->where(function($where) use($update){
                    $where->where('clearance_d_id' , $update['clearance_d_id'])
                        ->orWhere('container_number' , $update['container_number']);
                })
                ->where('trip_id' , '<>' , $id )
                ->where('trip_active' , 1 )
                ->count();

            if($check > 0 ){
                return $this->sendError( trans('error.dublicate_trip') , [] );
            }

        }

        DB::beginTransaction();
            $driver     = Driver::get_driver($update['driver_id'] , 'ar');
            $car        = Car::get_car($update['car_id'] , 'ar');
            // $clearance  = Clearance::get_clearance($update['clearance_m_id'],'ar');

            $clearance  = DB::connection('other_mysql')->table('clearances_m')
                ->where('clearance_id' , $update['clearance_m_id'] )
                ->first();
            $is_box     = (isset($clearance->is_lcl) && $clearance->is_lcl == 1 )? 1 : 0 ;

            Trip::update_trip($update ,  $id );
            if($update['trip_road'] == 1){

                if($update['clearance_d_id'] > 0 && $update['final_dest_id'] > 0){
                    DB::connection('other_mysql')->table('clearances_d')
                    ->where('clearances_d_id' , $update['clearance_d_id'])
                    ->update(['dest_id'  =>$update['final_dest_id']]);
                }
            }

            if(in_array($update['trip_road'] , [2,3]) && $update['to_area_id'] > 0 && $update['clearance_d_id'] > 0){
                DB::connection('other_mysql')->table('clearances_d')
                ->where('clearances_d_id' , $update['clearance_d_id'])
                ->update(['dest_id' => $update['to_area_id']]);
            }
            DB::table('wearhouse_transactions')
                ->where('in_trip_id' , $id)
                ->update( [
                    'in_driver_residency_number'    => $driver->residency_number ?? '',
                    'is_empty'                      => $update['is_empty'] ?? 0 ,
                    'is_box'                        => $is_box ,
                    'in_driver_name'                => $driver->name ?? '',
                    'in_driver_mobile'              => $driver->mobile ?? '' ,
                    'in_date'                       => $update['related_trans_date'] ?? null,

                    'in_car_number'                 => $car->name ?? '' ] );

            DB::table('wearhouse_transactions')
                ->where('out_trip_id' , $id)
                ->update( [
                    'out_driver_residency_number'   => $driver->residency_number ?? '',
                    'is_empty'                      => $update['is_empty'] ?? 0 ,
                    'is_box'                        => $is_box ,
                    'out_date'                       => $update['related_trans_date'] ?? null,

                    'out_driver_name'               => $driver->name ?? '',
                    'out_driver_mobile'             => $driver->mobile ?? '' ,
                    'out_car_number'                => $car->name ?? '' ] );
                    if($update['clearance_m_id'] > 0){
                        (new TripsHelper)->update_container_trips($item->clearance_m_id);
                    }
        DB::commit();

        return $this->sendResponse( $this->return , trans('main.update_success') );
    }

    public function destroy($lang , $id)
    {
        $this->checkPermission('03-007','delete');

        if( !( new TripsHelper)->can_delete($id) ){
            return $this->sendError( trans('error.has_wearhosue_ta') );
        }



        DB::beginTransaction();
            $item = Trip::find($id);

            if($item->driver_paid > 0 )
                return $this->sendError( trans('error.trip_has_driver_card') );

            if($item->invoice_id > 0 )
                return $this->sendError( trans('error.trip_has_invoice') );

            Trip::delete_trip($id);
            if($item->clearance_m_id > 0){
                (new TripsHelper)->update_container_trips($item->clearance_m_id);
            }

            if(in_array($item->trip_road , [3,5])){
                DB::table('wearhouse_transactions')
                    ->where('out_trip_id' , $id)
                    ->update(['out_trip_id' => 0, 'status' => 2 , 'out_driver_residency_number' => '' , 'out_driver_name' => '' , 'out_driver_mobile' => '' , 'out_car_number' => '']);
            }elseif(in_array($item->trip_road , [1,4])){
                $check = DB::table('wearhouse_transactions')
                    ->where('in_trip_id', $id)
                    ->delete();
                    // ->update(['in_trip_id' => 0 , 'in_driver_residency_number' => '' , 'in_driver_name' => '' , 'in_driver_mobile' => '' , 'in_car_number' => '' , 'wearhouse_transaction_active' => 0 , 'disable_user' => auth()->user()->id , 'disable_date' => date("Y-m-d H:i:s")]);
            }



        DB::commit();

        return $this->sendResponse( [] , trans('main.delete_success') );
    }


    public function toggle_active($lang , $id){
        $item = Trip::find($id);
        if($item->trip_active){

            if( !( new TripsHelper)->can_edit($id) ){
                return $this->sendError( trans('error.has_wearhosue_ta') );
            }


            $this->checkPermission('03-007','delete');


            DB::beginTransaction();
                if($item->driver_paid > 0 )
                return $this->sendError( trans('error.trip_has_driver_card') );

                if($item->invoice_id > 0 )
                    return $this->sendError( trans('error.trip_has_invoice') );

                Trip::delete_trip($id);
                if($item->clearance_m_id > 0){
                    (new TripsHelper)->update_container_trips($item->clearance_m_id);
                }
                if(in_array($item->trip_road , [3,5])){
                    DB::table('wearhouse_transactions')
                        ->where('out_trip_id' , $id)
                        ->update(['out_trip_id' => 0, 'status' => 2 , 'out_driver_residency_number' => '' , 'out_driver_name' => '' , 'out_driver_mobile' => '' , 'out_car_number' => '']);
                }elseif(in_array($item->trip_road , [1,4])){

                    $check = DB::table('wearhouse_transactions')
                        ->where('in_trip_id', $id)
                        ->delete();
                        // ->update(['in_trip_id' => 0 , 'in_driver_residency_number' => '' , 'in_driver_name' => '' , 'in_driver_mobile' => '' , 'in_car_number' => '' , 'wearhouse_transaction_active' => 0 , 'disable_user' => auth()->user()->id , 'disable_date' => date("Y-m-d H:i:s")]);
                }

            DB::commit();

            $this->return['active'] = false;

        }else{

            $this->checkPermission('03-007','edit');

            $check = DB::table('trips')
                ->where('clearance_m_id' , $item->clearance_m_id)
                ->where('trip_road' , $item->trip_road)
                ->where('trip_id' , '<>' , $id )
                ->where(function($where) use($item){
                    $where->where('clearance_d_id' , $item->clearance_d_id)
                        ->orWhere('container_number' , $item->container_number);
                })
                ->where('trip_active' , 1 )
                ->count();

            if($check > 0 ){
                return $this->sendError( trans('error.dublicate_trip') , [] );
            }

            Trip::update_trip(array('trip_active' => 1 ) , $id);
            if($item->clearance_m_id > 0){
                (new TripsHelper)->update_container_trips($item->clearance_m_id);
            }
            $this->return['active'] = true;
        }
        return $this->sendResponse( $this->return , trans('main.update_success') );
    }

    public function print( $id , Request $request)
    {
        $lang = 'ar';
        $this->return['lang']               = $lang;
        $this->return['master']             = Trip::get_trip($id , $lang);
        $this->return['branch_data']        = Branch::get_branch($this->return['master']->branch_id  , $lang);
        $this->return['logo']               = $this->return['branch_data']->branch_image ?? 0;

        switch (@$request['type']) {
            case 'excel':
                $this->return['logo']     = public_path().$this->return['logo'];
                $export = new InvoicesExport($this->return , 'Print/clearance/invoice');
                return Excel::download($export, 'balances.xlsx');
            break;
            case 'pdf':
                $this->return['logo']     = public_path().$this->return['logo'];
                $pdf = PDF::loadView('Print/clearance/invoice', array('data' => $this->return ))->setOption("footer-center", "[page] / [topage]");
                return $pdf->stream();
            break;
            case 'image':
                $image = App::make('snappy.image.wrapper');
                $image->loadView('Print/clearance/invoice', array('data' => $this->data));
                return $image->stream();
            break;
            case 'print':
                return view('Print.clearance.invoice')->with('data' , $this->return);
            break;
            case 'json':
                return view('Print.clearance.invoice')->with('data' , $this->return);
            break;
        }


        return $this->sendResponse($this->return);
    }
    public function trip_update_customized($lang,$id,Request $request){

        $inputs = $request->only(['related_trans_date','recommended_return_date','driver_price','final_dest_id']);
        $trip = Trip::find($id);
        $user = User::find(auth()->user()->id);

        $update = [
            'driver_price'            => $user->edit_trip_price ? $inputs['driver_price'] ?? null : null,
            'related_trans_date'      => $user->edit_trans_date ? $inputs['related_trans_date'] ?? null: null,
            'recommended_return_date' => $user->edit_return_date ? $inputs['recommended_return_date']  ?? null: null,
            'final_dest_id'           => $user->edit_return_date ? $inputs['final_dest_id']  ?? null: null,

        ];
        if(isset($update['recommended_return_date']) && isset($trip->clearance_m_id) && isset($trip->clearance_d_id)){
            DB::connection('other_mysql')->table('clearances_d')
            ->where('clearances_d_id' , $trip->clearance_d_id)
            ->update(['recommended_return_date' => $update['recommended_return_date'] ,'dest_id' => $update['final_dest_id']]);
        }
        if(isset($update['final_dest_id']) && isset($trip->clearance_m_id) && isset($trip->clearance_d_id)){
            DB::connection('other_mysql')->table('clearances_d')
            ->where('clearances_d_id' , $trip->clearance_d_id)
            ->update(['dest_id' => $update['final_dest_id']]);
        }
        if(isset($update['driver_price'])){
            if($trip->driver_paid > 0 )
                return $this->sendError( trans('error.trip_has_driver_card'));

            if($trip->invoice_id > 0 )
                return $this->sendError( trans('error.trip_has_invoice'));
        }
        $upate_trip =[
            'driver_price'            => $update['driver_price'] ?? 0,
            'total_price'             => $update['driver_price'] + $trip->trip_price,
            'related_trans_date'      => $update['related_trans_date'] ?? null,
            'final_dest_id'           => $update['final_dest_id'] ?? null,
        ];
        if(!isset($upate_trip['related_trans_date'])){
            unset($upate_trip['related_trans_date']);
        }
        if(!isset($upate_trip['final_dest_id'])){
            unset($upate_trip['final_dest_id']);
        }
        if(!isset($upate_trip['driver_price']) || $upate_trip['driver_price'] < 1){
            unset($upate_trip['driver_price']);
            unset($upate_trip['total_price']);
        }
        Trip::update_trip($upate_trip ,  $id );

        return $this->sendResponse($this->return , trans('main.update_success'));

    }
    public function available_containers($lang , Request $request)
    {
        $this->checkPermission('03-055','view');

        // $ports = DB::table('ports')
        //     ->where('branch_id' , $this->data['current_branch'] )
        //     ->pluck('port_id')
        //     ->toArray();
        $this->filter = array(
            'lang'              => $lang ,
            'rows'              => $request['rows'] ?? null ,
            'page'              => $request['page'] ?? null ,
            'word'              => $request['word'] ?? null ,
            'from'              => $request['from'] ?? null ,
            'to'                => $request['to'] ?? null ,
            'container_number'  => $request['container_number'] ?? null,
            'port_id'           => $request['port_id'] ?? null,
            // 'port_ids'          => $ports ,
            'clearance_id'      => $request['clearance_id'] ?? null
        );

        $this->return['screen_name'] = ScreenSub::get_screen_sub_by_screen_code('03-055' , $lang)->sub_title ?? '';
        $this->return['items']       = Clearance::get_available_container( $this->filter );
        $this->return['drivers']     = Driver::all_drivers( ['active' => 1 , 'lang' => $lang] );
        $this->return['areas']       = Area::all_areas( ['active' => 1 , 'lang' => $lang] );
        $this->return['ports']       = Port::all_ports( ['active' => 1 , 'lang' => $lang  , 'branch'=> $this->data['current_branch']] );

        return $this->sendResponse( $this->return );
    }
    public function update_available_container($lang , Request $request)
    {
        // $this->checkPermission('03-055','edit');

        $inputs = $request->all();
        $update_m = [
            'unloading_ship_date'       => $inputs['unloading_ship_date'] ?? null ,
            'receipt_date'              => $inputs['receipt_date'] ?? null ,
        ];
        $update_d = [
            'port_gate'                 => $inputs['port_gate'] ?? null ,
            'location_date'             => $inputs['location_date'] ?? null ,
            'container_weight'          => $inputs['container_weight'] ?? null ,
            'customs_date'              => $inputs['customs_date'] ?? null ,
            'hazardous'                 => $inputs['hazardous'] ?? null ,
            'shipment_date'             => $inputs['shipment_date'] ?? null ,
            'driver_id'                 => $inputs['driver_id'] ?? null ,
            'notes'                     => $inputs['notes'] ?? null ,
            'status'                    => $inputs['status'] ?? null ,
            'dest_id'                   => $inputs['dest_id'] ?? null ,
            'recommended_return_date'   => $inputs['recommended_return_date'] ?? null ,
        ];
        DB::beginTransaction();
            // Filter out null values
            $update_m = array_filter($update_m, function($value) { return $value !== null; });
            $update_d = array_filter($update_d, function($value) { return $value !== null; });

        if (count($update_m) > 0) {
            DB::connection('other_mysql')->table('clearances_m')->where('clearance_id',$inputs['clearances_m_id'])->update($update_m);
        }

        if (count($update_d) > 0) {
            DB::connection('other_mysql')->table('clearances_d')->where('clearances_d_id',$inputs['clearances_d_id'])->update($update_d);
        }
        DB::commit();

        return $this->sendResponse( $this->return , trans('main.update_success'));
    }
    public function update_unloading_ship_date($lang ,$id, Request $request)
    {
        $this->checkPermission('03-055','view');
        $update = [
            'unloading_ship_date' => $request->unloading_ship_date ?? date('Y-m-d'),
        ];
        DB::connection('other_mysql')->table('clearances_m')
        ->where('clearance_id' , $id)
        ->update($update);
        return $this->sendResponse( $this->return );
    }

}
