<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class DatabaseLogger
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
     */
    public function handle(Request $request, Closure $next)
    {
        DB::connection()->enableQueryLog();
        return $next($request);
    }

    public function terminate($request, $next)
    {
        $logData = [
            'payload'   => json_encode($request->all()),
            'method'    => $request->method(),
            'url'       => $request->getRequestUri(),
            'queries'   => json_encode(DB::getQueryLog()),
            'add_user'  => auth()->user()->id ?? 0,
        ];
        DB::table('logging')->insert($logData);

    }
}
