<?php
namespace App\Http\Middleware;

use Closure;
use App;

class VerifyAPIEXTAccess
{
    /**
     * Handle an incoming request.
     *
     * @param \Illuminate\Http\Request $request
     * @param \Closure $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        if ( (!$request->header('access-token') || $request->header('access-token') !== env('APP_API_TOKEN') ) ) {
            return response()->json(['check' => false , 'msg' => 'You do not access to this api.'.$request->header('access-token-ext') ], 403);
        }

        return $next($request);
    }
}
