<?php

namespace App\Http\Resources\Sales;

use Illuminate\Http\Resources\Json\ResourceCollection;

class ClassificationCollection extends ResourceCollection
{
    /**
     * Transform the resource collection into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {
        return $this->collection->transform(function ($query)  {
            return [
                         "invoiceSeq"                => 1,                                                          // - 01
                        "countryOriginCode"         => $query->country_id,                                           // - 02
                        "trafficCode"               => string_len($query->customs_item_number , 1 , 16 ,  "_") ,     // - 03
                        "goodsDescription"          => string_len($query->item_name , 22 , 300 , "  البضاعه الوارده  ") ,      // - 04
                        "grossWeight"               => $query->weight,                                               // - 05
                        "netWeight"                 => $query->weight,                                               // - 05
                        "noOfUnit"                  => intval($query->qry),                                                  // - 06
                        "itemValue"                 => $query->amount,                                               // - 07
                        "dutyTypeCode"              => 1,                                                          // - 08
                        "dateTypeCode"              => null ,                                                          // - 09
                        "productionDate"            => null ,                                                         // - 10
                        "expiryDate"                => null ,                                                         // - 11
                        "containerSize"             => $query->container_size ,                                      // - 12
                        "buyingcountry"             => null ,                                                         // - 13
                        "routeDescription"          => null ,                                                         // - 14
                        "salePriceForCustomer"      => null ,                                                         // - 15
                        "batchNumber"               => null ,                                                         // - 16
                        "preNotificationNumber"     => null ,                                                         // - 17
                        "itemQuantity"              => $query->qry,                                                  // - 18
                        "itemUnit"                  => $query->unit_id,                                              // - 19
                        "internationalQuantity"     => $query->qry,                                                  // - 20
                        "trafficQuantity"           => null ,                                                         // - 21
                        "trafficUnit"               => null ,                                                         // - 22
                        "minimumDutyQuantity"       => null ,                                                         // - 23
                        "minimumDutyUnit"           => null ,                                                         // - 24
                        "banderoleQuantity"         => null ,                                                         // - 25
                        "additionalFeeUnit"         => null   
            ];
        });
    }
}

