<?php

namespace App\Models\Main;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class NotAllowedTime extends Model
{
    protected $primaryKey     = 'not_allowed_time_id';
    public static $main_table = 'not_allowed_times';
    public $table             = 'not_allowed_times';

    public static $rules = array(
        'times'          => 'required|array',
        'user_id'          => 'required|numeric|exists:users,id',
        'times.*.day' => 'required|in:0,1,2,3,4,5,6',
//        'times.*.from_time' => 'required|date_format:H:i',
//        'times.*.to_time' => 'required|date_format:H:i|after:times.*.from_time'
    );


    public static function get_not_allowed_time($id, $lang = null)
    {
        $query = DB::table(self::$main_table)
            ->where('user_id', $id);

        if($lang != null)
            $query->selectRaw('
                not_allowed_time_id as id ,'.
                self::$main_table.'.day ,'.
                self::$main_table.'.from_time ,'.
                self::$main_table.'.to_time,'.
                self::$main_table.'.add_date,'.
                self::$main_table.'.add_user,
                from_time
            ');

        $data = $query->get();
        return $data;
    }


    public static function add_not_allowed_time($seed)
    {
        return DB::table(self::$main_table)->insertGetId($seed);
    }

    public static function delete_not_allowed_time($id,$not_allowed_time_id = null)
    {
        $query = DB::table(self::$main_table)->where('user_id', $id);
            if (isset($not_allowed_time_id)){
                $query->where('not_allowed_time_id',$not_allowed_time_id);
            }

            return  $query->delete();
    }
}
