<?php

namespace App\Models\Sales;

use Illuminate\Database\Eloquent\Model;
use DB;

class Country extends Model
{
    protected $primaryKey     = 'country_id';
    public static $main_table = 'countrys';
    public $table             = 'countrys';

    public static $rules = array(
        'name_en'          => 'required|string',
        'name_ar'          => 'required|string',
    );

    public static function all_countrys($params = null)
    {
        $query = DB::table(self::$main_table)
            ->orderBy(self::$main_table.'.country_id', 'desc');

        if(isset($params['lang']))
            $query->selectRaw('
                country_id as id ,'.
                self::$main_table.'.name_'.$params['lang'].' as name ,'.
                self::$main_table.'.name_ar ,'.
                self::$main_table.'.name_en 
            ');

  
        if(isset($params['word']) && strlen($params['word']) > 0){
            $query->where(function ($stmt) use($params) {
                $stmt->where(self::$main_table.'.name_en' , 'LIKE' , "%{$params['word']}%")
                    ->orWhere(self::$main_table.'.name_ar' , 'LIKE' , "%{$params['word']}%");
            });
        }

        if(isset($params['rows'])){
            $data = $query->paginate($params['rows'], ['*'], 'page', $params['page'] ?? 1);
        }else{
            $data = $query->get();
        }

        return $data;
    }

    public static function get_country($id, $lang = null)
    {
        $query = DB::table(self::$main_table)
            ->where('country_id', $id);

        if($lang != null)
            $query->selectRaw('
                country_id as id ,'.
                self::$main_table.'.name_'.$lang.' as name ,'.
                self::$main_table.'.name_ar ,'.
                self::$main_table.'.name_en 
            ');

        $data = $query->first();
        return $data;
    }

    public static function add_country($seed)
    {
        return DB::table(self::$main_table)->insertGetId($seed);
    }

    public static function update_country($seed, $id)
    {
        return DB::table(self::$main_table)->where('country_id', $id)->update($seed);
    }

    public static function delete_country($id)
    {
        return DB::table(self::$main_table)->where('country_id', $id)->update(array('country_active' => 0, 'disable_date' => date("Y-m-d H:i:s"), 'disable_user' => auth()->user()->id));
    }
}
