<?php

namespace App\Models\Sales;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class CustomerFile extends Model
{
    use HasFactory;
    protected $primaryKey = 'customer_file_id';

    public static $main_table = 'customer_files';
    public $table             = 'customer_files';



    public static function add_customer_file($seed)
    {
        return DB::table(self::$main_table)->insertGetId($seed);
    }

    public static function get_customer_file($customer_id,$lang=null){
        return DB::table(self::$main_table)->where('customer_id',$customer_id)->whereNull('disable_date')->selectRaw('file_name , file_path , customer_file_id as id')->get();

    }
    public static function get_file($file_id,$lang=null){
        return DB::table(self::$main_table)->where('customer_file_id',$file_id)->whereNull('disable_date')->selectRaw('file_name , file_path , customer_file_id as id')->first();
    }

    public static function delete_customer_file($id)
    {
        return DB::table(self::$main_table)->where('customer_file_id' , $id )->update( array( 'disable_date' => date("Y-m-d H:i:s") , 'disable_user' => auth()->user()->id));
    }
}
