<?php
namespace App\Http\Controllers\API\V1\Sales;
use App\Http\Controllers\API\V1\BaseController;


use App\Classes\Excel\InvoicesExport;
use App\Classes\General\Upload;
use App\Classes\General\General;
use Illuminate\Http\Request;
use App\Models\Main\ScreenSub;

use App\Models\User;

use App\Models\Sales\Customer;
use App\Models\Main\Delegate;
use App\Models\Main\Branch;
use App\Models\Finance\ExpenseCode;



use DB;
use PDF;
use App;
use Excel;
use DateTime;

class ReportController extends BaseController
{

    protected $return = array();
    protected $filter = array();

    protected function get_print_data( $branch_id ){

        $branch_data    = Branch::get_branch($branch_id);

        $this->return['print']['print_margin']   = $branch_data->print_margin ?? '';
        $this->return['print']['print_right']    = $branch_data->print_label_ar ?? '';
        $this->return['print']['print_left']     = $branch_data->print_label_en ?? '';
        $this->return['print']['footer']         = $branch_data->print_footer ?? '';
        $this->return['print']['logo']           = get_logo( $branch_id );


    }

    public function reimburses_expenses_report_get($lang , Request $request){

        // if(!@in_array('1', $this->data['mypermissions']['04-021'][0]->permission) ){
        //     return $this->sendError( 'update permission needed #04-021' , [] , 200 );
        // }

        $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('04-021' , $lang)->sub_title ?? '';
        $this->return['customers']      = customer::all_customers(array('lang' => $lang , 'active' => 1 ));
        $this->return['delegates']      = Delegate::all_delegates(array('lang' => $lang , 'active' => 1 ,'delegate_ids' => true));
        $this->return['expense_codes']  = ExpenseCode::all_expense_codes( array('lang' => $lang , 'active' => 1 ) );

        return $this->sendResponse( $this->return );

    }

    public function reimburses_expenses_report_post($lang , Request $request){
        // if(!@in_array('1', $this->data['mypermissions']['04-021'][0]->permission) ){
        //     return $this->sendError( 'update permission needed #04-021' , [] , 200 );
        // }

        $this->filter['lang']           = $lang ;
        $this->filter['from']           = $request['from_date'] ?? date("Y-m-01");
        $this->filter['to']             = $request['to_date'] ?? date("Y-m-d");
        $this->filter['customer_id']    = $request['customer_id'] ?? 0 ;
        $this->filter['delegate_id']    = $request['delegate_id'] ?? 0 ;
        $this->filter['clearance_id']    = $request['clearance_id'] ?? 0 ;
        $this->filter['expense_code_id']= $request['expense_code_id'] ?? 0 ;
        $this->filter['shipping_policy_no']= $request['shipping_policy_no'] ?? null ;
        $this->filter['container_no']   = $request['container_no'] ?? null ;
        $this->return['screen_name']    = ScreenSub::get_screen_sub_by_screen_code('04-021' , $lang)->sub_title ?? '';


        $report = DB::table('delegate_petty_d')
            ->leftjoin('delegate_petty_m' , 'delegate_petty_d.delegate_petty_m_id' , '=' , 'delegate_petty_m.delegate_petty_m_id')
            ->leftjoin('expense_codes' , 'delegate_petty_d.expense_code_id' , '=' , 'expense_codes.expense_code_id')
            ->leftjoin('clearances_m' , 'delegate_petty_d.clearance_id' , '=' , 'clearances_m.clearance_id')
            ->where('delegate_petty_m.action_date' , '>=' , $this->filter['from'] )
            ->where('delegate_petty_m.action_date' , '<=' , $this->filter['to'] )
            ->selectRaw('
                delegate_petty_d.delegate_petty_m_id as m_id ,
                delegate_petty_d.delegate_petty_d_id as d_id ,
                clearances_m.clearance_id ,
                clearances_m.shipping_policy_no ,
                clearances_m.first_container ,
                expense_codes.expense_code_id ,
                expense_codes.name_'.$lang.' as expense_code_name ,
                delegate_petty_d.receipt_number ,
                delegate_petty_d.amount ,
                delegate_petty_d.description_'.$lang.' as description ,
                delegate_petty_d.add_date ,
                delegate_petty_d.invoice_id
            ');

        if( $this->filter['customer_id'] > 0 ){
            $report->where('clearances_m.customer_id' , $this->filter['customer_id'] );
        }

        if( $this->filter['delegate_id'] > 0 ){
            $report->where('delegate_petty_m.delegate_id' , $this->filter['delegate_id'] );
        }

        if( $this->filter['expense_code_id'] > 0 ){
            $report->where('delegate_petty_d.expense_code_id' , $this->filter['expense_code_id'] );
        }

        if( $this->filter['clearance_id'] > 0 ){
            $report->where('delegate_petty_d.clearance_id' , $this->filter['clearance_id'] );
        }

        if( $this->filter['shipping_policy_no'] != null ){
            $report->where('clearances_m.shipping_policy_no' , $this->filter['shipping_policy_no'] );
        }

        if( $this->filter['container_no'] != null ){
            $ids = DB::table('clearances_d')
                ->where('container_number' , 'like' , '%'.$this->filter['container_no'].'%')
                ->pluck('clearances_m_id');

            $report->whereIn('delegate_petty_d.clearance_id' , $ids );
        }



        $this->return['report']         = $report->get();
        $this->return['ids']            = array_filter(collect($this->return['report'])->pluck('clearance_id'));
        $this->get_print_data(1);

        return $this->sendResponse( $this->return );
    }




}
