<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateStocktakingMTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('stocktaking_m', function (Blueprint $table) {
            $table->increments('stocktaking_m_id');
            $table->integer('branch_id')->nullable();
            $table->integer('finance_year_id')->nullable();
            $table->integer('year_ser')->nullable();
            $table->integer('month_ser')->nullable();
            $table->integer('branch_ser')->nullable();
            $table->integer('daily_journal_m_id')->nullable();
            $table->date('stocktaking_date')->nullable();
            $table->dateTime('add_date')->nullable();
            $table->integer('stocktaking_code')->nullable();
            $table->text('name_en')->nullable();
            $table->text('name_ar')->nullable();
            $table->double('total_18')->nullable();
            $table->double('total_21')->nullable();
            $table->double('total_24')->nullable();
            $table->double('grand_total_in_18')->nullable();
            $table->double('grand_total_in_21')->nullable();
            $table->double('grand_total_in_24')->nullable();
            $table->longText('deleted_items')->nullable();
            $table->longText('commen_items')->nullable();
            $table->longText('new_items')->nullable();
            $table->integer('add_user')->nullable();
            $table->tinyInteger('stocktaking_status')->nullable();
            $table->tinyInteger('stocktaking_active')->nullable();
            $table->dateTime('disable_date')->nullable();
            $table->integer('disable_user')->nullable();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('stocking_m');
    }
}
