<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateStockTransactionDTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('stock_transaction_d', function (Blueprint $table) {
            $table->increments('stock_transaction_d_id');
            $table->integer('stock_transaction_m_id')->nullable();
            $table->integer('category_id')->nullable();
            $table->integer('sub_category_id')->nullable();
            $table->double('gold_weight')->nullable();
            $table->double('diamond_weight')->nullable();
            $table->double('stone_weight')->nullable();
            $table->double('weight')->nullable();
            $table->double('price')->nullable();
            $table->integer('pieces_count')->nullable();
            $table->integer('caliber_id')->nullable();
            $table->integer('shape_id')->nullable();
            $table->integer('color_id')->nullable();
            $table->integer('quality_id')->nullable();
            $table->integer('clarity_id')->nullable();
            $table->string('item_code')->nullable();
            $table->double('purchase_cost')->nullable();
            $table->double('sell_cost')->nullable();
            $table->double('min_sell_cost')->nullable();
            $table->text('name_en')->nullable();
            $table->text('name_ar')->nullable();
            $table->text('image')->nullable();
            $table->dateTime('add_date')->nullable();
            $table->integer('add_user')->nullable();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('stock_transaction_d');
    }
}
