import Vue from "vue";
import Vuex from "vuex";
import auth from "./auth";
import loading from "./loading";

Vue.use(Vuex);

export default new Vuex.Store({
	state: {
		currentLang:localStorage.getItem('lang'),
		goldPrice:{
			c18:localStorage.getItem('gold18') ,
			c21:localStorage.getItem('gold21') ,
			c22:localStorage.getItem('gold22') ,
			c24:localStorage.getItem('gold24') ,
			ounce:localStorage.getItem('ounce') ,
			pricDir:0
		}
	},

	getters: {
		getLang(state){
			return state.currentLang;
		},
		getGoldPrice(state){
			return state.goldPrice;
		},
	},
	actions : {
		goldPriceChange(context , prices) {
			context.commit('goldPriceChange' ,prices);
		},
	
	},
	mutations : {
		goldPriceChange(state , prices) {

			state.goldPrice.c18 = prices.price_18;
			state.goldPrice.c21 = prices.price_21;
			state.goldPrice.c22 = prices.price_22;
			state.goldPrice.c24 = prices.price_24;
			state.goldPrice.ounce = prices.ounce;
			
			localStorage.setItem('gold18' , prices.price_18);
			localStorage.setItem('gold21' , prices.price_21);
			localStorage.setItem('gold22' , prices.price_22);
			localStorage.setItem('gold24' , prices.price_24);
			localStorage.setItem('ounce' , prices.ounce);

		},
	},
	modules: {
		auth,
		loading,
	}
});


