const state = {
	visible: false,
    layout: "normal",
    input: null,
};

const getters = {
    getKeyBoardVisible(state){
        return state.visible;
    },
    getKeyBoardLayout(state){
        return state.layout;
    },
    getKeyBoardInput(state){
        return state.input;
    }
};

const actions = {
	startKeyBoard(context , data ) {
		context.commit('startKeyBoard' , data);
	},
	endKeyBoard(context) {
		context.commit('endKeyBoard');
	}
};

const mutations = {
	startKeyBoard(state , data ) {
		state.visible = true;
		state.layout = data.type;
		state.input = data.input;
	},
	endKeyBoard(state) {
        console.log('endKeyBoard called')
		state.visible = false;
		state.input = null;
	}
};

export default {
	state,
	actions,
	mutations,
	getters
};