<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Print</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style type="text/css">
        @if($data['lang'] == 'ar')
    		* {
            direction: rtl;
        }

        .item_a{
            border-left: 0px;
            border-bottom: 0px;
        }
        .item_b{
            border-right: 0px;
            border-bottom: 0px;
        }
        .item_c{
            border-top: 0px;
        }


        @else
    		.item_a{
            border-right: 0px;
            border-bottom: 0px;
        }
        .item_b{
            border-left: 0px;
            border-bottom: 0px;
        }
        .item_c{
            border-top: 0px;
        }

        @endif
    	page_break { page-break-before: always; }
        *{
            font-family: 'dejavu sans', sans-serif;
        }
        .main_div{
            height: auto;
            margin: 0 auto;
            border: 1px solid #000;
            padding: 10px;
            position: relative;
        }
        .logo_cont{
            max-height: 80px;
            text-align: center;
        }
        thead{
            background-color: rgb(237 , 235, 235);
        }
        table{
            width: 100%;
            border-spacing: 0;
            border-collapse: collapse;
            -webkit-box-sizing: border-box;
            -moz-box-sizing: border-box;
            box-sizing: border-box;
            margin-bottom: 10px;
            border: 1px solid #ddd;
        }
        th , td{
            text-align: center;
            border: 1px solid #ddd;
            padding:5px;
        }
        td{
            font-size: 14px;
        }
        th{
            font-size: 16px;
        }
        .title{
            text-align: left;
            font-weight: 900;
        }
        .no_align{
            text-align: right;
        }
        .no_border{
            border:0px;
        }


    </style>
</head>
<body>
<div class="main_div" style="">
    <table  class="table " style="border: 0px">
        <tr>
            <td  class="no_border" style="width: 25%">

            </td>
            <td  class="no_border" style="width: 50%">
                <div class="logo_cont ">
                <!-- <img src="{{ ($data['logo']) }}" class="img-responsive" height="75" alt="Image" style=""> -->
                </div>
                <div>
                    {{ $data['screen_name']->sub_title }}
                </div>
                <div>
                    {{ $data['from']  . "   - "  . $data['to'] . "  -   " . " ( " .$data['account_tree']->account_code ." - " . $data['account_tree']->name." ) " }}
                </div>
            </td>
            <td  class="no_border" style="width: 25%">

            </td>
        </tr>
    </table>

    <hr>
    <table class="table table-bordered table-hover table-striped"  id="main_table_body" >
        <thead>
        <tr>
            <th >{{ trans('main.month_ser') }}</th>
            <th >{{ trans('main.journal_date') }}</th>
            <th >{{ trans('main.document_id') }}</th>
            <th >{{ trans('main.daily_type') }}</th>
            <th >{{ trans('main.description') }}</th>
            <th >{{ trans('main.debit') }}</th>
            <th >{{ trans('main.credit') }}</th>
            <th >{{ trans('main.balance') }}</th>
        </tr>
        </thead>
        <tbody >
        <tr>
            <td>1</td>
            <td>{{ $data['from'] }}</td>
            <td></td>
            <td>{{ trans('main.first_duration_balance') }}</td>
            <td></td>
            <td>0</td>
            <td>0</td>
            <td>{{ fix_number($data['first']->total , 2 ) }}</td>
        </tr>
        @foreach($data['actions'] as $row)
            <?php
            if( $row->debit > 0 ){
                $data['first']->total = $data['first']->total + $row->debit;;
            }else{

                $data['first']->total = $data['first']->total - $row->credit;;
            }
            ?>
            <tr>
                <td>{{ $row->month_ser }}</td>
                <td>{{ $row->journal_date }}</td>
                <td>{{ $row->document_id }}</td>
                <td>{{ $row->daily_type }}</td>
                <td>{{ $row->description }}</td>
                <td>{{ fix_number($row->debit , '1' ) }}</td>
                <td>{{ fix_number($row->credit , '1' ) }}</td>
                <td>{{ fix_number( $data['first']->total , '2') }}</td>
            </tr>
        @endforeach
        </tbody>
        <thead>
        <tr>
            <th colspan="4"></th>
            <th>{{ trans('main.balance') }}</th>
            <th>{{ fix_number($data['actions']->sum('debit') , 1) }}</th>
            <th>{{ fix_number($data['actions']->sum('credit') , 1) }}</th>

            <th> {{ fix_number($data['first']->total , '1') }}  @if( $data['first']->total < 0 )  {{ trans('main.credit') }} @else  {{ trans('main.debit')  }} @endif  </th>
        </tr>
        </thead>
    </table>
</div>
</body>

</html>
