<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Print</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style type="text/css">

    	/**{
	        font-family: 'dejavu sans', serif;
	    }*/

	    @font-face { font-family: Tajawal; src: url('/assets/fonts/Tajawal-Regular.ttf'); } 

			body ,h1 ,h2 , h3,h4,h5,h6,p,div,span:not(.fa) , button , input , a{
			    font-family: 'Tajawal', sans-serif !important ;
			}

    	@if($data['lang'] == 'ar')
    		* {
    			direction: rtl;
    		}

    	@endif
    	page_break { page-break-before: always; }
    	thead { display: table-header-group }
		tfoot { display: table-row-group }
		tr { page-break-inside: avoid }
 
	    
		.main_div{
			min-width: 1024px;
			font-size: 14px;
			height: auto;
			margin: 0 auto;
			/*border: 1px solid #000;*/
			padding: 10px;
			position: relative;
		}
		.logo_cont{
			max-height: 120px;
			text-align: center;
		}
		p , h1 , h2 , h3 , h4 , h5 , h6{
			padding: 0px;
			margin: 0px;
		}
		thead{
			background-color: rgb(237 , 235, 235);
		}
	    table{
	    	width: 100%;
	        border-spacing: 0;
   			border-collapse: collapse;
   			 -webkit-box-sizing: border-box;
			   -moz-box-sizing: border-box;
			        box-sizing: border-box;
   			margin-bottom: 10px;
   			/*border: 1px solid #ddd;*/
	    }
	    .table-bordered th , .table-bordered td{
	    	text-align: center;
		    border: 1px solid #ddd;
			padding:5px;
	    }


	    th , td{
	    	text-align: center;
			padding:5px;
	    }
	    td{
	    	font-size: 12px;
	    }
	    th{
	    	font-size: 14px;
	    }
	    .title{
	    	text-align: left;
	    	font-weight: 900;
	    }
	    .no_align{
	    	text-align: right;
	    }
	    .no_border{
	    	border:0px;
	    }

	    
	</style>
</head>
<body>
	<div class="main_div" style="">


		@yield('content')
        
        <table>
        	<tr>
        		<td>
        			<strong>{{ trans('main.print_date') }} : </strong> {{ date("Y-m-d H:i:s") }} 
					
					<strong>{{ trans('main.print_user') }} : </strong> {{ $data['master']->sales_agent_name ?? auth()->user()->user_full_name ?? '' }} 
        		</td>
        	</tr>
        </table>
        
	</div>
	@yield('script')

	@if(isset($_GET['type']) && $_GET['type'] == 'print')
	<script type="text/javascript">
	window.print();
	// window.onfocus=function(){ window.close();}
	</script>
	@endif


</body>
</html>	