@extends('Layouts.report')
@section('content')

<table class="table table-bordered table-hover table-striped"  id="main_table_body" >
    <thead class="report-header">
        <tr>
            <th colspan="11">
                <table  class="table d no_border" >
                    <tr>
                        <td width="25%">
                            {!! $data['branch_data']->print_label_ar !!}
                        </td>
                        <td width="50%">
                            <div class="logo_cont">
                                <img src="{{ ($data['logo']) }}" class="img-responsive" height="120" alt="Image" style="">
                            </div>
                        </td>
                        <td width="25%">
                            {!! $data['branch_data']->print_label_en !!}
                        </td>
                    </tr>
                    <tr>
                        <td></td>
                        <td style="text-align:center">
                            @yield('title')
                            <h5>{{ $data['params_text'] ?? '' }} </h5>
                        </td>
                        <td></td>
                    </tr>
                </table>
            </th>
        </tr>
        <tr class="report-header-names">
            <th >{{ trans('main.date') }}</th>
            <th >{{ trans('main.branch') }}</th>
            <th >{{ trans('main.invoice_code') }}</th>
            <th >{{ trans('main.caliber') }}</th>
            <th >{{ trans('main.item') }}</th>
            <th >{{ trans('main.supplier') }}</th>
            <th >{{ trans('main.raw_material') }}</th>
            <th >{{ trans('main.purchase_cost') }}</th>
            <th >{{ trans('main.price') }}</th>
            <th >{{ trans('main.vat') }}</th>
            <th >{{ trans('main.grand_total') }}</th>
        </tr>
    </thead>
    <tbody class="report-container">
        @foreach($data['report'] as $row)
            <tr>
                <td>{{ $row->purchase_invoice_date }}</td>
                <td>{{ $row->branch_name }}</td>
                <td>{{ $row->year_ser }}</td>
                <td>{{ $row->supplier_name }}</td>
                <td>{{ $row->category_title }}</td>
                <td>{{ $row->sub_category_title }}</td>
                <td>{{ number_format( $row->total_raws , 2 , '.' , ',' ) }}</td>
                <td>{{ number_format( $row->total_wages , 2 , '.' , ',' ) }}</td>
                <td>{{ number_format( $row->total_without_vat , 2 , '.' , ',' ) }}</td>
                <td>{{ number_format( $row->total_vat , 2 , '.' , ',' ) }}</td>
                <td>{{ number_format( $row->total_with_vat , 2 , '.' , ',' ) }}</td>
            </tr>
        @endforeach
    </tbody>
    <tfoot>
        <th colspan="6">{{ trans('main.total') }}</th>
        <th>{{  number_format( collect($data['report'])->sum('total_raws') , 2 , '.' , ',' ) }}</th>
        <th>{{  number_format( collect($data['report'])->sum('total_wages') , 2 , '.' , ',' ) }}</th>
        <th>{{  number_format( collect($data['report'])->sum('total_without_vat') , 2 , '.' , ',' ) }}</th>
        <th>{{  number_format( collect($data['report'])->sum('total_vat') , 2 , '.' , ',' ) }}</th>
        <th>{{  number_format( collect($data['report'])->sum('total_with_vat') , 2 , '.' , ',' ) }}</th>
    </tfoot>
    
</table>

@endsection