<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Print</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style type="text/css">
        @page {
            size: landscape;
        }
        * {
            direction: rtl;
        }
        page_break { page-break-before: always; }

        .main_div{
            width: 100%;
/*            min-height:296mm;*/
            font-size: 12px;
            /*height: auto;*/
            margin: 0 auto;
            /*border: 1px solid #000;*/
            padding: 5px;
            position: relative;
            margin:0 auto;
        }
        .line_div{
            margin-bottom:5px;
        }
        .logo_cont{
            max-height: 120px;
            text-align: center;
        }
        p , h1 , h2 , h3 , h4 , h5 , h6{
            color: rgb(58, 75, 111);
            padding: 0px;
            margin: 0px;
        }
        thead{
            background-color: rgb(231 , 247, 253);
        }
        table{
            width: 100%;
            border-spacing: 0;
            border-collapse: collapse;
             -webkit-box-sizing: border-box;
               -moz-box-sizing: border-box;
                    box-sizing: border-box;
            margin: 3px;
        }
        .table-bordered th , .table-bordered td{
            text-align: center;
            border: 1px solid #ddd;
            padding:0px;
        }
        .table-bordered.title_header tr td{
            width:100px;
        }
        th , td{
            text-align: center;
            padding:0px;
        }

        .title{
            color: rgb(41,98, 121);
            font-weight: 600;
            font-size:14px;
        }
        .no_align{
            text-align: right;
        }
        .no_border , .no_border th , .no_border td{
            border:0px;
        }

        #selected_item_table th{
            background-color: #222E46 ;
            color: white;
        }
        .summary_table th{
            padding: 10px 30px 10px 30px;
            font-weight: 600;
            background-color: rgb(237 , 235, 235);
        }
        .summary_table td{
            padding: 10px 30px 10px 30px;
        }

        .qrcode_table{
            /*background-color:#A88C07;*/
            border: 0px;
            /*color: white;*/
        }
        .qrcode_table th{
            padding: 10px;
        }

        .footer{
            position: absolute;
    width: 100%;
    bottom: 0;
    left:7px;
        }


        .header_label{
            /*width: 100%;*/
            border: 1px solid black;
            margin: 5px 12px 5px 5px ;
            padding: 5px;
            display: inline-block;
        }
        .header_p{
            margin:5px ;
            padding: 5px;
            border: 1px solid black;

        }
        .manager{
            position: absolute;
            right: 0;
            bottom: 0;
            padding: 0;
        }
    </style>
</head>
<body>
    <div class="main_div">

        <table  class="table " style="border: 0px">
            <tr>
                <td  class="no_border" style="width: 25%">
                    {!! $data['print_right'] ?? '' !!}
                </td>
                <td  class="no_border" style="width: 50%">
                    <div class="logo_cont ">
                        <img src="{{ ($data['logo']) }}" class="img-responsive" height="75" alt="Image" style="">
                    </div>
                    <div>
                        {{ $data['print_title'] ?? '' }}
                    </div>
                </td>
                <td  class="no_border" style="width: 25%">
                    {!! $data['print_left'] ?? '' !!}
                </td>
            </tr>
        </table>
        <br>
        <br>
        <table  class="table " style="border: 0px">
            <tr>

                <table class="table-bordered title_header">
                    <header>
                        <tr>
                            <th>اسم المستورد</th>
                            <th>رقم المعامله</th>
                            <th>المينا</th>
                            <th>رقم الفاتورة</th>
                            <th>نوع الفاتورة</th>
                            <th>عدد الحاويات</th>
                            <th>اول حاوية</th>
                            <th>قيمه الشحن </th>
                            <th>الشركة المصدرة</th>
                            <th>وزن البوليصة</th>
                        </tr>
                    </header>
                    <tbody>
                    <tr>
                        <td  >{{ $data['master']->customer_name ?? "-" }}</td>
                        <td >{{ $data['master']->clearances_m_id ?? "-"}}</td>
                        <td>{{ $data['master']->port_name ?? "-"}}</td>
                        <td>{{ $data['master']->supplier_invoice_code ?? "-" }}</td>
                        <td>{{ $data['master']->invoice_type ?? "-" }}</td>
                        <td>{!!  (optional($data['master'])->container_small > 0) ?  "20*" . optional($data['master'])->container_small ."<br>" : "" !!}  {{ (optional($data['master'])->container_big > 0) ?  "40*" . optional($data['master'])->container_big  : "" }}</td>
                        <td>{{ $data['master']->first_container ?? "-" }}</td>
                        <td>{{ ($data['master']->shipping_amount == 0) ?  "-"  : number_format($data['master']->shipping_amount , 2 , '.' , ',' ) }}</td>
                        <td>{{ $data['master']->exporting_company ?? "-"}}</td>
                        <td>{{ $data['master']->weight ?? "-"}}</td>
                    </tr>
                    </tbody>
                </table>
                <!-- <td  class="no_border" width="20%">
                    <div class="logo_cont ">
                        <img src="{{ ($data['logo']) }}" class="img-responsive" width="90%"  alt="Image" style="">
                    </div>
                </td> -->
            </tr>
        </table>
        <br>
        <div class="line_div" style="box-shadow: 3px 3px 0px 0px #50a1bf">
            <table class="table-bordered">
                <header>
                    <tr>
                        <th>م</th>
                        <th>اسم الصنف</th>
                        <th>المنشا</th>
                        <th>البند الجمركي</th>
                        <th>فئه البند</th>
                        <th>الوحدة</th>
                        <th>الكمية</th>
                        <th>الوزن </th>
                        <th>القيمة بالعملة الاجنبية</th>
                        <th>نوع العملة</th>
                        <th>سعر التحويل</th>
{{--                        <th>القيمه بالعملة المحلية</th>--}}
                        <th>السعر الإفرادى</th>
                        <th>الرسوم الجمركية</th>
                    </tr>
                </header>
                <tbody>
                    <?php $total_1 = 0 ; $total_2 = 0; ?>
                @foreach( $data['details'] as $key => $row)
                    <tr>
                        <td>{{ $key+1 }}</td>
                        <td>{{ $row->item_name }}</td>
                        <td>{{ $data['master']->country_name }}</td>
                        <td>{{ $row->customs_item_name }}</td>
                        <td>{{ $row->item_type }}</td>
                        <td>{{ $row->unit_name }}</td>
                        <td>{{ $row->qry }}</td>
                        <td>{{ $row->weight }}</td>
                        <td>{{ $row->amount }}</td>
                        <td>{{ $data['master']->currency_name  }}</td>
                        <td>{{  ($data['master']->equivalent_value) == 0 ? "-" :  $data['master']->equivalent_value }}</td>
{{--                   <td>{{ ($data['master']->equivalent_value * $row->amount)  == 0 ?  "-" : number_format( $data['master']->equivalent_value * $row->amount  , 2 , '.' , ',' )  }}</td>--}}
                        <td>{{ (  $row->amount / $row->qry ) == 0 ? "-" : number_format( ( $row->amount  /  $row->qry) , 2 , '.' , ',' ) }}</td>
                        <td>{{ ($row->custom_fees)  == 0 ?  "-" :  number_format( $row->custom_fees  , 2 , '.' , ',' )  }}</td>
                        <?php
                            $total_1 = $total_1 + ( $data['master']->equivalent_value * $row->amount ) ;
                            $total_2 = $total_2 + ( $data['master']->equivalent_value * $row->amount ) /  $row->qry ;
                        ?>


                    </tr>
                @endforeach
                </tbody>
                <tfoot>
                    <tr>
                        <th colspan="3"></th>
                        <th colspan="3">{{ date("Y-m-d") }}</th>
                        <th>{{ ($data['details']->sum('qry')) == 0 ? "-" :  number_format( $data['details']->sum('qry') , 2 , '.' , ',' ) }}</th>
                        <th>{{ ($data['details']->sum('weight')) == 0 ? "-" :   number_format( $data['details']->sum('weight') , 2 , '.' , ',' ) }}</th>
                        <th>{{ ($data['details']->sum('amount')) == 0 ? "-" :   number_format( $data['details']->sum('amount') , 2 , '.' , ',' ) }}</th>
                        <th></th>
                        <th></th>
{{--                        <th> {{ $total_1 == 0  ? "-" :  number_format( $total_1 , 2 , '.' , ',' ) }}</th>--}}
                        <th>{{--{{ $total_2 == 0  ? "-" :  number_format( $total_2 , 2 , '.' , ',' ) }}--}}</th>
                        <th>{{ ($data['details']->sum('custom_fees')) == 0 ? "-" :   number_format( $data['details']->sum('custom_fees') , 2 , '.' , ',' ) }}</th>
                        <th></th>
                        <td></td>

                    </tr>
                    <tr>
                        <th colspan="3">ملاحظات</th>
                        <th colspan="13">
                            {{ $data['master']->notes }}
                        </th>
                    </tr>
                </tfoot>
            </table>
        </div>

        <hr>

{{--        <div style="text-align:center;">--}}
{{--            E-mall: customer@amwajalmad.com--}}
{{--    Web Site : amwajalmad.business.site--}}
{{--    Jeddah 012 6272666 Riyadh 011 4762222--}}
{{--        </div>--}}

                <div style="text-align:center;">
                    {{ $data['master']->serial_number }}
                    {{ $data['master']->saber_no }}
                </div>

    </div>
    <p class="manager">{{ auth()->user()->user_full_name }}</p>

    @if(isset($_GET['type']) && $_GET['type'] == 'print')
        <script type="text/javascript">
            window.print();
            window.onfocus=function(){ window.close();}
        </script>
    @endif
</body>
</html>
