<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Print</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style type="text/css">
        * {
            direction: rtl;
        }
        page_break { page-break-before: always; }

        .main_div{
            width: 95%;
            min-height:230mm;
            font-size: 12px;
            /*height: auto;*/
            /*border: 1px solid #000;*/
            padding: 5px;
            position: relative;
            margin:0 auto;
            text-align: center;
        }
        .line_div{
            margin-bottom:5px;
        }
        .logo_cont{
            max-height: 120px;
            text-align: center;
        }
        p , h1 , h2 , h3 , h4 , h5 , h6{
            color: rgb(58, 75, 111);
            padding: 0px;
            margin: 0px;
        }
        thead{
            background-color: rgb(231 , 247, 253);
        }
        table{
            width: 100%;
            border-spacing: 0;
            border-collapse: collapse;
             -webkit-box-sizing: border-box;
               -moz-box-sizing: border-box;
                    box-sizing: border-box;
            margin: 3px;
        }
        .table-bordered th , .table-bordered td{
            text-align: center;
            border: 1px solid #ddd;
            padding:0px;
        }
        th , td{
            text-align: center;
            padding:0px;
        }

        .title{
            color: rgb(41,98, 121);
            font-weight: 600;
            font-size:14px;
        }
        .no_align{
            text-align: right;
        }
        .no_border , .no_border th , .no_border td{
            border:0px;
        }

        #selected_item_table th{
            background-color: #222E46 ;
            color: white;
        }
        .summary_table th{
            padding: 10px 30px 10px 30px;
            font-weight: 600;
            background-color: rgb(237 , 235, 235);
        }
        .summary_table td{
            padding: 10px 30px 10px 30px;
        }

        .qrcode_table{
            /*background-color:#A88C07;*/
            border: 0px;
            /*color: white;*/
        }
        .qrcode_table th{
            padding: 10px;
        }

        .footer{
            position: absolute;
    width: 100%;
    bottom: 0;
    left:7px;
        }
    </style>
</head>
<body>
    <div class="main_div">
        <table  class="table " style="border: 0px">
            <tr>
                <td  class="no_border" style="width: 40%;text-align: right;">
                    {!! $data['branch_data']->print_label_ar ?? '' !!}
                </td>
                <td  class="no_border" style="width: 20%">
                    <div class="logo_cont ">
                        <img src="{{ ($data['logo']) }}" class="img-responsive"  alt="Image" style="max-width: 100%;">
                    </div>
                    <div>
                        {{ $data['print_title'] ?? '' }}
                    </div>
                </td>
                <td  class="no_border" style="width: 40%;text-align: left;">
                    {!! $data['branch_data']->print_label_en ?? '' !!}
                </td>
            </tr>
        </table>
        <br>
        <div class="line_div" style="box-shadow: 3px 3px 0px 0px #50a1bf">
            <table class="table-bordered">
                <tr>
                    <td width="70%">
                        <table class="no_border">
                            <tr>
                                <td width="25%">
                                    <p class="title">السادة</p>
                                    <p class="title">customer</p>
                                </td>
                                <td width="75%">{{ $data['master']->customer_name }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="30%">
                        <table class="no_border">
                            <tr>
                                <td width="60%">
                                    <p class="title">رقم التسجيل الضريبي</p>
                                    <p class="title">Tax Reg. Number</p>
                                </td>
                                <td width="40%">{{ optional($data['master'])->vat_register_number }}</td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td colspan="2" >
                        <div style="width:70%;">

                            <table class="no_border">
                                <tr>
                                    <td width="25%">
                                        <p class="title">عنوان العميل</p>
                                        <p class="title">customer Address</p>
                                    </td>
                                    <td width="75%">{{ optional($data['master'])->address }}</td>
                                </tr>
                            </table>
                        </div>

                    </td>

                </tr>

            </table>
        </div>
        <div class="line_div" style="box-shadow: 3px 3px 0px 0px #50a1bf">
            <table class="table-bordered">
                <tr>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">رقم الفاتورة</p>
                                    <p class="title">Invovce No.</p>
                                </td>
                                <td width="60%"></td>
                            </tr>
                        </table>
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">التاريخ</p>
                                    <p class="title">Date</p>
                                </td>
                                <td width="60%">{{ $data['master']->action_date }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="50%">
                                    <p class="title">البيان الجمركي</p>
                                    <p class="title">Bayan no.</p>
                                </td>
                                <td width="50%">{{ optional($data['master'])->customs_declaration_number }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">رقم البوليصة</p>
                                    <p class="title">B/L no</p>
                                </td>
                                <td width="60%">{{ $data['master']->shipping_policy_no }}</td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">الفرع</p>
                                    <p class="title">Branch</p>
                                </td>
                                <td width="60%">{{ $data['master']->port_name ?? '' }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">رقم الملف </p>
                                    <p class="title">File No</p>
                                </td>
                                <td width="60%">{{ $data['master']->clearance_id ?? '' }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">نوع البضاعة</p>
                                    <p class="title">Goods Type</p>
                                </td>
                                <td width="60%">{{ $data['master']->goods_type ?? '' }}</</td>
                            </tr>
                        </table>
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">عدد الحاويات</p>
                                    <p class="title">No/Comt</p>
                                </td>
                                <td width="60%">
                                    {{ $data['master']->container_small }} X 40
                                    <br>
                                    {{ $data['master']->container_big }} X 40
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td colspan="4" width="100%">
                        <table class="no_border">
                            <tr>
                                <td width="15%">
                                    <p class="title">ارقام الحاويات</p>
                                    <p class="title">Countaner no.</p>
                                </td>
                                <td width="85%"> {{ $data['containers'] ?? "-" }}</td>
                            </tr>
                        </table>
                    </td>
                </tr>

            </table>
        </div>
        <div class="line_div">
            <table class="table-bordered">
                <thead>
                    <tr>
                        <th>
                            <p>رقم الايصال</p>
                            <p>File No</p>
                        </th>
                        <th>
                            <p>البيان</p>
                            <p>Details </p>
                        </th>
                        <th>
                            <p>القيمة قبل الضريبة</p>
                            <p>Value excl.VAT</p>
                        </th>
                        <th>
                            <p>الضريبة ٪</p>
                            <p>VAT %</p>
                        </th>
                        <th>
                            <p>قيمة الضريبة </p>
                            <p>Amound VAT </p>
                        </th>
                        <th>
                            <p>الاجمالي شامل الضريبة</p>
                            <p>Value including VAT</p>
                        </th>
                        <th>
                            <p>ملاحظات</p>
                            <p>Note</p>
                        </th>
                    </tr>
                </thead>
                <tbody>
                @if(isset($data['delegate_details']))
                    @foreach($data['delegate_details'] as $row)
                    <tr>
                        <td>{{ $row->receipt_number }}</td>
                        <td>{{ $row->expense_code_name }}</td>
                        <td>{{ $row->amount  == 0 ? "-" : number_format($row->amount , 2 , '.' , ',') }}</td>
                        <td> - </td>
                        <td> - </td>
{{--                        <td>{{ number_format($row->amount , 2 , '.' , ',')  }}</td>--}}
                        <td>
                            @if($row->amount == 0)
                                -
                            @else
                                {{ number_format($row->amount, 2, '.', ',') }}
                            @endif
                        </td>

                        <td>{{ $row->description }}</td>
                    </tr>
                    @endforeach

                @endif


                @if(isset($data['details']))
                    @foreach($data['details'] as $row)
                    <tr>
                        <td>{{ optional($row)->clearance_invoices_d_id }}</td>
                        <td>{{ $row->name_ar }} <br> {{ $row->name_en }}</td>
                        <td>{{ optional($row)->amount_without_vat == 0 ? "-" : number_format($row->vat_per , 2 ) }}</td>
                        <td>{{ number_format($row->vat_per , 2 ) }}</td>
                        <td>{{ number_format($row->vat_amount , 2 , '.' , ',') == 0 ? "-" : number_format($row->vat_amount , 2 , '.' , ',')."%" }}</td>
                        <td>@if(number_format($row->amount_with_vat , 2 , '.' , ',') == 0)
                                -
                            @else
                                {{number_format($row->amount_with_vat , 2 , '.' , ',')}}
                        @endif</td>
                        <td></td>
                    </tr>
                    @endforeach
                @endif

                </tbody>
            </table>
        </div>
        <div class="line_div">
            <table>
                <tr>
                    <td width="50%">
                        <div style="margin: 2px;background-color: rgb(249, 249, 249);padding: 5px;height: 50px;">
                            <table>
                                <tr>
                                    <td width="50%" style="text-align:right">ملاحظات</td>
                                    <td width="50%" style="text-align:left">note</td>
                                </tr>
                                <tr>
                                    <td colspan="2">

                                    </td>
                                </tr>
                            </table>
                        </div>
                    </td>
                    <td width="50%">
                        <div style="margin: 2px;background-color: rgb(249, 249, 249);padding: 5px;height: 50px;">
                            <table>
                                <tr>
                                    <td width="33.3%" style="text-align:right">غير شامل الضريبة</td>
                                    <td width="33.3%" style="text-align:center">
                                        {{ number_format(( $data['delegate_details']->sum('amout') + $data['details']->sum('amount_without_vat') ) , 2 , '.' ,',' ) }}
                                    </td>
                                    <td width="33.3%" style="text-align:left">Value excluding VAT</td>
                                </tr>
                                <tr>
                                    <td width="33.3%" style="text-align:right">قيمةالضريبة</td>
                                    <td width="33.3%" style="text-align:center;">
                                        {{ number_format( $data['details']->sum('vat_amount'), 2 , '.' ,',' ) }}
                                    </td>
                                    <td width="33.3%" style="text-align:left"> VAT Value</td>
                                </tr>
                                <tr>
                                    <td width="33.3%" style="text-align:right">القيمة شامل الضريبة</td>
                                    <td width="33.3%" style="text-align:center">
                                        {{ number_format(( $data['delegate_details']->sum('amout') + $data['details']->sum('amount_with_vat') ) , 2 , '.' ,',' ) }}
                                    </td>
                                    <td width="33.3%" style="text-align:left">Value including VAT</td>
                                </tr>
                            </table>
                        </div>
                    </td>
                </tr>
            </table>
        </div>
        <div class="line_div">
            <table>
                <tr>
                    <td width="50%" style="text-align:right">المستلم : </td>
                    <td width="50%" style="text-align:right">تاريخ الاستلام : </td>
                </tr>
                <tr>
                    <td width="50%" style="text-align:right">المحاسب : </td>
                    <td width="50%" style="text-align:right">المراجع : </td>
                </tr>

            </table>
        </div>
        <div class="footer">
            <table>
                <tr>
                    <td >
                        <div style="margin: 1px;background-color: rgb(249, 249, 249);padding: 5px;height: 70px;">
                            <table>
                                <tr>
                                    <td width="50%" style="text-align:left">
                                        <table>
                                            <tr>
                                                <td>بنك الاهلي</td>
                                                <td>NCB Bank IPAN : SA74 1234 1234 1234 1234 1234 </td>
                                            </tr>
                                            <tr>
                                                <td>بنك الرياض</td>
                                                <td>Riyad Bank IPAN : SA74 1234 1234 1234 1234 1234 </td>
                                            </tr>
                                            <tr>
                                                <td>بنك الراجحي</td>
                                                <td>Rajhi Bank IPAN : SA74 1234 1234 1234 1234 1234  </td>
                                            </tr>
                                        </table>
                                    </td>
                                    <td width="50%" style="text-align:left;">
                                            <img src="{{ $data['qrcode'] }}" alt="barcode" style="width: 70px;"  />
                                    </td>
                                </tr>

                            </table>
                        </div>
                    </td>

                </tr>
            </table>
            <hr>

            <div style="text-align:center;">
                E-mall: customer@amwajalmad.com
        Web Site : amwajalmad.business.site
        Jeddah 012 6272666 Riyadh 011 4762222
            </div>

        </div>

    </div>

    <script>
        window.onload = function() { window.print(); }
    </script>
</body>
</html>
