<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Print</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style type="text/css">
        * {
            direction: rtl;
            font-weight:900;
        }
        page_break { page-break-before: always; }

        .main_div{
            width: 98%;
            min-height:285mm;
            font-size: 12px;
            /*height: auto;*/
            /*border: 1px solid #000;*/
            padding: 5px;
            position: relative;
            margin:0 auto;
            text-align: center;
        }
        .line_div{
            margin-bottom:5px;
        }
        .logo_cont{
            max-height: 120px;
            text-align: center;
        }
        p , h1 , h2 , h3 , h4 , h5 , h6{
            color: rgb(58, 75, 111);
            padding: 0px;
            margin: 0px;
        }
        thead{
            background-color: rgb(231 , 247, 253);
        }
        table{
            width: 100%;
            border-spacing: 0;
            border-collapse: collapse;
             -webkit-box-sizing: border-box;
               -moz-box-sizing: border-box;
                    box-sizing: border-box;
            margin: 2px;
        }
        .table-bordered th , .table-bordered td{
            text-align: center;
            border: 1px solid #ddd;
            padding:0px;
        }
        th , td{
            text-align: center;
            padding:0px;
        }

        .title{
            color: rgb(41,98, 121);
            font-weight: 600;
            font-size:14px;
        }
        .content{
            color: rgb(41,98, 121);
            font-weight:900;
        }
        .no_align{
            text-align: right;
        }
        .no_border , .no_border th , .no_border td{
            border:0px;
        }

        #selected_item_table th{
            background-color: #222E46 ;
            color: white;
        }
        .summary_table th{
            padding: 10px 30px 10px 30px;
            font-weight: 600;
            background-color: rgb(237 , 235, 235);
        }
        .summary_table td{
            padding: 10px 30px 10px 30px;
        }

        .qrcode_table{
            /*background-color:#A88C07;*/
            border: 0px;
            /*color: white;*/
        }
        .qrcode_table th{
            padding: 10px;
        }

        .footer{
            position: absolute;
    width: 100%;
    bottom: 0;
    left:7px;
        }
    </style>
</head>
<body>
    <div class="main_div">
        <table  class="table " style="border: 0px">
            <tr>
                <td  class="no_border" style="width: 40%;text-align: right;">
                    {!! $data['branch_data']->print_label_ar ?? '' !!}
                </td>
                <td  class="no_border" style="width: 20%">
                    <div class="logo_cont ">
                        <img src="{{ ($data['logo']) }}" class="img-responsive"  alt="Image" style="max-width: 100%;max-height:70px">
                    </div>
                    <div>
                        فاتورة ضريبية
                    </div>
                </td>
                <td  class="no_border" style="width: 40%;text-align: left;">
                    {!! $data['branch_data']->print_label_en ?? '' !!}
                </td>
            </tr>
        </table>
        <br>
        <br>
        <br>
        <div class="line_div" style="box-shadow: 3px 3px 0px 0px #50a1bf">
            <table class="table-bordered">
                <tr>
                    <td width="65%">
                        <table class="no_border">
                            <tr>
                                <td width="150px">
                                    <p class="title">السادة</p>
                                    <p class="title">customer</p>
                                </td>
                                <td  style="text-align:right;font-weight:900;font-size:14px;" class="content">{{ $data['master']->customer_name }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="35%">
                        <table class="no_border">
                            <tr>
                                <td width="60%">
                                    <p class="title">رقم التسجيل الضريبي</p>
                                    <p class="title">VAT Reg. Number</p>
                                </td>
                                <td width="40%" class="content" >{{ optional($data['master'])->vat_register_number }}</td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">
                        <div style="width:100%;">

                            <table class="no_border">
                                <tr>
                                    <td width="150px">
                                        <p class="title">عنوان العميل</p>
                                        <p class="title">customer Address</p>
                                    </td>
                                    <td class="content" style="text-align:right;font-weight:900;font-size:14px;">{{ optional($data['master'])->address }}</td>
                                </tr>
                            </table>
                        </div>

                    </td>

                </tr>

            </table>
        </div>
        <div class="line_div" style="box-shadow: 3px 3px 0px 0px #50a1bf">
            <table class="table-bordered">
                <tr>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">الفرع</p>
                                    <p class="title">Branch</p>
                                </td>
                                <td width="60%" class="content">{{ $data['master']->port_name ?? '' }}</td>
                            </tr>
                        </table>
                        
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="45%">
                                    <p class="title">رقم الفاتورة</p>
                                    <p class="title">Invoice No</p>
                                </td>
                                <td width="55%" class="content">{{ $data['master']->id }}</td>
                            </tr>
                        </table>
                        
                        
                    </td>
                    <td width="20%">
                        <table class="no_border">
                            <tr>
                                <td width="50%">
                                    <p class="title">رقم البيان</p>
                                    <p class="title">Bayan no</p>
                                </td>
                                <td width="50%" class="content">{{ $data['master']->customs_declaration_number }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="30%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">رقم البوليصة</p>
                                    <p class="title">B/L no</p>
                                </td>
                                <td width="60%" class="content">{{ $data['master']->shipping_policy_no }}</td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title">رقم الملف </p>
                                    <p class="title">File No</p>
                                </td>
                                <td width="60%" class="content">{{ $data['master']->clearance_id ?? '' }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="25%">
                        <table class="no_border">
                            <tr>
                                <td width="45%">
                                    <p class="title">تاريخ الفاتورة</p>
                                    <p class="title">Inv Date</p>
                                </td>
                                <td width="55%" class="content">{{ $data['master']->invoice_date }}</td>
                            </tr>
                        </table>
                    </td>
                    <td width="20%">
                        <table class="no_border">
                            <tr>
                                <td width="50%">
                                    <p class="title">تاريخ البيان</p>
                                    <p class="title">Bayan Date</p>
                                </td>
                                <td width="50%" class="content">{{ $data['master']->customs_declaration_date ?? '' }}</</td>
                            </tr>
                        </table>
                    </td>
                    <td width="30%">
                        <table class="no_border">
                            <tr>
                                <td width="40%">
                                    <p class="title" >عدد الحاويات</p>
                                    <p class="title">No/Comt</p>
                                </td>
                                <td width="60%" style="direction: ltr;" class="content">
                                    {{ $data['master']->container_small }} X 20
                                    <br>
                                    {{ $data['master']->container_big }} X 40
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <td colspan="4" width="100%">
                        <table class="no_border">
                            <tr>
                                <td width="15%">
                                    <p class="title">ارقام الحاويات</p>
                                    <p class="title">Countaner no.</p>
                                </td>
                                <td width="85%" class="content">
                                    @php
                                        $containers = explode(',', $data['containers']);
                                    @endphp
                                
                                    @if(count($containers) > 5)
                                        {{ implode(', ', array_slice($containers, 0, 5)) }} +{{ count($containers) - 5 }}
                                    @else
                                        {{ implode(', ', $containers) }}
                                    @endif

                                </td>
                                </tr>
                        </table>
                    </td>
                </tr>

            </table>
        </div>
        <div class="line_div">
            <table class="table-bordered">
                <thead>
                    <tr>
                        <th width="75px">
                            <p>رقم الايصال</p>
                            <p>File No</p>
                        </th>
                        <th width="150px">
                            <p>البيان</p>
                            <p>Details </p>
                        </th>
                        <th>
                            <p>القيمة قبل الضريبة</p>
                            <p>Value excl.VAT</p>
                        </th>
                        <th>
                            <p>الضريبة ٪</p>
                            <p>VAT %</p>
                        </th>
                        <th>
                            <p>قيمة الضريبة </p>
                            <p>Amound VAT </p>
                        </th>
                        <th>
                            <p>الاجمالي شامل الضريبة</p>
                            <p>Value including VAT</p>
                        </th>
                        <th>
                            <p>ملاحظات</p>
                            <p>Note</p>
                        </th>
                    </tr>
                </thead>
                <tbody>
                @if(isset($data['delegate_details']))
                    @foreach($data['delegate_details'] as $row)
                    <tr>
                        <td class="item_content">{{ explode(',' , $row->receipt_number)[0] ?? "-" }}</td>
                        <td class="item_content">{{ $row->name_ar }} <br> {{ $row->name_en }}</td>
                        <td class="item_content">{{ $row->amount  == 0 ? "-" : number_format($row->amount , 2 , '.' , ',') }}</td>
                        <td class="item_content"> - </td>
                        <td class="item_content"> - </td>
                        <td class="item_content">
                            @if($row->amount == 0)
                                -
                            @else
                                {{ number_format($row->amount, 2, '.', ',') }}
                            @endif
                        </td>

                        <td class="item_content" width="20%">{{ $row->description }}</td>
                    </tr>
                    @endforeach

                @endif


                @if(isset($data['details']))
                    @foreach($data['details'] as $key => $row)
                    <tr>
                        <td>-</td>
                        <td>{{ $row->name_ar }} <br> {{ $row->name_en }}</td>
                        <td>{{ $row->amount_without_vat == 0 ? "-" : number_format($row->amount_without_vat , 2 ) }}</td>
                        <td>{{ "%".number_format($row->vat_per , 0 ) }}</td>
                        <td>{{ ($row->vat_amount == 0 ? "-" : number_format($row->vat_amount , 2 , '.' , ',')) }}</td>
                        <td>@if(number_format($row->amount_with_vat , 2 , '.' , ',') == 0)
                                -
                            @else
                                {{number_format($row->amount_with_vat , 2 , '.' , ',')}}
                        @endif</td>
                        <td>{{ $row->description }}</td>
                    </tr>
                    @endforeach
                @endif

                </tbody>
                <tfoot>
                                        <tr>
                        <td colspan="2"  style="border-color:white;text-align:right;border-left-color: lightgray;">المستلم :</td>
                        <td style="font-size: 10px;">
                            اجمالي القيمة قبل الضريبة
                            <br>
                            Total value without VAT
                        </td>
                        <td rowspan="2">%15</td>
                        <td style="font-size: 10px;">
                            اجمالي قيمة الضريبة
                            <br>
                            Total VAT Amount
                        </td>
                        <td style="font-size: 10px;">
                            صافي الفاتورة شامل الضريبة
                            <br>
                            Net Invoice value with VAT
                        </td>
                        <td style="border-color:white;text-align:right;border-rghit-color: lightgray;padding:0px 10px 0px 10px;"> المحاسب :</td>

                    </tr>
                    <tr>
                        <td colspan="2" style="border-color:white;text-align:right;border-left-color: lightgray;">تاريخ الاستلام :</td>
                        <td style="padding:5px"> {{ number_format(( $data['delegate_details']->sum('amount') + $data['details']->sum('amount_without_vat') ) , 2 , '.' ,',' ) }}</td>
                        <td style="padding:5px"> {{ number_format(( $data['details']->sum('vat_amount') ) , 2 , '.' ,',' ) }}</td>
                        <td style="padding:5px"> {{ number_format(( $data['delegate_details']->sum('amount') + $data['details']->sum('amount_with_vat') ) , 2 , '.' ,',' ) }}</td>
                        <td style="border-color:white;text-align:right;border-rghit-color: lightgray;padding:0px 5px 0px 5px;"> المراجع : </td>

                    </tr>
                    <tr>
                        <td colspan="2" style="border-color:white;text-align:right;border-left-color: lightgray;"></td>
                        <td colspan="4" style="padding:10px"> 
                            {{ $data['tafqeet'] }}
                        </td>
                    </tr>
                
                </tfoot>
            </table>
        </div>

        <div>
            <table>

                <tr>
                    <td >
                        <div style="margin: 1px;background-color: rgb(249, 249, 249);padding: 5px;height: 130px;">
                            <table>
                                <tr>
                                    <td width="75%" style="text-align:left;font-weight:900;font-size:14px">
                                        <table style="border:1px solid gray;padding:10px" >
                                            <tr >
                                                <td rowspan="3"style="border:1px solid gray;" >
                                                    معلومات الحسابات البنكية 
                                                    <br>
                                                    Bank Account Details
                                                </td>
                                                <td style="text-align:center;">بنك الاهلي</td>
                                                <td style="text-align:center;">NCB Bank  </td>
                                                <td style="padding:5px">IBAN : SA96 1000 0021 4000 0008 3210 </td>
                                            </tr>
                                            <tr>
                                                <td style="text-align:center;">بنك الرياض</td>
                                                <td style="text-align:center;">Riyad Bank  </td>
                                                <td style="padding:5px">IBAN : SA74 2000 0002 0412 1188 9940 </td>
                                                
                                            </tr>
                                            <tr>
                                                <td style="text-align:center;">بنك الراجحي</td>
                                                <td style="text-align:center;">Rajhi Bank  </td>
                                                <td style="padding:5px" >IBAN : SA75 8000 0125 6080 1098 9226  </td>
                                                
                                            </tr>
                                        </table>
                                    </td>
                                    <td width="25%" style="text-align:left;">
                                            <img src="{{ $data['qrcode'] }}" alt="barcode" style="width: 130px;"  />
                                    </td>
                                </tr>

                            </table>
                        </div>
                    </td>

                </tr> 
            </table>
            <hr>

            <div style="text-align:center;">
                E-mall: customer@amwajalmad.com
        Web Site : amwajalmad.business.site
        Jeddah 012 6272666 Riyadh 011 4762222
            </div>

        </div>

    </div>


    @if(isset($data['attachments']))
        @foreach($data['attachments'] as $img)
            <div class="line_div">
                <img src="{{ public_path($img) }}" style="width:100%;max-height:300mm;" />
            </div>
        @endforeach
    @endif

    
    <script>
        window.onload = function() { window.print(); }
    </script>
</body>
</html>
