<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Print</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style type="text/css">
        * {
        box-sizing: border-box;
        padding-top: 0 !important;
        padding-bottom: 0px !important;
        }

        @media screen {
        html {
            background: #5F6368;
        }
        .footer {
            position: absolute;
            bottom: 0;
        }
        }
        @font-face {
        font-family: arial;
        src: url("/resources/fonts/arial.ttf");
        }
        @page {
        size: A4 portrait;
        margin: default !important;
        }
        @media print {
        .heightMm {
            height: 10mm !important;
        }
        .footer {
            position: fixed;
            bottom: 0;
        }
        }
        body {
        font-family: arial;
        display: flex;
        justify-content: center;
        margin: 0px !important;
        padding: 0px !important;
        border: 0px;
        font-size: 12px;
        }
        body .A4 {
        width: 100%;
        margin: 0px auto;
        padding: 0px;
        border: 0px;
        }
        body .A4 .page-inner {
        position: relative;
        background: white;
        width: 21cm;
        min-height: 29.7cm;
        margin: 0 auto !important;


        }
        body .A4 .page-inner:before{
            content:'';
            position:absolute;
            width:100%;
            height:100%;
            background-image: url({!! url($data['branch_data']->branch_image) ?? '' !!});
            background-size:300px;
            background-repeat: no-repeat;
            background-position: center;
            opacity :0.1;
        }
        body .A4 .headerParent .header {
        height: 130px;
        background-color: #222F77;
        color: white;
        padding: 0 15px;
        }
        body .A4 .headerParent .header .heade_content {
        padding-top: 1rem !important;
        display: flex !important;
        justify-content: space-between !important;
        align-items: center !important;
        }
        body .A4 .headerParent .header .heade_content p {
        margin: 5px 0;
        }
        body .A4 .headerParent .header .heade_content .en_content {
        text-align: start;
        width: 33.333%;
        }
        body .A4 .headerParent .header .heade_content .ar_content {
        text-align: end;
        width: 33.333%;
        }
        body .A4 .headerParent .inv_details {
        display: flex;
        align-items: center;
        margin-top: 1rem;
        padding: 0 5rem;
        font-weight: bold;
        }
        body .A4 .headerParent .inv_details .inv_date {
        width: 30%;
        }
        body .A4 .headerParent .inv_details .inv_number {
        border: 1px solid #000;
        border-radius: 6px;
        width: 250px;
        margin-top: 0.3rem;
        text-align: center;
        }
        body .A4 .headerParent .inv_details .inv_number .box {
        display: flex;
        justify-content: space-around;
        height: 30px;
        border: 1px solid #000;
        }
        body .A4 .headerParent .inv_details .inv_number .box .inv-name,
        body .A4 .headerParent .inv_details .inv_number .box .inv-serial {
        width: 50%;
        }
        body .A4 .headerParent .inv_details .inv_number .box .inv-name h5,
        body .A4 .headerParent .inv_details .inv_number .box .inv-serial h5 {
        margin-top: 2px;
        margin-bottom: -2px;
        font-size: 10px;
        }
        body .A4 .headerParent .inv_details .inv_number .box .inv-serial h5 {
        margin-top: 10px;
        }
        body .A4 .headerParent .inv_details .inv_number .box .inv-name {
        border-left: 2px solid #000;
        }
        body .A4 .headerParent .customer_details {
        padding: 0 25px;
        }
        body .A4 .headerParent .customer_details div {
        display: flex;
        justify-content: end;
        margin-bottom: -15px !important;
        }
        body .A4 .headerParent .customer_details div .space {
        margin-left: 15px;
        margin-right: 15px;
        }
        body .A4 .parent_td {
        border: 1px solid white !important;
        padding: 0 !important;
        }
        body .A4 .statement {
        display: flex;
        padding: 0 15px;
        margin-top: 1rem;
        font-weight: bold;
        }
        body .A4 .statement .row_description {
        display: flex;
        justify-content: space-between;
        align-items: center;
        }
        body .A4 .statement .row_description .ExportCo {
        font-weight: 100 !important;
        }
        body .A4 .statement table {
        width: 49%;
        }
        body .A4 .table_footer .Qr_total {
        display: flex;
        justify-content: start;
        padding-left: 10rem !important;
        padding-top: 1rem !important;
        }
        body .A4 .table_footer .Receiver {
        display: flex;
        justify-content: space-around;
        }
        body .A4 table {
        border-collapse: collapse;
        width: 100%;
        margin: 0px auto;
        text-align: center;
        }
        body .A4 table th {
        background-color: transparent;
        }
        body .A4 table th,
        body .A4 table td {
        border: 1px solid #000;
        padding: 2px 5px !important;
        text-align: center;
        }
        body .footer {
        width: 100%;
        height: 50px;
        margin: 0px auto;
        text-align: center;
        background-color: #222F77;
        background-size: auto;
        background-position: center;
        color: white;
        padding: 0 15px;
        }
        body .footer .contact_us {
        font-size: 16px;
        }
        body .footer .contact_us div {
        display: flex;
        justify-content: center;
        align-items: center;
        margin-top: 0.5rem;
        }
        body .footer .contact_us p {
        margin-left: 5px;
        margin-right: 5px;
        margin-block: 0;
        }/*# sourceMappingURL=style.css.map */
    </style>
</head>
<body>
    <section class="A4">
      <div class="page-inner">

        <table class="top">
          <!-- header -->
          <thead>
            <tr>
              <td class="parent_td">
                <section class="headerParent">
                  <section class="header">
                    <section class="heade_content">
                      <div class="en_content">
                        {!! $data['branch_data']->print_label_en ?? '' !!}
                        {{-- <p>Abdullah O. Al-Barrak For Custom Clearance</p>
                        <p>VAT No.: 300151673100003</p>
                        <p>C.R.: 1010496112</p>
                        <p>License No.: 1356</p> --}}
                      </div>
                      <img src={!! url($data['branch_data']->branch_image) ?? '' !!} alt="logo" width="100">
                      <div class="ar_content">
                        {!! $data['branch_data']->print_label_ar ?? '' !!}

                        {{-- <p>مؤسسة عبدالله عمر البراك للتخليص الجمركي</p>
                        <p>الرقم الضريبي: ۳۰۰۱۵۱۶۷۳۱۰۰۰۰۳</p>
                        <p>س ت: ١٠١٠٤٩٦١١٢</p>
                        <p>رقم الرخصة : ١٣٥٦</p> --}}
                      </div>
                    </section>
                  </section>
                  <section class="inv_details">
                    <div class="inv_date">
                        {{ $data['master']->action_date }}
                    </div>
                    <div class="inv_number">
                      <div class="box">
                        <div class="inv-serial">
                          <h5>{{ optional($data['master'])->id }}</h5>
                        </div>
                        <div class="inv-name">
                          <h5>فاتورة ضريبة</h5>
                          <h5>VAT Invoice</h5>
                        </div>
                      </div>

                    </div>
                  </section>
                  <section class="customer_details">
                    <div>
                      <h5>{{ $data['master']->customer_name }}</h5>
                      <h5 class="space">/</h5>
                      <h5>السادة</h5>
                    </div>
                    <div>
                      <h5>{{ optional($data['master'])->vat_register_number }}</h5>
                      <h5 class="space">/</h5>
                      <h5>الرقم الضريبي</h5>
                    </div>
                    <div>
                      <h5>{{ optional($data['master'])->address }}</h5>
                      <h5 class="space">/</h5>
                      <h5>العنوان</h5>
                    </div>
                  </section>
                </section>
              </td>
            </tr>
          </thead>

          <!-- body -->
          <tbody class="tBody">
            <tr>
              <td class="parent_td">
                <section class="statement">
                  <table>
                    <thead>
                      <tr>
                        <th colspan="2">بيانات المعاملة</th>
                      </tr>
                    </thead>
                    <tbody>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Ser No</span>
                            <span>رقم المعامله</span>
                          </div>
                        </td>
                        <td>{{ $data['master']->clearance_id ?? '' }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Bill No</span>
                            <span>رقم البوليصة</span>
                          </div>
                        </td>
                        <td>{{ $data['master']->shipping_policy_no }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Cont. No</span>
                            <span>رقم الحاوية</span>
                          </div>
                        </td>
                        <td>{{ $data['containers'] ?? "-" }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Cont. Qty</span>
                            <span>عدد الحاويات</span>
                          </div>
                        </td>
                        <td>40*1</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Weight</span>
                            <span>الوزن</span>
                          </div>
                        </td>
                        <td>{{ $data['master']->weight }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Export Co</span>
                            <span>الشركة المصدرة</span>
                          </div>
                        </td>
                        <td width="40%" class="ExportCo">{{ $data['master']->exporting_company }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Bayan No</span>
                            <span>رقم البيان</span>
                          </div>
                        </td>
                        <td>{{ optional($data['master'])->customs_declaration_number }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Bayan Date</span>
                            <span>تاريخ البيان</span>
                          </div>
                        </td>
                        <td>{{ optional($data['master'])->customs_declaration_date }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Goods Type</span>
                            <span>نوع البضاعة</span>
                          </div>
                        </td>
                        <td width="40%">{{ $data['master']->goods_type ?? '' }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Doc Date</span>
                            <span>تاريخ المستندات</span>
                          </div>
                        </td>
                        <td>{{ optional($data['master'])->arrival_date }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Dammam Arrival</span>
                            <span>وصول الدمام</span>
                          </div>
                        </td>
                        <td>{{ optional($data['master'])->mainfest_date_hijri }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Riyadh Arrival</span>
                            <span>وصول الرياض</span>
                          </div>
                        </td>
                        <td>{{ optional($data['master'])->unloading_date }}</td>
                      </tr>

                      <tr>
                        <td>
                          <div class="row_description">
                            <span>Exp Date</span>
                            <span>تاريخ الانتهاء</span>
                          </div>
                        </td>
                        <td>{{ $data['master']->expiry_date ?? '' }}</td>
                      </tr>

                      @if(isset($data['banks']))
                        @foreach($data['banks'] as $row)
                            <tr>
                                <td colspan="2">
                                <div class="row_description">
                                    <span>{{$row->iban}}</span>
                                    <span>{{$row->name}}</span>
                                </div>
                                </td>
                            </tr>
                        @endforeach
                    @endif
                    </tbody>
                  </table>

                  <table>
                    <thead>
                      <tr>
                        <th>البيان</th>
                        <th>المبلغ</th>
                      </tr>
                    </thead>
                    <tbody>
                    @if(isset($data['details']))
                        @foreach($data['details'] as $row)
                            <tr>
                                <td>
                                  <div class="row_description">
                                    <span>{{ $row->name_en }}</span>
                                    <span>{{ $row->name_ar }}</span>
                                  </div>
                                </td>
                                <td> @if(number_format($row->amount_with_vat , 2 , '.' , ',') == 0)
                                    -
                                @else
                                    {{number_format($row->amount_with_vat , 2 , '.' , ',')}}
                                @endif</td></td>
                              </tr>
                        @endforeach
                    @endif
                    <tr>
                        <td colspan="2">عمليات التخليص</td>
                    </tr>
                    @if(isset($data['delegate_details']))
                        @foreach($data['delegate_details'] as $row)
                        <tr>
                            <td>
                              <div class="row_description">
                                <span>{{ $row->name_en }}</span>
                                <span>{{ $row->name_ar }}</span>
                              </div>
                            </td>
                            <td>{{ $row->amount  == 0 ? "-" : number_format($row->amount , 2 , '.' , ',') }}</td>
                        </tr>
                        @endforeach
                    @endif
                    </tbody>
                  </table>
                </section>
                <section class="table_footer">
                  <div class="Qr_total">
                    <div><img src="{{ $data['qrcode'] }}" alt="" width="120"></div>
                  </div>
                  <h2>
                    The sum of {{$data['tafqeet']}} مبلغ وقدره
                  </h2>
                  <div class="Receiver">
                    <div>
                      <h3>Manager المدير</h3>
                      <h5>...............................</h5>
                    </div>
                    <div>
                      <h3>Receiver المستلم</h3>
                      <h5>...............................</h5>
                    </div>
                    <div>
                      <h3>Accountant المحاسب</h3>
                      <h5>...............................</h5>
                    </div>
                  </div>
                </section>

              </td>
            </tr>
          </tbody>

          <!-- DONT DELETE THIS CONTENET -->
          <tfoot>
            <tr>
              <td class="heightMm parent_td">
                <!-- Adjust height as needed to compensate for footer -->
              </td>
            </tr>
          </tfoot>
        </table>

        <!-- Footer [ ADD FOOTER CONTENT HERE ]-->
        <section class="footer">
          <div class="contact_us">
            <div>
              <p>Riyadh - Malaz - Prince fahad Bin Ibrahim Al Saud St</p>
              <p>-</p>
              <p>Mobile: 0504288920</p>
            </div>
            <p>E-mail: albarrak4cc@gmail.com</p>
          </div>
        </section>
      </div>
    </section>
    <script>
        window.onload = function() { window.print(); }
    </script>
  </body>
</html>
