<?php

use Illuminate\Support\Facades\Route;

Route::group(['prefix'=>'v1/{lang}', 'where' => ['lang' => 'en|ar'], "namespace"=>"App\Http\Controllers\API\V1"], function(){

    Route::post('/login', "AuthController@login");


    Route::group(['middleware' => 'auth:api'], function(){


        Route::get('/get_gregorian_data/{date}',"GeneralController@get_gregorian_data");
        Route::get('/get_hijri_data/{date}',"GeneralController@get_hijri_data");

        Route::get('/get_aval_clearances', "TreatmentController@get_aval_clearances");
        Route::get('/get_aval_clearances_short', "TreatmentController@get_aval_clearances_short");
        Route::get('/get_clearance_containers/{id}', "TreatmentController@get_clearance_containers");

        Route::get('/get_my_profile', "GeneralController@get_my_profile");
        Route::post('/update_profile', "GeneralController@update_profile");
        Route::post('/change_password', "Main\UserController@change_password");
        Route::post('/change_user_defaults', "Main\UserController@change_user_defaults");

        Route::resource('/setting', "Main\SettingController");

        Route::resource('/user', "Main\UserController");
        Route::post('/update_permission/{id}', "Main\UserController@update_permission");
        Route::post('/user_toggle_active/{id}', "Main\UserController@toggle_active");

        Route::resource('/drafts', "Main\DraftController");

        Route::resource('/branch', "Main\BranchController");
        Route::post('/branch_sort', "Main\BranchController@sort_post");
        Route::post('/branch_toggle_active/{id}', "Main\BranchController@toggle_active");

        Route::resource('/bank', "Main\BankController");
        Route::post('/bank_sort', "Main\BankController@sort_post");
        Route::post('/bank_toggle_active/{id}', "Main\BankController@toggle_active");

        Route::resource('/network_machine', "Main\NetworkMachineController");

        Route::post('/network_machine_sort', "Main\NetworkMachineController@sort_post");
        Route::post('/network_machine_toggle_active/{id}', "Main\NetworkMachineController@toggle_active");

        Route::resource('/finance_year', "Main\FinanceYearController");
        Route::post('/finance_year_sort', "Main\FinanceYearController@sort_post");
        Route::post('/finance_year_toggle_active/{id}', "Main\FinanceYearController@toggle_active");
        Route::post('/update_users_year', "Main\FinanceYearController@update_users_year");

        Route::resource('/daily_type', "Main\DailyTypeController");
        Route::post('/daily_type_sort', "Main\DailyTypeController@sort_post");
        Route::post('/daily_type_toggle_active/{id}', "Main\DailyTypeController@toggle_active");

        Route::resource('/partner', "Main\PartnerController");
        Route::post('/partner_sort', "Main\PartnerController@sort_post");
        Route::post('/partner_toggle_active/{id}', "Main\PartnerController@toggle_active");

        Route::resource('/screen_main', "Main\ScreenMainController");
        Route::post('/screen_main_sort', "Main\ScreenMainController@sort_post");
        Route::post('/screen_main_toggle_active/{id}', "Main\ScreenMainController@toggle_active");

        Route::resource('/screen_cat', "Main\ScreenCatController");
        Route::post('/screen_cat_sort', "Main\ScreenCatController@sort_post");
        Route::post('/screen_cat_toggle_active/{id}', "Main\ScreenCatController@toggle_active");

        Route::resource('/screen_sub', "Main\ScreenSubController");
        Route::post('/screen_sub_sort', "Main\ScreenSubController@sort_post");
        Route::post('/screen_sub_toggle_active/{id}', "Main\ScreenSubController@toggle_active");

        Route::resource('/sales_agent', "Main\SalesAgentController");
        Route::post('/sales_agent_sort', "Main\SalesAgentController@sort_post");
        Route::post('/sales_agent_toggle_active/{id}', "Main\SalesAgentController@toggle_active");

        Route::resource('/title', "Main\TitleController");
        Route::post('/title_toggle_active/{id}', "Main\TitleController@toggle_active");

        Route::resource('/input',"Main\InputController");
        Route::get('/get_screen_inputs/{id}', "Main\InputController@get_screen_inputs");
        Route::get('/all_screens_inputs', "Main\InputController@all_screens_inputs");

        Route::resource('/not_allowed_time',"Main\NotAllowedTimeController");
        // Finance

        Route::resource('/account_tree', "Finance\AccountTreeController");
        Route::post('/account_tree_toggle_active/{id}', "Finance\AccountTreeController@toggle_active");

        Route::resource('/cost_center', "Finance\CostCenterController");
        Route::post('/cost_center_toggle_active/{id}', "Finance\CostCenterController@toggle_active");

        Route::resource('/daily_journal', "Finance\DailyJournalController");
        Route::post('/daily_journal_toggle_active/{id}', "Finance\DailyJournalController@toggle_active");
        Route::post('/export_journal_data/{id}', "Finance\DailyJournalController@export_journal_data");
        Route::post('/add_daily_journal_attach/{id}', "Finance\DailyJournalController@add_daily_journal_attach");
        Route::get('/get_daily_journal_attach/{id}', "Finance\DailyJournalController@get_daily_journal_attach");
        Route::get('/daily_journal_search', "Finance\DailyJournalController@daily_journal_search");

        Route::resource('/treasury', "Finance\TreasuryController");
        Route::post('/treasury_sort', "Finance\TreasuryController@sort_post");
        Route::post('/treasury_toggle_active/{id}', "Finance\TreasuryController@toggle_active");

        Route::resource('/financial_period', "Finance\FinancialPeriodController");
        Route::get('/get_close_finance_year/{id}', "Finance\FinancialPeriodController@get_close_finance_year");
        Route::post('/close_finance_year/{id}', "Finance\FinancialPeriodController@close_finance_year");

        Route::resource('/receipt_voucher', "Finance\ReceiptVoucherController");
        Route::post('/receipt_voucher_toggle_active/{id}', "Finance\ReceiptVoucherController@toggle_active");
        Route::post('/export_receipt_voucher/{id}', "Finance\ReceiptVoucherController@export_data");

        Route::resource('/payment_voucher', "Finance\PaymentVoucherController");
        Route::post('/payment_voucher_toggle_active/{id}', "Finance\PaymentVoucherController@toggle_active");
        Route::post('/export_payment_voucher/{id}', "Finance\PaymentVoucherController@export_data");

        Route::resource('/multi_voucher_attach', "Finance\MultiVoucherAttachController");
        Route::get('/download_multi_voucher_detail_attachment/{id}', "Finance\MultiVoucherAttachController@download_attach");
        Route::post('/add_multi_voucher_details_attachment/{id}', "Finance\MultiVoucherAttachController@add_details_attach");
        Route::delete('/delete_multi_voucher_detail_attachment/{id}', "Finance\MultiVoucherAttachController@delete_details_attach");


        Route::resource('/multi_voucher', "Finance\MultiVoucherController");
        Route::post('/add_multi_voucher_attachment/{id}', "Finance\MultiVoucherController@add_attach");
        Route::post('/add_multi_voucher_details_attach/{id}', "Finance\MultiVoucherController@add_details_attach");
        Route::get('/download_multi_voucher_detail_attach/{id}', "Finance\MultiVoucherController@download_detail_attach");
        Route::get('/download_multi_voucher_attachment/{id}', "Finance\MultiVoucherController@download_attach");
        Route::delete('/delete_multi_voucher_detail_attach/{id}', "Finance\MultiVoucherController@delete_details_attach");
        Route::delete('/delete_multi_voucher_attachment/{id}', "Finance\MultiVoucherController@delete_attach");

        Route::post('/export_multi_voucher/{id}', "Finance\MultiVoucherController@export_data");
        Route::post('/multi_voucher_toggle_active/{id}', "Finance\MultiVoucherController@toggle_active");

        Route::get('/cheque_incoming', "Finance\ChequeIncomingController@index");
        Route::post('/cheque_incoming_status/{id}', "Finance\ChequeIncomingController@changeChequeStatus");

        Route::get('/cheque_outgoing', "Finance\ChequeOutgoingController@index");
        Route::post('/cheque_outgoing_status/{id}', "Finance\ChequeOutgoingController@changeChequeStatus");

        Route::get('/account_statment_anal_report', "Finance\ReportController@account_statment_anal_report_get");
        Route::post('/account_statment_anal_report', "Finance\ReportController@account_statment_anal_report_post");

        Route::get('/account_statment_yearly_report', "Finance\ReportController@account_statment_yearly_report_get");
        Route::post('/account_statment_yearly_report', "Finance\ReportController@account_statment_yearly_report_post");


        Route::get('/main_account_balances' , "Finance\ReportController@main_account_balances_get");
        Route::post('/main_account_balances' , "Finance\ReportController@main_account_balances_post");

        Route::get('/cost_center_statement' , "Finance\ReportController@cost_center_statement_get");
        Route::post('/cost_center_statement' , "Finance\ReportController@cost_center_statement_post");

        Route::post('/trial_balance_report', "Finance\ReportController@trial_balance_report");

        Route::resource('/expense_code', "Finance\ExpenseCodeController");
        Route::post('/expense_code_toggle_active/{id}', "Finance\ExpenseCodeController@toggle_active");

        Route::resource('/tax', "Finance\TaxController");
        Route::post('/tax_toggle_active/{id}', "Finance\TaxController@toggle_active");

        Route::resource('/currency', "Finance\CurrencyController");
        Route::post('/currency_toggle_active/{id}', "Finance\CurrencyController@toggle_active");

        Route::resource('/related_partie', "Finance\RelatedPartieController");
        Route::post('/related_partie_toggle_active/{id}', "Finance\RelatedPartieController@toggle_active");

        Route::resource('/bank_transfer', "Finance\BankTransferController");
        Route::post('/bank_transfer_toggle_active/{id}', "Finance\BankTransferController@toggle_active");

        Route::resource('/delegate_petty', "Finance\DelegatePettyController");
        Route::post('/delegate_petty_toggle_active/{id}', "Finance\DelegatePettyController@toggle_active");
        Route::get('/get_delegate_balance/{id}', "Finance\DelegatePettyController@get_delegate_balance");
        Route::get('/get_delegate_petty_without_attachment', "Finance\DelegatePettyController@get_delegate_petty_without_attachment_get");
        Route::post('/get_delegate_petty_without_attachment/{id}', "Finance\DelegatePettyController@get_delegate_petty_without_attachment_post");
        Route::get('/get_delegate_petty_d/{id}', "Finance\DelegatePettyController@get_delegate_petty_d");
        Route::post('/export_delegate_petty/{id}', "Finance\DelegatePettyController@export_data");
        Route::post('/upload_delegate_petty/{id}', "Finance\DelegatePettyController@upload_file");

        Route::resource('/maintenance_petty', "Finance\MaintenancePettyController");
        Route::post('/maintenance_petty_toggle_active/{id}', "Finance\MaintenancePettyController@toggle_active");
        Route::post('/export_maintenance_petty/{id}', "Finance\MaintenancePettyController@export_data");

        Route::get('/customer_statement_report', "Finance\ReportController@customer_statement_get");
        Route::post('/customer_statement_report', "Finance\ReportController@customer_statement_post");

        Route::get('/delegate_statement_report', "Finance\ReportController@delegate_statement_get");
        Route::post('/delegate_statement_report', "Finance\ReportController@delegate_statement_post");

        Route::get('/balanced_by_main_customers_report', "Finance\ReportController@balanced_by_main_customers_get");
        Route::post('/balanced_by_main_customers_report', "Finance\ReportController@balanced_by_main_customers_post");

        Route::post('/tax_declaration_post', "Finance\ReportController@tax_declaration_post");

        Route::post('/profit_and_loss_report', "Finance\ReportController@profit_and_loss_report_post");

        // financial statements

        Route::resource('/financial_statements',"FinancialStatements\FinancialStatementsController");
        Route::post('/statement_toggle_active',"FinancialStatements\FinancialStatementsController@toggle_active");

        Route::resource('/financial_collections',"FinancialStatements\FinancialCollectionsController");

        Route::get('/statement_report', "FinancialStatements\FinancialStatementsController@get_report");

        // Sales
        Route::resource('/quotation', "Sales\QuotationController");
        Route::post('/quotation_toggle_active/{id}', "Sales\QuotationController@toggle_active");
        Route::get('/quotation_by_customer', "Sales\QuotationController@get_by_customer");

        Route::resource('/covenant_type', "Sales\CovenantTypeController");
        Route::post('/covenant_type_toggle_active/{id}', "Sales\CovenantTypeController@toggle_active");

        Route::resource('/delegate', "Sales\DelegateController");
        Route::post('/delegate_toggle_active/{id}', "Sales\DelegateController@toggle_active");

        Route::resource('/customer', "Sales\CustomerController");

        Route::post('/customer_toggle_active/{id}', "Sales\CustomerController@toggle_active");
        Route::post('/toggle_customer_prices', "Sales\CustomerController@toggle_customer_prices");
        Route::post('/toggle_customer_transport_prices', "Sales\CustomerController@toggle_customer_transport_prices");
        Route::post('/toggle_customer_warehouse_prices', "Sales\CustomerController@toggle_customer_warehouse_prices");
        Route::post('/upload_file_customer/{id}', "Sales\CustomerController@upload_file");
        Route::get('/download_file_customer/{id}', "Sales\CustomerController@download_file");
        Route::delete('/delete_file_customer/{id}', "Sales\CustomerController@delete_file");
        Route::get('/check_customer_name', "Sales\CustomerController@check_customer_name");
        Route::get('/get_customer_contacts/{id}', "Sales\CustomerController@get_customer_contacts");

        Route::resource('/customer_trans_prices', "Sales\CustomerPricesController");
        Route::post('/update_customer_trans_prices', "Sales\CustomerPricesController@update_customer_prices");


        Route::resource('/customer_warehouse_prices', "Sales\CustomerWarehousePricesController");
        Route::post('/update_customer_warehouse_prices', "Sales\CustomerWarehousePricesController@update_customer_warehouse_prices");


        Route::resource('/revenue', "Sales\RevenueController");
        Route::post('/revenue_toggle_active/{id}', "Sales\RevenueController@toggle_active");


        Route::resource('/clearance_file_name', "Sales\AttachmentNameController");
        Route::post('/clearance_file_name_toggle_active/{id}', "Sales\AttachmentNameController@toggle_active");


        Route::resource('/clearance', "Sales\ClearanceController");
        Route::post('/clearance_toggle_active/{id}', "Sales\ClearanceController@toggle_active");
        Route::post('/clearance_add_file/{id}', "Sales\ClearanceController@add_file");
        Route::get('/clearance_download_file/{id}', "Sales\ClearanceController@download_file");
        Route::get('/clearance_download_all_file/{id}', "Sales\ClearanceController@download_all_files");

        Route::post('/upload_reimburses_expenses_attach/{id}', "Sales\ClearanceController@upload_reimburses_expenses_attach");

        Route::delete('/clearance_delete_file/{id}', "Sales\ClearanceController@delete_file");
        Route::post('/update_status/{id}', "Sales\ClearanceController@update_status");
        Route::get('/clearance_full_index', "Sales\ClearanceController@full_index");
        Route::get('/check_clearance_container', "Sales\ClearanceController@check_clearance_container");
        Route::get('/check_clearance_saber_no', "Sales\ClearanceController@check_clearance_saber_no");
        Route::get('/check_clearance_shipping_policy_no', "Sales\ClearanceController@check_clearance_shipping_policy_no");
        Route::get('/holding_container', "Sales\ClearanceController@holding_container_get");
        Route::post('/holding_container/{id}', "Sales\ClearanceController@update_holding_container");

        Route::post('/update_container_return_file/{id}', "Sales\ClearanceController@update_container_return_file");


        Route::get('/clearance_get_comment/{id}', "Sales\ClearanceController@clearance_get_comment");
        Route::post('/export_clearance/{id}', "Sales\ClearanceController@update_status");
        Route::get('/get_clearance_customs_declaration/{id}', "Sales\ClearanceController@get_clearance_customs_declaration");
        Route::get('/get_clearance_problem_comment/{id}', "Sales\ClearanceController@get_problem_comment");
        Route::get('/download_clearance_customs_declaration/{id}', "Sales\ClearanceController@download_clearance_customs_declaration");
        Route::get('/download_final_note_file/{id}', "Sales\ClearanceController@download_final_note_file");

        Route::get('/clearance_transaction_report', "Sales\ReportController@clearance_transaction_report");


        Route::get('/finished_clearances_report', "Sales\ReportController@finished_clearances_report_get");
        Route::post('/finished_clearances_report', "Sales\ReportController@finished_clearances_report_post");

        Route::post('/update_clearance_arrival/{id}', "Sales\ClearanceController@update_clearance_arrival");
        Route::post('/update_clearance_customs_declaration/{id}', "Sales\ClearanceController@update_clearance_customs_declaration");
        Route::post('/update_preview_done/{id}', "Sales\ClearanceController@update_preview_done");
        Route::post('/update_clearance_paymant/{id}', "Sales\ClearanceController@update_clearance_paymant");
        Route::post('/update_completed/{id}', "Sales\ClearanceController@update_completed");

        Route::post('/update_clearance_withdrawal_note/{id}', "Sales\ClearanceController@update_clearance_withdrawal_note");
        Route::post('/update_clearance_withdrawal_port/{id}', "Sales\ClearanceController@update_clearance_withdrawal_port");
        Route::post('/update_clearance_inspection_number/{id}', "Sales\ClearanceController@update_clearance_inspection_number");
        Route::post('/clearance_transport_fees', "Sales\ClearanceController@clearance_transport_fees");
        Route::post('/clearance_add_comment/{id}', "Sales\ClearanceController@add_comment");
        Route::post('/clearance_toggle_has_problem/{id}', "Sales\ClearanceController@clearance_toggle_has_problem");
        Route::post('/update_clearance_item/{id}', "Sales\ClearanceController@update_clearance_item");
        Route::get('/get_clearance_attachment/{id}', "Sales\ClearanceController@get_clearance_attachment");

        Route::resource('/insurance', "Sales\InsuranceController");
        Route::post('/insurance_toggle_active/{id}', "Sales\InsuranceController@toggle_active");

        Route::get('/clearance_d_insurance', "Sales\InsuranceController@clearance_d_insurances_get");
        Route::post('/clearance_d_insurance/{id}', "Sales\InsuranceController@clearance_d_insurances_post");
        Route::post('/update_clearance_d_insurances/{id}', "Sales\InsuranceController@update_clearance_d_insurances");

        Route::post('/send_return_file/{id}', "Sales\InsuranceController@send_return_file");

        Route::post('/update_all_completed_insurances', "Sales\InsuranceController@update_all_completed_insurances");
        Route::get('/print_clearance_invoices', "Sales\InvoiceController@print_invoices");




        Route::resource('/clearance_invoice', "Sales\InvoiceController");

        Route::get('/get_invoice_deleget_data', "Sales\InvoiceController@get_invoice_deleget_data");
        Route::get('/get_invoice_attachment/{clearance_id}', "Sales\InvoiceController@get_invoice_attachment");
        Route::get('/download_attachment/{attachment_id}', "Sales\InvoiceController@download_attachment");
        Route::post('/send_clearance_invoice/{clearance_invoice_id}', "Sales\InvoiceController@send_clearance_invoice");
        Route::post('/update_invoice_journals/{clearance_invoice_id}', "Sales\InvoiceController@update_invoice_journals");
        Route::post('/send_clearance_invoice_whats/{clearance_invoice_id}', "Sales\InvoiceController@send_clearance_invoice_whats");
        Route::post('/upload_invoice_attach/{id}', "Sales\InvoiceController@upload_attachment");
        Route::delete('/delete_invoice_attach/{id}', "Sales\InvoiceController@delete_attachment");

        Route::get('/download_invoice_attachments/{id}', "Sales\InvoiceController@download_all_attachments");


        // Invoice Draft
        Route::resource('/clearance_draft', "Sales\DraftController");
        Route::post('/convert_draft_to_invoice/{id}', "Sales\DraftController@convert_draft_to_invoice");
        Route::get('/get_invoice_amounts/{id}', "Sales\DraftController@get_invoice_amounts");
        Route::get('/print_drafts_invoices', "Sales\DraftController@print_invoices");
        Route::post('/send_clearance_draft/{clearance_draft_id}', "Sales\DraftController@send_clearance_invoice");


        // Invoice Claim
        Route::resource('/clearance_claim', "Sales\ClaimController");
        Route::post('/send_clearance_claim/{clearance_claim_id}', "Sales\ClaimController@send_clearance_invoice");
        Route::post('/upload_claim_attach/{id}', "Sales\ClaimController@upload_attachment");
        Route::get('/print_claim_invoices', "Sales\ClaimController@print_invoices");

        Route::resource('/invoices_need_update', "Sales\UpdateInvoiceController");




        Route::resource('/customer_claim', "Sales\CustomerClaimController");

        Route::resource('/item', "Sales\ItemController");
        Route::post('/item_toggle_active/{id}', "Sales\ItemController@toggle_active");

        Route::resource('/unit', "Sales\UnitController");
        Route::post('/unit_toggle_active/{id}', "Sales\UnitController@toggle_active");

        Route::resource('/customs_item', "Sales\CustomsItemController");
        Route::post('/customs_item_toggle_active/{id}', "Sales\CustomsItemController@toggle_active");


        Route::resource('/classification', "Sales\ClassificationController");
        Route::get('/classification_get_comment/{id}', "Sales\ClassificationController@get_comments");
        Route::post('/classification_add_comment/{id}', "Sales\ClassificationController@add_comment");
        Route::post('/update_classification_customs/{id}', "Sales\ClassificationController@update_customs");
        Route::put('/update_translation_of_classification/{id}', "Sales\ClassificationController@update_translation_of_classification");
        Route::post('/upload_classification/{id}', "Sales\ClassificationController@upload_classification");
        Route::get('/get_clearance_data/{id}', "Sales\ClassificationController@get_clearance_data");
        Route::any('/export_classification/{id}', "Sales\ClassificationController@export_classification");
        Route::any('/import_classification/{id}', "Sales\ClassificationController@import_classification");
        Route::get('/classification_search', "Sales\ClassificationController@classification_search");
        Route::post('/lock_clearance_toggle/{id}', "Sales\ClassificationController@lock_clearance");
        Route::get('/temp_classifications', "Sales\ClassificationController@temp_classifications");
        Route::post('/add_temp_classification', "Sales\ClassificationController@add_temp_classification");
        Route::delete('/delete_temp_classification/{id}', "Sales\ClassificationController@delete_temp_classification");


        Route::get('/customers_statement' , "Finance\ReportController@customer_balances_report_get");
        Route::post('/customers_statement' , "Finance\ReportController@customer_balances_report_post");

        Route::get('/revenue_analysis' , "Finance\ReportController@revenue_analysis");
        Route::post('/revenue_analysis' , "Finance\ReportController@revenue_analysis");

        Route::get('/customer_revenue' , "Finance\ReportController@customer_revenue");
        Route::post('/customer_revenue' , "Finance\ReportController@customer_revenue");

        Route::get('/reimburses_expenses_report' , "Sales\ReportController@reimburses_expenses_report_get");
        Route::post('/reimburses_expenses_report' , "Sales\ReportController@reimburses_expenses_report_post");

        Route::get('/completed_insurance' , "Sales\ReportController@completed_insurance_get");
        Route::post('/completed_insurance' , "Sales\ReportController@completed_insurance_post");

        Route::get('/notcompleted_insurance' , "Sales\ReportController@notcompleted_insurance_get");
        Route::post('/notcompleted_insurance' , "Sales\ReportController@notcompleted_insurance_post");

        Route::get('/clearance_report' , "Sales\ReportController@clearance_report_get");
        Route::post('/clearance_report' , "Sales\ReportController@clearance_report_post");

        Route::get('/returned_clearances_report' , "Sales\ReportController@returned_clearances_report_get");
        Route::post('/returned_clearances_report' , "Sales\ReportController@returned_clearances_report_post");

        Route::get('/clearances_delegate_report' , "Sales\ReportController@clearances_delegate_report_get");
        Route::post('/clearances_delegate_report' , "Sales\ReportController@clearances_delegate_report_post");

        Route::get('/clearance_invoices_report' , "Sales\ReportController@invoices_report_get");
        Route::post('/clearance_invoices_report' , "Sales\ReportController@invoices_report_post");

        Route::get('/container_status_report' , "Sales\ReportController@container_status_report_get");
        Route::post('/container_status_report' , "Sales\ReportController@container_status_report_post");

        Route::get('/group_account_statment_anal_report' , "Finance\ReportController@group_account_statment_anal_report_get");
        Route::post('/group_account_statment_anal_report' , "Finance\ReportController@group_account_statment_anal_report_post");

        Route::get('/custom_codes_report' , "Sales\ReportController@custom_codes_report_get");
        Route::post('/custom_codes_report' , "Sales\ReportController@custom_codes_report_post");

        Route::resource('/notice_debtor', "Sales\NoticeDebtorController");
        Route::resource('/notice_creditor', "Sales\NoticeCreditorController");

        // Trans

        // Route::resource('/customer', "Trans\CustomerController");
        // Route::post('/customer_sort', "Trans\CustomerController@sort_post");
        // Route::post('/customer_toggle_active/{id}', "Trans\CustomerController@toggle_active");

        Route::get('/available_containers', "Trans\TripController@available_containers");
        Route::post('/update_available_container', "Trans\TripController@update_available_container");

        Route::post('/update_unloading_ship_date/{id}', "Trans\TripController@update_unloading_ship_date");

        Route::resource('/car', "Trans\CarController");
        Route::post('/car_sort', "Trans\CarController@sort_post");
        Route::post('/car_toggle_active/{id}', "Trans\CarController@toggle_active");

        Route::resource('/driver', "Trans\DriverController");
        Route::post('/driver_sort', "Trans\DriverController@sort_post");
        Route::post('/driver_toggle_active/{id}', "Trans\DriverController@toggle_active");

        Route::resource('/driver_card', "Trans\DriverCardController");
        Route::post('/driver_card_sort', "Trans\DriverCardController@sort_post");
        Route::post('/driver_card_toggle_active/{id}', "Trans\DriverCardController@toggle_active");

        Route::resource('/area', "Trans\AreaController");
        Route::post('/area_sort', "Trans\AreaController@sort_post");
        Route::post('/area_toggle_active/{id}', "Trans\AreaController@toggle_active");

        Route::resource('/wearhouse', "Trans\WearhouseController");
        Route::post('/wearhouse_sort', "Trans\WearhouseController@sort_post");
        Route::post('/wearhouse_toggle_active/{id}', "Trans\WearhouseController@toggle_active");

        Route::resource('/port', "Trans\PortController");
        Route::post('/port_sort', "Trans\PortController@sort_post");
        Route::post('/port_toggle_active/{id}', "Trans\PortController@toggle_active");

        Route::resource('/area_price', "Trans\AreaPriceController");
        Route::post('/area_price_sort', "Trans\AreaPriceController@sort_post");
        Route::post('/area_price_toggle_active/{id}', "Trans\AreaPriceController@toggle_active");

        Route::resource('/trip', "Trans\TripController");
        Route::get('/get_area_prices', "Trans\TripController@get_area_prices");

        Route::post('/print_trip', "Trans\TripController@print");
        Route::post('/trip_sort', "Trans\TripController@sort_post");
        Route::post('/trip_toggle_active/{id}', "Trans\TripController@toggle_active");
        Route::get('/check_clearance_trip', "Trans\TripController@check_clearance_trip");
        Route::post('/trip_update_customized/{id}', "Trans\TripController@trip_update_customized");

        Route::resource('/wearhouse_transaction', "Trans\WearhouseTransactionController");
        Route::post('/wearhouse_transaction_sort', "Trans\WearhouseTransactionController@sort_post");
        Route::post('/wearhouse_transaction_toggle_active/{id}', "Trans\WearhouseTransactionController@toggle_active");
        Route::post('/trip_change', "Trans\WearhouseTransactionController@trip_change");

        Route::resource('/invoice', "Trans\InvoiceController");
        Route::post('/invoice_toggle_active/{id}', "Trans\InvoiceController@toggle_active");

        Route::resource('/trans_invoice', "Trans\TransInvoiceController");

        Route::resource('/container', "Trans\ContainerDamageController");
        Route::post('/container_toggle_active/{id}', "Trans\ContainerDamageController@toggle_active");

        Route::resource('/agent', "Trans\AgentController");
        Route::post('/agent_toggle_active/{id}', "Trans\AgentController@toggle_active");

        //reports

        Route::get('/customer_prices_report', "ReportController@customer_prices_report_get");
        Route::post('/customer_prices_report', "ReportController@customer_prices_report_post");

        Route::resource('/reporting', "ReportingController");
        Route::post('/reporting_toggle_active', "ReportingController@toggle_active");

        Route::get('/driver_report', "ReportController@driver_report_get");
        Route::post('/driver_report', "ReportController@driver_report_post");

        Route::get('/warehouse_report', "ReportController@warehouse_report_get");
        Route::post('/warehouse_report', "ReportController@warehouse_report_post");

        Route::get('/transport_report', "ReportController@transport_report_get");
        Route::post('/transport_report', "ReportController@transport_report_post");

        Route::get('/maintenance_report', "ReportController@maintenance_report_get");
        Route::post('/maintenance_report', "ReportController@maintenance_report_post");

        Route::get('/car_movements_report', "ReportController@car_movements_report_get");
        Route::post('/car_movements_report', "ReportController@car_movements_report_post");

        Route::get('/car_income_report', "ReportController@car_income_report_get");
        Route::post('/car_income_report', "ReportController@car_income_report_post");

        Route::get('/driver_income_report', "ReportController@driver_income_report_get");
        Route::post('/driver_income_report', "ReportController@driver_income_report_post");


        Route::get('/container_report', "ReportController@container_report_get");
        Route::post('/container_report', "ReportController@container_report_post");

        Route::get('/trips_containers_report', "ReportController@trips_containers_report_get");
        Route::post('/trips_containers_report', "ReportController@trips_containers_report_post");

        Route::get('/trip_expenses_report', "ReportController@trip_expenses_reports_get");
        Route::post('/trip_expenses_report', "ReportController@trip_expenses_reports_post");


        Route::post('/export_trip/{id}', "PrintController@export_trip");
        Route::post('/export_invoice/{id}', "PrintController@export_invoice");
        Route::post('/export_store_in/{id}', "PrintController@export_store_in");
        Route::post('/export_store_out/{id}', "PrintController@export_store_out");


        Route::get('/get_gregorian_data/{date}',"GeneralController@get_gregorian_data");
        Route::get('/get_hijri_data/{date}',"GeneralController@get_hijri_data");

        Route::get('/get_logs',"LogsController@index");

    });

});
