<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Print</title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style type="text/css">
    	<?php if($data['lang'] == 'ar'): ?>
    		* {
    			direction: rtl;
    		}

    		.item_a{
		    	border-left: 0px;
		    	border-bottom: 0px;
		    }
		    .item_b{
		    	border-right: 0px;
		    	border-bottom: 0px;
		    }
		    .item_c{
		    	border-top: 0px;
		    }


    	<?php else: ?>
    		.item_a{
		    	border-right: 0px;
		    	border-bottom: 0px;
		    }
		    .item_b{
		    	border-left: 0px;
		    	border-bottom: 0px;
		    }
		    .item_c{
		    	border-top: 0px;
		    }

    	<?php endif; ?>
    	page_break { page-break-before: always; }
	    *{
	        font-family: 'dejavu sans', sans-serif;
	    }
		.main_div{
			height: auto;
			margin: 0 auto;
			border: 1px solid #000;
			padding: 10px;
			position: relative;
		}
		.logo_cont{
			max-height: 80px;
			text-align: center;
		}
		thead{
			background-color: rgb(237 , 235, 235);
		}
	    table{
	    	width: 100%;
	        border-spacing: 0;
   			border-collapse: collapse;
   			 -webkit-box-sizing: border-box;
			   -moz-box-sizing: border-box;
			        box-sizing: border-box;
   			margin-bottom: 10px;
   			border: 1px solid #ddd;
	    }
	    th , td{
	    	text-align: center;
		    border: 1px solid #ddd;
			padding:5px;
	    }
	    td{
	    	font-size: 14px;
	    }
	    th{
	    	font-size: 16px;
	    }
	    .title{
	    	text-align: left;
	    	font-weight: 900;
	    }
	    .no_align{
	    	text-align: right;
	    }
	    .no_border{
	    	border:0px;
	    }


	</style>
</head>
<body>
	<div class="main_div" style="">
		<table  class="table " style="border: 0px">
			<tr>
				<td  class="no_border" style="width: 25%">
					<?php echo $data['print_right'] ?? ''; ?>

				</td>
				<td  class="no_border" style="width: 50%">
					<div class="logo_cont ">
						<img src="<?php echo e(url($data['logo'])); ?>" class="img-responsive" height="75" alt="Image" style="">
					</div style="">
					<div style="font-size: 24px; font-weight: bold;">
						<?php echo e($data['print_title'] ?? ''); ?>

					</div>
				</td>
				<td  class="no_border" style="width: 25%">
					<?php echo $data['print_left'] ?? ''; ?>

				</td>
			</tr>
		</table>
		<?php echo $__env->yieldContent('content'); ?>



	</div>

	<?php echo $__env->yieldContent('script'); ?>
    <?php if(!isset($skipScript)): ?>
    		<?php if(isset($_GET['type']) && $_GET['type'] == 'print'): ?>
    			<script type="text/javascript">
                    window.print();
    				window.onfocus=function(){ window.close();}
    			</script>
    		<?php endif; ?>
    <?php endif; ?>
</body>

</html>
<?php /**PATH /home/cstesting/public_html/customs/api/resources/views/Layouts/general.blade.php ENDPATH**/ ?>